
//=========================================================================
//
//	Code pour le hud et la slection des Force Powers du Jedi
//
//	Il va rcuprer les Commandes du clavier pour les touches  partir de 6
//
//
//
//==========================================================================


#include "hud.h"
#include "cl_util.h"
#include "parsemsg.h"

#include <string.h>
#include <stdio.h>
#include <stdarg.h>




#include "ammohistory.h"

void ForceAlert( char *szFmt, ... );



FORCE *fpActiveSel;	// NULL signifie off, 1 signifie seulement la barre de menu, 
						// sinon c'est un pointeur vers l'objet actif du menu Force
FORCE *fpLastSel;		// Dernire slection du menu Force

// rcupre la sprite dans la liste
client_sprite_t *GetForceSprite(client_sprite_t *pList, const char *psz, int iRes, int iCount);

ForceResource gFR;

int g_forceselect = 0;

//chargement des sprites
void ForceResource :: LoadAllForceSprites( void )
{
	for (int i = 0; i < MAX_WEAPONS; i++)
	{
		if ( rgForces[i].iId )
			LoadForceSprites( &rgForces[i] );
	}
}

void ForceResource :: LoadForceSprites( FORCE *pForce )
{
	int i, iRes;

	if (ScreenWidth < 640)
		iRes = 320;
	else
		iRes = 640;

	char sz[128];

	if ( !pForce )
		return;

	memset( &pForce->rcActive, 0, sizeof(wrect_t) );
	memset( &pForce->rcInactive, 0, sizeof(wrect_t) );

	pForce->hInactive = 0;
	pForce->hActive = 0;
	
	// recherche du fichier de liste de sprites de la force, comme pour les armes
	// szName est le nom du fichier
	// il faudra donc crer un fichier texte de liste de sprites pour chaque force
	// szName est transmis par le serveur au moyen du message lors de la prise de la force
	// ce mme nom sert de commande pour le dclenchement de la force
	// attention  bien respecter les noms choisis :

	// force_speed , force_jump , force_see , force_throw , force_traction , force_heal

	sprintf(sz, "sprites/%s.txt", pForce->szName);
	client_sprite_t *pList = SPR_GetList(sz, &i);

	if (!pList)
		return;

	// on charge les deux sprites de la force, la sprite sombre "force" de la liste : (hInactive)
	// et la sprite brillante "force_s" de la liste : (hActive)
	client_sprite_t *p;


	p = GetForceSprite(pList, "force", iRes, i);
	if (p)
	{
		sprintf(sz, "sprites/%s.spr", p->szSprite);
		pForce->hInactive = SPR_Load(sz);
		pForce->rcInactive = p->rc;

		//gHR.iHistoryGap = max( gHR.iHistoryGap, pForce->rcActive.bottom - pForce->rcActive.top );
	}
	else
		pForce->hInactive = 0;

	p = GetForceSprite(pList, "force_s", iRes, i);
	if (p)
	{
		sprintf(sz, "sprites/%s.spr", p->szSprite);
		pForce->hActive = SPR_Load(sz);
		pForce->rcActive = p->rc;
	}
	else
		pForce->hActive = 0;

}


// Retourne la premire force d'un slot donn.
FORCE *ForceResource :: GetFirstPos( int iSlot )
{
	FORCE *pret = NULL;
	
	// Parcourre toutes les positions du slot : 5 positions disponibles
	// Attention au bug!!! l'array rgSlots doit pouvoir stocker 10 slots car les slots sont indexs
	// selon leur numro et pas par leur nombre
	for (int i = 0; i < MAX_WEAPON_POSITIONS; i++)
	{
		if ( rgSlots[iSlot][i] )
		{
			pret = rgSlots[iSlot][i];
			break;
		}
	}

	return pret;
}


FORCE* ForceResource :: GetNextActivePos( int iSlot, int iSlotPos )
{
	if ( iSlotPos >= MAX_WEAPON_POSITIONS || iSlot >= MAX_WEAPON_SLOTS )
		return NULL;

	FORCE *p = gFR.rgSlots[ iSlot ][ iSlotPos+1 ];
	
	if ( !p )
		return GetNextActivePos( iSlot, iSlotPos + 1 );

	return p;
}



int giBoiteHeight, giBoiteWidth, giFBHeight, giFBWidth; // Force Bar width et height

HSPRITE ghsprBoites;					// Sprite pour le rang suprieur du menu Forces

DECLARE_MESSAGE(m_Force, CurForce );	
DECLARE_MESSAGE(m_Force, ForceList);
DECLARE_MESSAGE(m_Force, Mana);	// nergie renouvelable pour la Force


DECLARE_COMMAND(m_Force, Slot6);
DECLARE_COMMAND(m_Force, Slot7);
DECLARE_COMMAND(m_Force, Slot8);
DECLARE_COMMAND(m_Force, Slot9);
DECLARE_COMMAND(m_Force, Slot10);

DECLARE_COMMAND(m_Force, ForceClose);

DECLARE_COMMAND(m_Force, ForceStop);

DECLARE_COMMAND(m_Force, ForceStart);

//commandes pour le volume de la musique MP3 places ici pour simplifier 

DECLARE_COMMAND(m_Force, VolDown);	//baisse le son
DECLARE_COMMAND(m_Force, VolUp);	//monte le son

int CHudForce::Init(void)
{
	gHUD.AddHudElem(this);

	HOOK_MESSAGE(CurForce);
	HOOK_MESSAGE(ForceList);
	HOOK_MESSAGE(Mana);

	
	HOOK_COMMAND("slot6", Slot6);
	HOOK_COMMAND("slot7", Slot7);
	HOOK_COMMAND("slot8", Slot8);
	HOOK_COMMAND("slot9", Slot9);
	HOOK_COMMAND("slot10", Slot10);
	HOOK_COMMAND("cancelforce", ForceClose);
	HOOK_COMMAND("stopforce", ForceStop);
	HOOK_COMMAND("startforce", ForceStart);

	HOOK_COMMAND("voldown", VolDown);
	HOOK_COMMAND("volup", VolUp);

	Reset();

	m_iFlags |= HUD_ACTIVE; //!!!

	gFR.Init();

	return 1;
};

void CHudForce::Reset(void)
{
	m_fFade = 0;
	m_iFlags |= HUD_ACTIVE; //!!!

	fpActiveSel = NULL;

	gHUD.m_iHideHUDDisplay = 0;


	gFR.Reset();

}

int CHudForce::VidInit(void)
{
	// on charge les sprites standard de la liste hud.txt
	m_HUD_boite0 = gHUD.GetSpriteIndex( "bucket1" );	//la sprite bucket1 fait 20 x 20
	//m_HUD_select = gHUD.GetSpriteIndex( "selection" );	//la sprite selection fait 170 x 45

	ghsprBoites = gHUD.GetSprite(m_HUD_boite0);
	giBoiteWidth = gHUD.GetSpriteRect(m_HUD_boite0).right - gHUD.GetSpriteRect(m_HUD_boite0).left;
	giBoiteHeight = gHUD.GetSpriteRect(m_HUD_boite0).bottom - gHUD.GetSpriteRect(m_HUD_boite0).top;

	//gHR.iHistoryGap = max( gHR.iHistoryGap, gHUD.GetSpriteRect(m_HUD_boite0).bottom - gHUD.GetSpriteRect(m_HUD_boite0).top);

	// Si on a dj charg les forces on va charger les sprites
	gFR.LoadAllForceSprites();

	if (ScreenWidth >= 640)
	{
		giFBWidth = 20;
		giFBHeight = 4;
	}
	else
	{
		giFBWidth = 10;
		giFBHeight = 2;
	}

	return 1;
}


void CHudForce ::Think(void)
{
	
	if ( gHUD.m_fPlayerDead )
		return;


	int forwSpeed = CVAR_GET_FLOAT("cl_forwardspeed");
	
	//ForceAlert("ForwardSpeed %d\n", forwSpeed);

	//SetForceSpeed();

	

	// m_iForceBits n'est pas mis  jour comme m_iWeaponBits l'est dans hud_update.cpp
	// par l'intermdiaire de int CHud::UpdateClientData(client_data_t *cdata, float time)

	// cette condition qui suit  n'est utilis que si les force ne sont pas acquises ds le dpart
	// et peuvent tre acquise au cours du jeu ou supprime 
	// a met  jour les forces disponibles

	if ( gHUD.m_iForceBits != gFR.iOldForceBits )
	{
		//ForceAlert("ForceBits %d\n", gHUD.m_iForceBits);

		gFR.iOldForceBits = gHUD.m_iForceBits;

		for (int i = MAX_WEAPONS-1; i > 0; i-- )
		{
			FORCE *p = gFR.GetForce(i);

			if ( p )
			{	
				if( p->iId == 2 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
				else if( p->iId == 3 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
				else if( p->iId == 4 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
				else if( p->iId == 5 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
				else if( p->iId == 6 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
				else if( p->iId == 7 )
				{
					//ForceAlert("PickupForce\n");

					gFR.PickupForce( p );
				}
			}
		}
	}

	if (!fpActiveSel)
		return;

	if (fpActiveSel != (FORCE *)1)
	{
		LastForce = fpActiveSel;
	}

	//SUPPRIME  cause des risques de confusion de touche, la force risque d'tre dclenche involontairement

/*	// le joueur en a t il slectionn une, la touche utiliser est celle qui active la force
	if (gHUD.m_iKeyBits & IN_USE)
	{
		if (fpActiveSel != (FORCE *)1)
		{
			//ForceAlert("USE FORCE %s\n", fpActiveSel->szName);
			
			ClientCmd(fpActiveSel->szName);
			g_forceselect = fpActiveSel->iId;
		}

		fpLastSel = fpActiveSel;
		fpActiveSel = NULL;
		gHUD.m_iKeyBits &= ~IN_USE;

		//PlaySound("common/force_select.wav", 0.8);
	}
*/
}


// Selection du menu

void ForceResource :: SelectSlot( int iSlot, int fAdvance, int iDirection )
{
	

	if ( gHUD.m_Menu.m_fMenuDisplayed && (fAdvance == FALSE) && (iDirection == 1) )	
	{ // le menu passe avant les commandes de slots
		gHUD.m_Menu.SelectMenuItem( iSlot + 1 );  // les slots sont dcals d'une unit par rapport aux touches 
		return;
	}

	if ( iSlot >  MAX_WEAPON_SLOTS  ) //les forces utilisent les iSlots 0  4
		return;

	// si les huds ne doivent pas tre affichs
	if ( gHUD.m_fPlayerDead || gHUD.m_iHideHUDDisplay & ( HIDEHUD_WEAPONS | HIDEHUD_ALL ) )
		return;

	if (!(gHUD.m_iWeaponBits & (1<<(WEAPON_SUIT)) ))//pas de slection sans combinaison
		return;

	if ( ! ( gHUD.m_iWeaponBits & ~(1<<(WEAPON_SUIT)) ))
		return;

	FORCE *p = NULL;
	

	//si pas encore de slection ou seulement la barre ou pas le mme slot:

	if ( (fpActiveSel == NULL) || (fpActiveSel == (FORCE *)1) || (iSlot != fpActiveSel->iSlot) )
	{
		PlaySound( "common/force_hudon.wav", 0.7 );
		p = GetFirstPos( iSlot );
		
	}
	else // on passe  la position suivante du slot
	{
		PlaySound("common/force_moveselect.wav", 0.7);
		if ( fpActiveSel )
			p = GetNextActivePos( fpActiveSel->iSlot, fpActiveSel->iSlotPos );
		if ( !p )
			p = GetFirstPos( iSlot );
	}
/*
 */	
	if ( !p )  // pas de slection trouve
	{
		// on affiche seulement la liste des forces (barre).
		
		fpActiveSel = (FORCE *)1;
		
	}
	else 
	{
		fpActiveSel = p;
	}

/*	if( p && fpActiveSel != (FORCE *)1)
	{
		ForceAlert("ACTIVE ID %d SlOT %d POS %d\n", p->iId, p->iSlot, p->iSlotPos);
	}
 */
}




//fonctions de messages

int CHudForce::MsgFunc_CurForce(const char *pszName, int iSize, void *pbuf)
{
	BEGIN_READ( pbuf, iSize );

	int iState = READ_BYTE();	// tat actuel
	int iId = READ_CHAR();		// identification
	int speed = READ_SHORT();	// valeur ventuelle (vitesse pour Force Speed)

	if (iId == -1)
	{
		fpActiveSel = NULL;
		return 1;
	}

	if ( iId == 2 )//force speed
	{

		m_iSpeed = speed;

		SetForceSpeed();
		//ForceAlert("ForwardSpeed %d\n", m_iSpeed);
	
	}


	FORCE *pForce = gFR.GetForce( iId );

	if ( !pForce )
		return 0;

	m_pForce = pForce;

	m_fFade = 200.0f; //!!!
	m_iFlags |= HUD_ACTIVE;

	return 1;
}
	
int CHudForce::MsgFunc_ForceList(const char *pszName, int iSize, void *pbuf)
{
	BEGIN_READ( pbuf, iSize );
	
	FORCE Force;

	strcpy( Force.szName, READ_STRING() );	// nom de la force

	Force.iSlot = READ_CHAR();		// slot
	Force.iSlotPos = READ_CHAR();	// position dans le slot
	Force.iId = READ_CHAR();		// identification
	Force.iFlags = READ_BYTE();		// flags

	//ajoute le numro d'identit pour que les forces soient misent  jour dans Think()
	gHUD.m_iForceBits = gHUD.m_iForceBits + Force.iId;
	
	gFR.AddForce( &Force );
	

	//ForceAlert("FORCE %s iSlot %d iSlotPos %d iId %d\n", Force.szName, Force.iSlot, Force.iSlotPos, Force.iId);
	
	//reoit pour force_speed : iSlot = 0  iSlotPos = 1 iId = 2

	return 1;
}

int CHudForce::MsgFunc_Mana(const char *pszName, int iSize, void *pbuf)
{
	BEGIN_READ( pbuf, iSize );

	m_iMana = READ_BYTE();

	//ajouter le code pour mettre  jour la barre d'tat de Mana du hud
	
	return 1;
}


//fonctions de commandes

void CHudForce ::SlotInput(int iSlot)
{
	
	gFR.SelectSlot(iSlot, FALSE, 1);
}



void CHudForce::UserCmd_Slot6(void)
{
	SlotInput( 0 );
}

void CHudForce::UserCmd_Slot7(void)
{
	SlotInput( 1 );
}

void CHudForce::UserCmd_Slot8(void)
{
	SlotInput( 2 );
}

void CHudForce::UserCmd_Slot9(void)
{
	SlotInput( 3 );
}

void CHudForce::UserCmd_Slot10(void)
{
	SlotInput( 4 );
}



void CHudForce::UserCmd_ForceClose(void)
{
	
	if (fpActiveSel)
	{
		LastForce = fpActiveSel;
		fpLastSel = fpActiveSel;
		fpActiveSel = NULL;
		PlaySound("common/force_hudoff.wav", 0.7);
	}
  
}

void CHudForce ::UserCmd_ForceStop(void)
{
	ClientCmd("forceoff");
	//ForceAlert("ForceStop\n");
}

void CHudForce ::UserCmd_ForceStart(void)
{
	if (LastForce != (FORCE *)1)
	{
		ClientCmd(LastForce->szName);
	}
	
}

//commandes du volume de la musique mp3

void CHudForce ::UserCmd_VolDown(void)
{
	ClientCmd("volbas");
}


void CHudForce ::UserCmd_VolUp(void)
{
	ClientCmd("volhaut");
}


//-------------------------------------------------------------------------
// Drawing code : dessin de l'tat des slots des Forces
//-------------------------------------------------------------------------


int CHudForce ::Draw(float flTime)
{
	

	if (!(gHUD.m_iWeaponBits & (1<<(WEAPON_SUIT)) )) // pas de hud si pas de combinaison
		return 1;

	if ( (gHUD.m_iHideHUDDisplay & ( HIDEHUD_WEAPONS | HIDEHUD_ALL )) )
		return 1;

	// Draw Force Menu
	DrawWList(flTime);  //dessine les slots des Forces

	ManaBar();

	if (!(m_iFlags & HUD_ACTIVE))
		return 0;

	if (!m_pForce)
		return 0;


	// ajouter le code pour dessiner la barre de Mana
	
	return 1;
}


//=====================================
// Dessin du menu de choix des Forces
//=====================================

int CHudForce ::DrawWList(float flTime)
{

	int r,g,b,x,y,a,i;

	if ( !fpActiveSel )
		return 0;

	int iActiveSlot;

	if ( fpActiveSel == (FORCE *)1 )
		iActiveSlot = -1;	// le slot courant n'a pas de Forces
	else 
		iActiveSlot = fpActiveSel->iSlot;

	x = 10; //!!!
	y = 140; //!!! //les armes commencent  10 et les forces un peu en dessous
	

	// on s'assure qu'il y a des choix disponibles dans le slot actif
	if ( iActiveSlot > 0 )
	{
		if ( !gFR.GetFirstPos( iActiveSlot ) )
		{
			fpActiveSel = (FORCE *)1;
			iActiveSlot = -1;
		}
	}
		
	// On dessine la premire ligne des slots, (les carrs avec le numro de slot en bas  droite)
	for ( i = 0; i < MAX_WEAPON_SLOTS; i++ )
	{
		int iWidth;

		UnpackRGB(r,g,b, RGB_YELLOWISH);
	
		if ( iActiveSlot == i )
			a = 255; //intensit
		else
			a = 192;

		ScaleColors(r, g, b, 255);
		SPR_Set(gHUD.GetSprite(m_HUD_boite0 + i), r, g, b );

		// on rend les slots actifs assez larges pour les images des Forces
		if ( i == iActiveSlot )
		{
			FORCE *f = gFR.GetFirstPos(iActiveSlot);
			if ( f )
				iWidth = f->rcActive.right - f->rcActive.left;
			else
				iWidth = giBoiteWidth;
		}
		else
			iWidth = giBoiteWidth;

		SPR_DrawAdditive(0, x, y, &gHUD.GetSpriteRect(m_HUD_boite0 + i));
		
		x += iWidth + 5;
	}


	a = 190; //!!!
	x = 10;

	// On dessine les colonnes de slots

	for (i = 0; i < MAX_WEAPON_SLOTS; i++)  //boucle sur les colonnes de slot
	{
		y = giBoiteHeight + 140;

		// Si c'est le slot actif, on dessine une grande image de la force
		// sinon on dessine des carrs
		if ( i == iActiveSlot )
		{
			FORCE *f = gFR.GetFirstPos( i );
			int iWidth = giBoiteWidth;
			if ( f )
				iWidth = f->rcActive.right - f->rcActive.left;

			for ( int iPos = 0; iPos < MAX_WEAPON_POSITIONS; iPos++ )
			{
				f = gFR.GetForceSlot( i, iPos );

				if ( !f || !f->iId )
					continue;

				UnpackRGB( r,g,b, RGB_YELLOWISH );
			

				if ( fpActiveSel == f )
				{
					SPR_Set(f->hActive, r, g, b );
					SPR_DrawAdditive(0, x, y, &f->rcActive);//dessin de la sprite brillante de la force (force_s)

					//SPR_Set(gHUD.GetSprite(m_HUD_select), r, g, b );
					//SPR_DrawAdditive(0, x, y, &gHUD.GetSpriteRect(m_HUD_select));//dessin de la sprite(slection : [   ])
					// les deux sprites sont dessines en superposition
				}
				else
				{
					
					ScaleColors(r, g, b, 220);

					SPR_Set( f->hInactive, r, g, b );
					SPR_DrawAdditive( 0, x, y, &f->rcInactive );//dessin de la sprite sombre de la force (force)
				}

				y += f->rcActive.bottom - f->rcActive.top + 5;
			}

			x += iWidth + 5;

		}
		else
		{
			// une colonne de slot

			UnpackRGB(r,g,b, RGB_YELLOWISH);

			for ( int iPos = 0; iPos < MAX_WEAPON_POSITIONS; iPos++ )//boucle sur les lments de la colonne
			{
				FORCE *f = gFR.GetForceSlot( i, iPos );
				
				if ( !f || !f->iId )
					continue;

				UnpackRGB(r,g,b, RGB_YELLOWISH);
				a = 190;
				

				FillRGBA( x, y, giBoiteWidth, giBoiteHeight, r, g, b, a );

				y += giBoiteHeight + 5;
			}

			x += giBoiteWidth + 5;//colonne suivante
		}
	}	

	return 1;
}


//==================================================
//dessin de la barre d'tat de Mana pour les forces
//==================================================

void CHudForce ::ManaBar(void)
{

	int r, g, b, a;

	int y = ScreenHeight; //hauteur de l'cran

	int x = ScreenWidth; //largeur de l'cran

	//milieu de l'cran moins la moiti de la barre
	int startX = ( x / 2 ) - 102;

	//hauteur du dbut de la barre
	int startY = y - 30;

	// on dessine le cadre : 1 ligne de 200 de 5 d'paisseur

	UnpackRGB(r,g,b, RGB_YELLOWISH);
	a = 150;

	FillRGBA( startX, startY, 200, 2, r, g, b, a );

	// on dessine la deuxime ligne du cadre

	FillRGBA( startX, startY + 17, 200, 2, r, g, b, a );

	// on dessine les deux lignes verticales

	FillRGBA( startX - 2, startY, 2, 19, r, g, b, a );

	FillRGBA( startX + 200, startY, 2, 19, r, g, b, a );

	// remplissage de la barre selon l'tat du Mana
	// la couleur dpend du Mana , vert si plus de 50, jaune entre 20 et 50 sinon rouge

	// on va crer deux barres, celle du mana et celle de fond

	int barreX = startX;
	int barreY = startY + 2;

	// calcul des couleurs

	int bleu = 0;
	int rouge = 0;
	int vert = 0;

	vert = m_iMana * 10;

	if ( vert > 255 )
		vert = 255;

	if ( m_iMana <= 25 )
	{
		rouge = 255;
	}
	else
	{
		rouge = 255 - (( m_iMana - 25 ) * 10);
	}
		
	if ( rouge < 0 )
		rouge = 0;

	// barre de Mana ( m_iMana de 0  100) la barre fait 200 , alors *2

	FillRGBA( barreX, barreY, (m_iMana * 2), 15, rouge, vert, bleu, a );

	// barre de fond pour complter

	a = 100; // intensit plus faible

	FillRGBA( barreX + (m_iMana * 2), barreY, (200 - (m_iMana * 2) ), 15, r, g, b, a );

}

//=====================================
//
// On va forcer l'application d'une vitesse 
// maximale plus grande pour Force Speed
//
//=====================================

void CHudForce::SetForceSpeed(void)
{

	if ( m_iSpeed < 400 )
		m_iSpeed = 400;

	char cmd[50];

	sprintf(cmd, "cl_forwardspeed %d\n", m_iSpeed);

	ClientCmd(cmd);

	sprintf(cmd, "cl_backspeed %d\n", m_iSpeed);

	ClientCmd(cmd);

	sprintf(cmd, "cl_sidespeed %d\n", m_iSpeed);

	ClientCmd(cmd);
	
}


/* =================================
	GetForceSprites 

  Trouve et retourne le nom de la sprite 
correspondante'psz' et la rsolution 'iRes'
dans la liste de sprites donne 'pList'
iCount est le nombre d'objets dans pList

================================= */
client_sprite_t *GetForceSprite(client_sprite_t *pList, const char *psz, int iRes, int iCount)
{
	if (!pList)
		return NULL;

	int i = iCount;
	client_sprite_t *p = pList;

	while(i--)
	{
		if ((!strcmp(psz, p->szName)) && (p->iRes == iRes))
			return p;
		p++;
	}

	return NULL;
}

/*
========================================================
Messages d'alerte 

Imprimer les messages d'alerte  l'cran pour forces.cpp
========================================================
*/
void ForceAlert( char *szFmt, ... )
{
	va_list		argptr;
	static char	string[1024];
	
	va_start (argptr, szFmt);
	vsprintf (string, szFmt,argptr);
	va_end (argptr);

	gEngfuncs.Con_Printf( "cl:  " );
	gEngfuncs.Con_Printf( string );
}
