/////////////////////////////////////////////////////////////////////////////
//
// Prise en charge des sons au format MP3
//
// Prise en charge tridimensionnelle des sons 
//
// Ce code va utiliser la DLL fmod pour jouer ces sons
//
// Par Jean-Franois Vuagniaux
//
// vuagniaux.jf@com.mcnet.ch
//
//////////////////////////////////////////////////////////////////////////////

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"player.h"
#include	"../apifmod/fmod.h"






//=============================================================
// Fonctions pour prendre en charge les sons au format MP3
// Utilise la DLL fmod.dll
//=============================================================




class C3Dmp3 : public CBaseEntity
{
public:
	void KeyValue( KeyValueData* pkvd);
	void Spawn( void );
	void Precache( void );
	void EXPORT ToggleUse ( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value );

	void EXPORT Think3D( void );

	int Playmp3(const char *filename, int volume, int loop, int StartStop);

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];
	virtual int	ObjectCaps( void ) { return (CBaseEntity :: ObjectCaps() & ~FCAP_ACROSS_TRANSITION); }

	BOOL	m_fActive;	
	BOOL	m_fLooping;
	BOOL	m_Update3d;
	BOOL	m_Retard;
	int		volume;
	int		attenuation;
	int		channel;
	float   m_flSpawnTime;

	FSOUND_SAMPLE *sample;

	CBasePlayer * Player;

	char* filename;

	

};

LINK_ENTITY_TO_CLASS( ambient_mp3, C3Dmp3 );
TYPEDESCRIPTION	C3Dmp3::m_SaveData[] = 
{
	
	DEFINE_FIELD( C3Dmp3, m_fActive, FIELD_BOOLEAN ),
	DEFINE_FIELD( C3Dmp3, m_fLooping, FIELD_BOOLEAN ),
	DEFINE_FIELD( C3Dmp3, m_Update3d, FIELD_BOOLEAN ),
	DEFINE_FIELD( C3Dmp3, attenuation, FIELD_INTEGER ),
	DEFINE_FIELD( C3Dmp3, volume, FIELD_INTEGER ),
	DEFINE_FIELD( C3Dmp3, channel, FIELD_INTEGER ),

};

IMPLEMENT_SAVERESTORE( C3Dmp3, CBaseEntity );


void C3Dmp3 :: Spawn( void )
{

	
    pev->solid		= SOLID_NOT;
    pev->movetype	= MOVETYPE_NONE;


	//inizialisation de FMOD si ce n'est pas dj le cas
	UTIL_InitFsound();
	//FSOUND_3D_Listener_SetDistanceFactor(40);

	SetThink(Think3D);//initialise mais ne dmarre pas
	pev->nextthink = 0;

	SetUse ( ToggleUse );

	UTIL_SetOrigin( pev, pev->origin );
	
	m_fActive = FALSE;

	m_Update3d = 0;//pas de code 3D pour le moment
	
	
	if ( FBitSet ( pev->spawnflags, AMBIENT_SOUND_NOT_LOOPING ) )
		m_fLooping = FALSE;
	else
		m_fLooping = TRUE;
	Precache( );


}


void C3Dmp3 :: Precache( void )
{
	filename = (char*) STRING(pev->message);

	

	if ( !FStringNull( pev->message ) && strlen( filename ) > 1 )
	{
		//if (*szSoundFile != '!')
		
	}

	if ( !FBitSet (pev->spawnflags, AMBIENT_SOUND_START_SILENT ) )
	{

		if (m_fLooping)
			m_fActive = TRUE;
	}
	if ( m_fActive )
	{
		//code pour continuer  jouer

		m_flSpawnTime = gpGlobals->time;
		//temporisation de 1 seconde pour laisser le temps au joueur de prendre place dans l'espace 3d

		Playmp3(filename, volume, m_fLooping, 1);

		pev->nextthink = gpGlobals->time + 0.1;
		
	}
}


void C3Dmp3 :: KeyValue( KeyValueData *pkvd )
{

	if (FStrEq(pkvd->szKeyName, "volume"))
	{
		volume = atoi(pkvd->szValue);

		if ( volume > 255 )
			volume = 255;

		pkvd->fHandled = TRUE;
	}
	else if (FStrEq(pkvd->szKeyName, "attenuation"))
	{
		attenuation = atoi(pkvd->szValue);

		if ( attenuation == 0 )
			attenuation = 1;

		pkvd->fHandled = TRUE;
	}
	else

		CBaseEntity::KeyValue( pkvd );
}


void C3Dmp3 :: ToggleUse ( CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value )
{


	if ( useType != USE_TOGGLE )
	{
		if ( (m_fActive && useType == USE_ON) || (!m_fActive && useType == USE_OFF) )
			return;
	}
	

	// Toggle

	// m_fActive est TRUE seulement si un son est en train de jouer.
	
	if ( m_fActive )
	{// on arrte le mp3

			
		m_fActive = FALSE;
			
		// bidouillage pour que le code dans Precache fonctionne (m_fActive) aprs un save/restore
		pev->spawnflags |= AMBIENT_SOUND_START_SILENT;

		//code d'arrt du son mp3
		Playmp3(filename, volume, m_fLooping, 0);

		pev->nextthink = gpGlobals->time + 0.1;
	}
	else 
	{// on va lancer le son mp3

		// on commute seulement si c'est un son en boucle. Si ce n'est pas un son en boucle, 
		// chaque dclenchement va dmarrer le son.  Si le son est toujours en train de jouer, 
		// il va tre arrt et redmarr.
		

		if (m_fLooping)
			m_fActive = TRUE;
		
		else // code pour couper le son mp3
			
			Playmp3(filename, volume, m_fLooping, 0);
		
		//code pour relancer le son mp3
		Playmp3(filename, volume, m_fLooping, 1);
		
		pev->nextthink = gpGlobals->time + 0.1;

	} 
}

int C3Dmp3 :: Playmp3(const char *filename, int volume, int loop, int StartStop)
{
	if (attenuation == 0 )
		attenuation = 1;

	Vector VecOrigine = pev->origin;
	VecOrigine = VecOrigine / (40 / attenuation);

	int playvolume = 0;

	int result = 0;

	//s'il faut jouer en boucle
	int LoopType = 0;

	if( m_fLooping )
	{
		LoopType = FSOUND_LOOP_NORMAL;
	}
	else
	{
		LoopType = FSOUND_LOOP_OFF;
	}

	if( StartStop ) //on dmarre le son
	{

		sample = FSOUND_Sample_Load(FSOUND_FREE, filename, FSOUND_HW3D | LoopType, 0);

		FSOUND_Sample_SetMinMaxDistance(sample, 5, 100);
		
		//FSOUND_3D_Listener_SetDistanceFactor(40.0);
		
		if (gpGlobals->time < m_flSpawnTime + 1.5)
		{
			playvolume = 0;
			m_Retard = 1;
		}
		else
			playvolume = volume;

		channel = FSOUND_PlaySound3DAttrib(FSOUND_FREE, sample, -1, playvolume, -1, VecOrigine, NULL);

		

		m_Update3d = 1;

	}
	else //on arrte le son
	{

		if ( sample )
		{
			FSOUND_Sample_Free(sample);
		}
		
		m_Update3d = 0;//on arrte le code 3D

	}



return result;

}

void C3Dmp3::Think3D( void )
{


	if ( !m_Update3d )
		return;
	

	
	if(!FSOUND_IsPlaying(channel))
	{
		if ( sample )
		{
			FSOUND_Sample_Free(sample);
		}

		Playmp3(filename, volume, m_fLooping, 1);

	}


	if ((gpGlobals->time > m_flSpawnTime + 2) && m_Retard == 1)
	{
		FSOUND_SetVolume(channel, volume);

		//FSOUND_StopSound(channel);

		m_Retard = 0;
	}
		


	//ALERT(at_console, "CHANNEL %d PLAYING %d VOLUME %d\n", channel, FSOUND_IsPlaying(channel), FSOUND_GetVolume(channel));
	
	
	if (attenuation == 0 )
		attenuation = 1;

	

	CBaseEntity * pEntity = NULL;

	pEntity = UTIL_PlayerByIndex( 1 );

	if ( pEntity == NULL )
	{
		pev->nextthink = gpGlobals->time + 0.1;
		
		return;
	}
	
	

	//dfinition de la position et de l'orientation du joueur 
	

	Vector VecForward = gpGlobals->v_forward;
	Vector VecUpward = gpGlobals->v_up;
	Vector VecPlayerpos = pEntity->pev->origin;
	VecPlayerpos = VecPlayerpos / (40 / attenuation);

	//ALERT(at_console, "Player %f %f %f\n Source %f %f %f\n", VecPlayerpos.x, VecPlayerpos.y, VecPlayerpos.z, pev->origin.x, pev->origin.y, pev->origin.z);

	ALERT(at_console, "Player %f %f\n", VecForward.x, VecForward.y);

	//ATTENTION fmod n'utilise pas le systme de coordonnes de HL, il faut rajuster les angles dans la composante z
	
	FSOUND_3D_Listener_SetAttributes(VecPlayerpos, NULL, VecForward.x, VecForward.y, -VecForward.z, VecUpward.x, VecUpward.y, -VecUpward.z); 
	
	//FSOUND_3D_Listener_SetDistanceFactor(40.0);// l'unit de FMOD fait 1 mtre dans Half-Life l'unit fait 1 pouce
	
	FSOUND_3D_Update();//met  jour les paramtres 3D du son

	pev->nextthink = gpGlobals->time + 0.1;

}