/***
*
*	Code pour l'ATST par Jean-Franois Vuagniaux
*   vuagniaux.jf@com.mcnet.ch
*
****/
//=========================================================
// ATST, bipode tout terrain blind lger
//=========================================================

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"monsters.h"
#include	"schedule.h"
#include	"squadmonster.h"
#include	"weapons.h"
#include	"soundent.h"
#include	"animation.h"

//=========================================================
// types de schedule (programmes) spcifiques au monstre ATST
//=========================================================
enum
{
	SCHED_ATST_SUPPRESS = LAST_COMMON_SCHEDULE + 1,
	SCHED_ATST_RECHERCHE,
};

//=========================================================
// tasks (tches) spcifiques pour l'ATST
//=========================================================
enum 
{
	TASK_ATST_GET_PATH_TO_ENEMY_CORPSE = LAST_COMMON_TASK + 1,
};

int iAtstMuzzleFlash;
int m_Biglowspr;
int m_Bismoke;
int m_iAtTrail;
int m_WallSmoke;


//=========================================================
// Evnements d'animations de l'ATST
//=========================================================
#define		ATST_AE_TIR1	( 1 )
#define		ATST_AE_TIR2	( 2 )
#define		ATST_AE_KICK	( 3 )
#define		ATST_AE_LEFT_FOOT  ( 4 )
#define		ATST_AE_RIGHT_FOOT ( 5 )

#define		ATST_MELEE_DIST	180


//=========================================================
// Projectile de blaster lourd pour le canon de tourelle BlasTech industries
//=========================================================

class CBBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );
	
	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_Bblastballs;
	int  m_Bblastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;	
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol
	
};

LINK_ENTITY_TO_CLASS( bblaster, CBBlaster );

TYPEDESCRIPTION	CBBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CBBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CBBlaster, CBaseEntity );


void CBBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "bblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/bigblaster.spr");
	pev->frame = 0;
	pev->scale = 0.8;
	

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iAtTrail );	// modle
		WRITE_BYTE( 2 ); // dure
		WRITE_BYTE( 4 );  // largeur
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}


void CBBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 25 );		// radius * 0.1
			WRITE_BYTE( 100 );		// r
			WRITE_BYTE( 255 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		
		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_Bismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}

}

void CBBlaster::Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity )
{
	CBBlaster *pBBlast = GetClassPtr( (CBBlaster *)NULL );
	pBBlast->Spawn();
	
	UTIL_SetOrigin( pBBlast->pev, MvecStart );
	pBBlast->pev->velocity = MvecVelocity;
	pBBlast->pev->euser1 = ENT(pevOwner);
	pBBlast->pev->owner = NULL;

	pBBlast->SetThink ( Animate );
	pBBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CBBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iMPitch;
	m_Bblastglow = m_Biglowspr;
	m_Bblastballs = m_Biglowspr;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	// son de choc
	iMPitch = RANDOM_FLOAT( 90, 110 );

	entvars_t *pevAttacker = NULL;
	if ( pev->euser1 )
	{
		pevAttacker = VARS(pev->euser1);
	}

	if ( pev->euser1 == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}
	
	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}

	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		if ( !pOther->pev->takedamage )
		{
			
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			// sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_Bblastglow );		// modle
						WRITE_BYTE( 50 );	// dure
						WRITE_BYTE( 4 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_Bblastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 12 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 24 );	
						WRITE_SHORT( m_WallSmoke );		// modle
						WRITE_BYTE( 15 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else
		{
			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

				Vector Mcentre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, Mcentre );//nuage d'impacte sur les corps
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( Mcentre.x );	// position
					WRITE_COORD( Mcentre.y );	
					WRITE_COORD( Mcentre.z + 8);	
					WRITE_SHORT( m_Bismoke );	// modle
					WRITE_BYTE( 4 );			// taille * 10
					WRITE_BYTE( 255 );			// luminosit
				MESSAGE_END();
			
				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, (gSkillData.blasterDmg * 2) * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );

				ApplyMultiDamage( pev, pevAttacker);
			
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}


class CAtst : public CSquadMonster
{
public:
	void Spawn( void );
	void Precache( void );
	void SetYawSpeed ( void );
	int  Classify ( void );
	int  ISoundMask ( void );
	void HandleAnimEvent( MonsterEvent_t *pEvent );
	void SetObjectCollisionBox( void )
	{
		pev->absmin = pev->origin + Vector( -64, -64, 0 );
		pev->absmax = pev->origin + Vector( 64, 64, 320 );
	}
	void Killed( entvars_t *pevAttacker, int iGib );
	Schedule_t* GetSchedule ( void );
	Schedule_t* GetScheduleOfType ( int Type );
	BOOL FCanCheckAttacks ( void );
	BOOL CheckMeleeAttack1 ( float flDot, float flDist );
	BOOL CheckRangeAttack1 ( float flDot, float flDist );
	void StartTask ( Task_t *pTask );
	void DeathSound ( void );
	void StopTalking ( void );
	BOOL ShouldSpeak( void );
	Vector GetGunPosition ( void );
	void Shoot ( void );
	CBaseEntity	*Kick( void );
	void AttackSound ( void );
	void PrescheduleThink ( void );
	void TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType);
	int TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType );
	int IRelationship( CBaseEntity *pTarget );

	CUSTOM_SCHEDULES;

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	static const char *pAttackHitSounds[];
	static const char *pAttackMissSounds[];
	static const char *pAttackSounds[];
	static const char *pDieSounds[];
	static const char *pIdleSounds[];
	
	float	m_flNextSpeakTime;
	float	m_flNextWordTime;
	int		m_iLastWord;
	int		num;

	BOOL	m_fCanAttack;
	float	m_flNextAttackCheck;
	BOOL    m_quelcanon;
};
LINK_ENTITY_TO_CLASS( monster_atst, CAtst );

TYPEDESCRIPTION	CAtst::m_SaveData[] = 
{
	DEFINE_FIELD( CAtst, m_fCanAttack, FIELD_BOOLEAN ),
	DEFINE_FIELD( CAtst, m_flNextAttackCheck, FIELD_TIME ),
	DEFINE_FIELD( CAtst, m_flNextSpeakTime, FIELD_TIME ),
	DEFINE_FIELD( CAtst, m_flNextWordTime, FIELD_TIME ),
	DEFINE_FIELD( CAtst, m_iLastWord, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CAtst, CSquadMonster );

const char *CAtst::pAttackHitSounds[] = 
{
	"atst/strike1.wav",
	"atst/strike2.wav",
	"atst/strike3.wav",
};

const char *CAtst::pAttackMissSounds[] = 
{
	"atst/miss1.wav",
	"atst/miss2.wav",
};

const char *CAtst::pAttackSounds[] =
{
	"atst/attack1.wav",
	"atst/attack2.wav",
	"atst/attack3.wav",
	"atst/attack4.wav",
	"atst/attack5.wav",
};

const char *CAtst::pDieSounds[] =
{
	"atst/die1.wav",
	"atst/die2.wav",
	"atst/die3.wav",
};

const char *CAtst::pIdleSounds[] =
{
	"atst/idle1.wav",
	"atst/idle2.wav",
	"atst/idle3.wav",
	"atst/idle4.wav",
	"atst/idle5.wav",
};


//=========================================================
// IRelationship - l'ennemi principal est l'alien grunt
//=========================================================
int CAtst::IRelationship ( CBaseEntity *pTarget )
{
	if ( FClassnameIs( pTarget->pev, "monster_alien_grunt" ) )
	{
		return R_NM;
	}

	return CSquadMonster :: IRelationship( pTarget );
}

//=========================================================
// ISoundMask 
//=========================================================
int CAtst :: ISoundMask ( void )
{
	return	bits_SOUND_WORLD	|
			bits_SOUND_DANGER	|
			bits_SOUND_PLAYER	|
			bits_SOUND_COMBAT	;
			
}


void CAtst::Killed( entvars_t *pevAttacker, int iGib )
{
	
	CBaseMonster::Killed( pevAttacker, GIB_NEVER );

	STOP_SOUND(ENT(pev), CHAN_VOICE, pIdleSounds[ num ]);
	
	

}

//=========================================================
// TraceAttack
//=========================================================
void CAtst :: TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	
	m_LastHitGroup = ptr->iHitgroup;

		switch ( ptr->iHitgroup )
		{
		case HITGROUP_GENERIC:
			break;
		case HITGROUP_HEAD:
			flDamage *= gSkillData.monHead;
			break;
		case HITGROUP_CHEST:
			flDamage *= gSkillData.monChest;
			break;
		case HITGROUP_STOMACH:
			flDamage *= gSkillData.monStomach;
			break;
		case HITGROUP_LEFTARM:
		case HITGROUP_RIGHTARM:
			flDamage *= gSkillData.monArm;
			break;
		case HITGROUP_LEFTLEG:
		case HITGROUP_RIGHTLEG:
			flDamage *= gSkillData.monLeg;
			break;
		default:
			break;
		}


	// l'ATST ne reoit que trs peu de dommage de la part d'armes lgres comme le pied de biche
	// ou une balle ou un coup. Il provoque donc facilement des ricochets.
    if  (bitsDamageType & (DMG_ENERGYBEAM | DMG_MORTAR | DMG_BLAST | DMG_SABER))
	{
		if (bitsDamageType & DMG_ENERGYBEAM)
		{
			flDamage -= 20;
			if (flDamage <= 0)
				flDamage = 0.1;
		}
		
	}

	if  (bitsDamageType & (DMG_GENERIC | DMG_NEVERGIB | DMG_CRUSH))
	{
		// hit armor
		flDamage -= 30; // diminue le dommage de 30 units
		if (flDamage <= 0)
			flDamage = 0.1;// ne blesse que trs lgrement mais permet que bits_COND_LIGHT_DAMAGE soit gnr.

	}

	if  (bitsDamageType & (DMG_BULLET | DMG_SLASH | DMG_CLUB))
	{
		// hit armor
		//ALERT ( at_console, "faible dommages\n" ) ;

		if ( pev->dmgtime != gpGlobals->time || (RANDOM_LONG(0,2) < 1) )
		{
			UTIL_Ricochet( ptr->vecEndPos, RANDOM_FLOAT( 1, 2) );
			pev->dmgtime = gpGlobals->time;
		}

		if ( RANDOM_LONG( 0, 1 ) == 0 )
		{
			Vector vecTracerDir = vecDir;

			vecTracerDir.x += RANDOM_FLOAT( -0.3, 0.3 );
			vecTracerDir.y += RANDOM_FLOAT( -0.3, 0.3 );
			vecTracerDir.z += RANDOM_FLOAT( -0.3, 0.3 );

			vecTracerDir = vecTracerDir * -512;

			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, ptr->vecEndPos );
			WRITE_BYTE( TE_TRACER );
				WRITE_COORD( ptr->vecEndPos.x );
				WRITE_COORD( ptr->vecEndPos.y );
				WRITE_COORD( ptr->vecEndPos.z );

				WRITE_COORD( vecTracerDir.x );
				WRITE_COORD( vecTracerDir.y );
				WRITE_COORD( vecTracerDir.z );
			MESSAGE_END();
		}

		flDamage -= 30; // diminue le dommage de 30 units
		if (flDamage <= 0)
			flDamage = 0.1;// ne blesse que trs lgrement mais permet que bits_COND_LIGHT_DAMAGE soit gnr.
		
	}
	
	// bien entendu il n'y a jamais de projection de sang
	AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType );

	
}

int CAtst :: TakeDamage(entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType)
{
	
	Forget( bits_MEMORY_INCOVER );

	// l'ATST ne reoit que trs peu de dommage de la part d'armes lgres comme le pied de biche
	// ou une balle ou un coup. Il provoque donc facilement des ricochets.
    if  (bitsDamageType & (DMG_ENERGYBEAM | DMG_MORTAR | DMG_BLAST | DMG_SABER))
	{
		//ALERT ( at_console, "graves dommages\n" ) ;
		
		if (bitsDamageType & DMG_ENERGYBEAM)
		{
			
				flDamage = 0.1;// les blasters n'affectent pratiquement pas le blindage
		}

		if ( bitsDamageType & DMG_SABER )
		{
			flDamage = flDamage / 2;	// blindage partiellement efficace
		}

		return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );
	}

	if  (bitsDamageType & (DMG_GENERIC | DMG_NEVERGIB | DMG_CRUSH))
	{
		// hit armor
		flDamage -= 30; // diminue le dommage de 30 units
		if (flDamage <= 0)
			flDamage = 0.1;// ne blesse que trs lgrement mais permet que bits_COND_LIGHT_DAMAGE soit gnr.

		return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );
	}

	else
	{
		
		// hit armor
		flDamage -= 30; // diminue le dommage de 30 units
		if (flDamage <= 0)
			flDamage = 0.1;// ne blesse que trs lgrement mais permet que bits_COND_LIGHT_DAMAGE soit gnr.

		return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );

	}


}


//=========================================================
// PrescheduleThink 
//=========================================================
void CAtst :: PrescheduleThink ( void )
{
	if ( InSquad() && m_hEnemy != NULL )
	{
		if ( HasConditions ( bits_COND_SEE_ENEMY ) )
		{
			// update the squad's last enemy sighting time.
			MySquadLeader()->m_flLastEnemySightTime = gpGlobals->time;
		}
		else
		{
			if ( gpGlobals->time - MySquadLeader()->m_flLastEnemySightTime > 5 )
			{
				// been a while since we've seen the enemy
				MySquadLeader()->m_fEnemyEluded = TRUE;
			}
		}
	}

	if ( ShouldSpeak() )
	{
		if ( m_flNextWordTime < gpGlobals->time )
		{
			num = -1;

			do
			{
				num = RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1);
			} while( num == m_iLastWord );

			m_iLastWord = num;

			// play a new sound
			EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[ num ], 1.0, ATTN_NORM );

			// is this word our last?
			if ( RANDOM_LONG( 1, 10 ) <= 4 )
			{
				// stop talking.
				StopTalking();
			}
			else
			{
				m_flNextWordTime = gpGlobals->time + RANDOM_FLOAT( 3.5, 6 );
			}
		}
	}
}

//=========================================================
// Sons de mort
//=========================================================
void CAtst :: DeathSound ( void )
{

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pDieSounds[RANDOM_LONG(0,ARRAYSIZE(pDieSounds)-1)], 1.0, ATTN_NORM );
}


//=========================================================
// StopTalking - pas de sons pendant 10-20 secondes.
//=========================================================
void CAtst::StopTalking( void )
{
	m_flNextWordTime = m_flNextSpeakTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);
}

//=========================================================
// ShouldSpeak - Est-ce le moment de jouer un son
//=========================================================
BOOL CAtst::ShouldSpeak( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		// pas pour le moment.
		return FALSE;
	}

	if ( pev->spawnflags & SF_MONSTER_GAG )
	{
		if ( m_MonsterState != MONSTERSTATE_COMBAT )
		{
			
			m_flNextSpeakTime = gpGlobals->time + 6;
			return FALSE;
		}
	}

	return TRUE;
}


//=========================================================
// Sons d'attaque
//=========================================================
void CAtst :: AttackSound ( void )
{

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// Classify - place du monstre dans la table des relations 
//=========================================================
int	CAtst :: Classify ( void )
{
	return	CLASS_HUMAN_MILITARY;
}

//=========================================================
// SetYawSpeed - permet  chaque squence d'avoir un taux de lacet diffrent
//=========================================================
void CAtst :: SetYawSpeed ( void )
{
	int ys;

	switch ( m_Activity )
	{
	case ACT_TURN_LEFT:
	case ACT_TURN_RIGHT:
		ys = 30;
		break;
	default:			ys = 20;
	}

	pev->yaw_speed = ys;
}


//=========================================================
// GetGunPosition	donne l'extrmit du canon
//=========================================================

Vector CAtst :: GetGunPosition( )
{
	if ( !m_quelcanon  )
	{
		Vector vecArmPos, vecArmDir;
		GetAttachment( 0, vecArmPos, vecArmDir ); //point d'attache numro 1 du canon
		return vecArmPos;
	}
	else
	{
		Vector vecArmPos, vecArmDir;
		GetAttachment( 1, vecArmPos, vecArmDir ); //point d'attache numro 2 du canon
		return vecArmPos;
	}
}


//=========================================================
// Shoot Tourelle
//=========================================================
void CAtst :: Shoot ( void )
{
	if (m_hEnemy == NULL)
	{
		return;
	}

	Vector vecShootOrigin = GetGunPosition();
	Vector vecShootDir = ShootAtEnemy( vecShootOrigin );

	UTIL_MakeVectors ( pev->angles );
	
	// code pour tirer un projectile de blaster
	// ajout de la dispersion du tir automatique rapide

	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_3DEGREES ;
	vecShootDir = vecShootDir + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;
    
	// !! ajouter les dtonations de tir!!!

	switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, "atst/shoot1.wav", 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
				break;

			case 1:

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, "atst/shoot2.wav", 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
				break;

			}
			
	CBBlaster::Shoot(pev,vecShootOrigin,vecShootDir * 2000);


	Vector angDir = UTIL_VecToAngles( vecShootDir );
	SetBlending( 0, angDir.x ); // donne l'inclinaison de tir du stormtrooper pour l'animation
}



//=========================================================
// HandleAnimEvent - s'occupe des messages spcifiques qui apparaissent dans les animations
//
// Retourne le nombre d'vnements traits, 0 si aucun.
//=========================================================
void CAtst :: HandleAnimEvent( MonsterEvent_t *pEvent )
{
	switch( pEvent->event )
	{
	case ATST_AE_TIR1:

		{
			// m_vecEnemyLKP doit tre le centre du corps de l'ennemi
			Vector vecArmPos, vecArmDir;
			Vector vecDirToEnemy;
			Vector angDir;

			if (HasConditions( bits_COND_SEE_ENEMY))
			{
				vecDirToEnemy = ( ( m_vecEnemyLKP ) - pev->origin );
				angDir = UTIL_VecToAngles( vecDirToEnemy );
				vecDirToEnemy = vecDirToEnemy.Normalize();
			}
			else
			{
				angDir = pev->angles;
				UTIL_MakeAimVectors( angDir );
				vecDirToEnemy = gpGlobals->v_forward;
			}

			pev->effects = EF_MUZZLEFLASH;

			// make angles +-180
			if (angDir.x > 180)
			{
				angDir.x = angDir.x - 360;
			}

			SetBlending( 0, angDir.x );
			GetAttachment( 0, vecArmPos, vecArmDir ); //point d'attache numro 1 du canon

			vecArmPos = vecArmPos + vecDirToEnemy * 32;
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecArmPos );
				WRITE_BYTE( TE_SPRITE );
				WRITE_COORD( vecArmPos.x );	// position
				WRITE_COORD( vecArmPos.y );	
				WRITE_COORD( vecArmPos.z );	
				WRITE_SHORT( iAtstMuzzleFlash );		// modle pour le flash
				WRITE_BYTE( 10 );				// taille * 10
				WRITE_BYTE( 128 );			// luminosit
			MESSAGE_END();

			// code pour le tir d'un projectile de type blaster lourd
			m_quelcanon = 0;
			
			//ALERT ( at_console, "tir donc ducon\n" ) ;

			Shoot();

		}
		break;

	case ATST_AE_TIR2:

		{

			// m_vecEnemyLKP doit tre le centre du corps de l'ennemi
			Vector vecArmPos, vecArmDir;
			Vector vecDirToEnemy;
			Vector angDir;

			if (HasConditions( bits_COND_SEE_ENEMY))
			{
				vecDirToEnemy = ( ( m_vecEnemyLKP ) - pev->origin );
				angDir = UTIL_VecToAngles( vecDirToEnemy );
				vecDirToEnemy = vecDirToEnemy.Normalize();
			}
			else
			{
				angDir = pev->angles;
				UTIL_MakeAimVectors( angDir );
				vecDirToEnemy = gpGlobals->v_forward;
			}

			pev->effects = EF_MUZZLEFLASH;

			// make angles +-180
			if (angDir.x > 180)
			{
				angDir.x = angDir.x - 360;
			}

			SetBlending( 0, angDir.x );
			GetAttachment( 1, vecArmPos, vecArmDir ); //point d'attache numro 2 du canon

			vecArmPos = vecArmPos + vecDirToEnemy * 32;
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecArmPos );
				WRITE_BYTE( TE_SPRITE );
				WRITE_COORD( vecArmPos.x );	// position
				WRITE_COORD( vecArmPos.y );	
				WRITE_COORD( vecArmPos.z );	
				WRITE_SHORT( iAtstMuzzleFlash );		// modle pour le flash
				WRITE_BYTE( 10 );				// taille * 10
				WRITE_BYTE( 128 );			// luminosit
			MESSAGE_END();

			// code pour le tir d'un projectile de type blaster lourd
			m_quelcanon = 1;

			Shoot();

		}
		break;

		// l'ATST fait normment de bruit en marchant 

	case ATST_AE_LEFT_FOOT:
		switch (RANDOM_LONG(0,1))
		{
		// pied gauche
		case 0:	EMIT_SOUND_DYN ( ENT(pev), CHAN_BODY, "atst/walk3.wav", 1, 0.3, 0, 70 );	break;
		case 1:	EMIT_SOUND_DYN ( ENT(pev), CHAN_BODY, "atst/walk4.wav", 1, 0.3, 0, 70 );	break;
		}
		break;
	case ATST_AE_RIGHT_FOOT:
		// pied droit
		switch (RANDOM_LONG(0,1))
		{
		case 0:	EMIT_SOUND_DYN ( ENT(pev), CHAN_BODY, "atst/walk1.wav", 1, 0.3, 0, 70 );	break;
		case 1:	EMIT_SOUND_DYN ( ENT(pev), CHAN_BODY, "atst/walk2.wav", 1, 0.3, 0 ,70);	break;
		}
		break;

	case ATST_AE_KICK:
		{
			
			CBaseEntity *pHurt = Kick();

			if ( pHurt )
			{
				// SOUND HERE!
				UTIL_MakeVectors( pev->angles );
				pHurt->pev->punchangle.x = 50;
				pHurt->pev->punchangle.y = -25;
				pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_forward * 600 + gpGlobals->v_up * 500;
				pHurt->TakeDamage( pev, pev, gSkillData.atstDmgKick, DMG_CRUSH );
			}
			
			
			
			/*CBaseEntity *pHurt = CheckTraceHullAttack( ATST_MELEE_DIST, gSkillData.atstDmgKick, DMG_CRUSH);
			
			if ( pHurt )
			{
				pHurt->pev->punchangle.y = -25;
				pHurt->pev->punchangle.x = 50;

				
				if ( pHurt->IsPlayer() )
				{
					
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * 600;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				
			}
			else
			{
				// joue un son de rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}*/


		}
		break;


	default:
		CSquadMonster::HandleAnimEvent( pEvent );
		break;
	}
}


//=========================================================
// KickAss
//=========================================================
CBaseEntity *CAtst :: Kick( void )
{
	TraceResult tr;

	UTIL_MakeVectors( pev->angles );
	Vector vecStart = pev->origin;
	//vecStart.z += pev->size.z * 0.5;
	vecStart.z += pev->size.z * 0.1;
	Vector vecEnd = vecStart + (gpGlobals->v_forward * 180);

	UTIL_TraceHull( vecStart, vecEnd, dont_ignore_monsters, head_hull, ENT(pev), &tr );
	
	if ( tr.pHit )
	{
		CBaseEntity *pEntity = CBaseEntity::Instance( tr.pHit );
		return pEntity;
	}

	return NULL;
}

//=========================================================
// Spawn
//=========================================================
void CAtst :: Spawn()
{
	Precache( );

	SET_MODEL(ENT(pev), "models/atst.mdl");
	UTIL_SetSize(pev, Vector(-32, -32, 0), Vector(32, 32, 320));

	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_STEP;
	m_bloodColor		= DONT_BLEED;
	pev->effects		= 0;
	pev->iuser3			= 100; // masse
	pev->iuser4			= 0; //flag d'incendie
	pev->health			= gSkillData.atstHealth;
	m_flFieldOfView		= 0.2;// champs de vision de l'atst
	m_MonsterState		= MONSTERSTATE_NONE;
	m_afCapability		= 0;
	m_afCapability		|= bits_CAP_SQUAD;


	MonsterInit();
}

//=========================================================
// Precache - precache toutes les ressources
//=========================================================
void CAtst :: Precache()
{
	int i;

	PRECACHE_MODEL("models/atst.mdl");

	for ( i = 0; i < ARRAYSIZE( pAttackHitSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackHitSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackMissSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackMissSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pDieSounds ); i++ )
		PRECACHE_SOUND((char *)pDieSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pIdleSounds ); i++ )
		PRECACHE_SOUND((char *)pIdleSounds[i]);


	// son de la marche
	PRECACHE_SOUND( "atst/walk1.wav" );
	PRECACHE_SOUND( "atst/walk2.wav" );
	PRECACHE_SOUND( "atst/walk3.wav" );
	PRECACHE_SOUND( "atst/walk4.wav" );
	
	// sons de tir blaster et lanceur

	iAtstMuzzleFlash = PRECACHE_MODEL( "sprites/muz4.spr" );
	PRECACHE_MODEL( "sprites/bigblaster.spr" );
	m_Biglowspr = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_Bismoke = PRECACHE_MODEL( "sprites/blasthit.spr" );
	m_iAtTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_WallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
	PRECACHE_MODEL( "sprites/bigblaster.spr" );

	PRECACHE_SOUND( "weapons/choc1.wav" );
	PRECACHE_SOUND( "weapons/choc2.wav" );
	PRECACHE_SOUND( "weapons/grill.wav" );
	PRECACHE_SOUND( "weapons/choc3.wav" );
	PRECACHE_SOUND( "weapons/choc4.wav" );
	PRECACHE_SOUND( "atst/shoot1.wav" );
	PRECACHE_SOUND( "atst/shoot2.wav" );

}	
	
//=========================================================
// AI Schedules particuliers au monstre ATST
//=========================================================

//=========================================================
// Fail Schedule (chec)
//=========================================================
Task_t	tlAtstFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT,				(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slAtstFail[] =
{
	{
		tlAtstFail,
		ARRAYSIZE ( tlAtstFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Atst Fail"
	},
};

//=========================================================
// Combat Fail Schedule ( chec au combat )
//=========================================================
Task_t	tlAtstCombatFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT_FACE_ENEMY,		(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slAtstCombatFail[] =
{
	{
		tlAtstCombatFail,
		ARRAYSIZE ( tlAtstCombatFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Atst Combat Fail"
	},
};

//=========================================================
// Standoff schedule. Utilis en combat lorsque le monstre a perdu de vue l'ennemi.
// On recherche l'ennemi?
//=========================================================
Task_t	tlAtstStandoff[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_ACTIVITY,			(float)ACT_IDLE				},
	{ TASK_WAIT_FACE_ENEMY,			(float)2					},
};

Schedule_t slAtstStandoff[] = 
{
	{
		tlAtstStandoff,
		ARRAYSIZE ( tlAtstStandoff ),
		bits_COND_CAN_RANGE_ATTACK1		|
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_SEE_ENEMY				|
		bits_COND_NEW_ENEMY				|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Atst Standoff"
	}
};

//=========================================================
// Suppress
//=========================================================
Task_t	tlAtstSuppress[] =
{
	{ TASK_STOP_MOVING,		(float)0		},
	{ TASK_RANGE_ATTACK1,	(float)0		},
};

Schedule_t slAtstSuppress[] =
{
	{
		tlAtstSuppress,
		ARRAYSIZE ( tlAtstSuppress ),
		0,
		0,
		"Atst Suppress",
	},
};

//=========================================================
// Attaque primaire  distance
//=========================================================
Task_t	tlAtstRangeAttack1[] =
{
	{ TASK_STOP_MOVING,			(float)0		},
	{ TASK_FACE_ENEMY,			(float)0		},
	{ TASK_RANGE_ATTACK1,		(float)0		},
};

Schedule_t	slAtstRangeAttack1[] =
{
	{ 
		tlAtstRangeAttack1,
		ARRAYSIZE ( tlAtstRangeAttack1 ), 
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_HEAVY_DAMAGE,
		
		0,
		"Atst Range Attack1"
	},
};

//=========================================================
// Se met  couvert de l'ennemi sur le ct avant de rechercher un noeud  couvert. 
//=========================================================
Task_t	tlAtstTakeCoverFromEnemy[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slAtstTakeCoverFromEnemy[] =
{
	{ 
		tlAtstTakeCoverFromEnemy,
		ARRAYSIZE ( tlAtstTakeCoverFromEnemy ), 
		bits_COND_NEW_ENEMY,
		0,
		"AtstTakeCoverFromEnemy"
	},
};

//=========================================================
// Youpiiieee ! je t'ai eu !, tu l'as dans l'cul.
//=========================================================
Task_t	tlAtstVictoryDance[] =
{
	{ TASK_STOP_MOVING,						(float)0					},
	{ TASK_WAIT,							(float)0.2					},
	{ TASK_ATST_GET_PATH_TO_ENEMY_CORPSE,	(float)0					},
	{ TASK_WALK_PATH,						(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,				(float)0					},
	{ TASK_FACE_ENEMY,						(float)0					},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_CROUCH			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_STAND			},

};

Schedule_t	slAtstVictoryDance[] =
{
	{ 
		tlAtstVictoryDance,
		ARRAYSIZE ( tlAtstVictoryDance ), 
		bits_COND_NEW_ENEMY		|
		bits_COND_LIGHT_DAMAGE	|
		bits_COND_HEAVY_DAMAGE,
		0,
		"AtstVictoryDance"
	},
};


Task_t tlAtstRecherche[] =
{
	{ TASK_GET_PATH_TO_SPOT,		(float)0		},
	{ TASK_RUN_PATH,				(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0		},
};

Schedule_t slAtstRecherche[] =
{
	{
		tlAtstRecherche,
		ARRAYSIZE ( tlAtstRecherche ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"AtstRecherche"
	},
};
//=========================================================
//=========================================================

DEFINE_CUSTOM_SCHEDULES( CAtst )
{
	slAtstFail,
	slAtstCombatFail,
	slAtstStandoff,
	slAtstSuppress,
	slAtstRangeAttack1,
	slAtstTakeCoverFromEnemy,
	slAtstVictoryDance,
	slAtstRecherche,
};




IMPLEMENT_CUSTOM_SCHEDULES( CAtst, CSquadMonster );

//=========================================================
// FCanCheckAttacks vrifie si l'attaque est possible
//=========================================================
BOOL CAtst :: FCanCheckAttacks ( void )
{
	if ( !HasConditions( bits_COND_ENEMY_TOOFAR ) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//=========================================================
// CheckMeleeAttack1 vrifie si l'attaque de mle est possible
//=========================================================
BOOL CAtst :: CheckMeleeAttack1 ( float flDot, float flDist )
{
	if ( HasConditions ( bits_COND_SEE_ENEMY ) && flDist <= ATST_MELEE_DIST && flDot >= 0.6 && m_hEnemy != NULL )
	{
		//ALERT ( at_console, "c'est la melee\n" ) ;
		return TRUE;
	}
	return FALSE;
}

//=========================================================
// CheckRangeAttack1 vrifie si l'attaque  distance est possible
//=========================================================
BOOL CAtst :: CheckRangeAttack1 ( float flDot, float flDist )
{
	if ( gpGlobals->time < m_flNextAttackCheck )
	{
		return m_fCanAttack;
	}

	if ( HasConditions( bits_COND_SEE_ENEMY ) && flDist >= ATST_MELEE_DIST && flDist <= 1024 && flDot >= 0.5 && NoFriendlyFire() )
	{
		TraceResult	tr;
		Vector	vecArmPos, vecArmDir;

		// vrifie qu'un coup tir touchera l'ennemi avant le monde
		UTIL_MakeVectors( pev->angles );
		GetAttachment( 0, vecArmPos, vecArmDir );
		UTIL_TraceLine( vecArmPos, m_hEnemy->BodyTarget(vecArmPos), dont_ignore_monsters, ENT(pev), &tr);

		if ( tr.flFraction == 1.0 || tr.pHit == m_hEnemy->edict() )
		{
			m_flNextAttackCheck = gpGlobals->time + RANDOM_FLOAT( 2, 5 );
			m_fCanAttack = TRUE;
			//ALERT ( at_console, "m_fCanAttack = TRUE\n" ) ;
			return m_fCanAttack;
		}
	}
	
	m_flNextAttackCheck = gpGlobals->time + 0.2;// don't check for half second if this check wasn't successful
	m_fCanAttack = FALSE;
	return m_fCanAttack;
}

//==========================================================
// L'atst utilise l'animation pour tourner, mme lgrement
//==========================================================
void CBaseMonster :: AtstTurn ( void )
{
	
	float flYD;
	flYD = FlYawDiff();

	if ( LookupActivity ( ACT_TURN_RIGHT ) != ACTIVITY_NOT_AVAILABLE )
	{// big right turn
		m_IdealActivity = ACT_TURN_RIGHT;
	}
	else if ( LookupActivity ( ACT_TURN_LEFT ) != ACTIVITY_NOT_AVAILABLE )
	{// big left turn
		m_IdealActivity = ACT_TURN_LEFT;
	}
}
//=========================================================
// StartTask
//=========================================================
void CAtst :: StartTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_ATST_GET_PATH_TO_ENEMY_CORPSE:
		{
			UTIL_MakeVectors( pev->angles );
			if ( BuildRoute ( m_vecEnemyLKP - gpGlobals->v_forward * 50, bits_MF_TO_LOCATION, NULL ) )
			{
				TaskComplete();
			}
			else
			{
				ALERT ( at_aiconsole, "AtstGetPathToEnemyCorpse failed!!\n" );
				TaskFail();
			}
		}
		break;
	
	case TASK_TURN_RIGHT:
		{
		float flCurrentYaw;
			
			flCurrentYaw = UTIL_AngleMod( pev->angles.y );
			pev->ideal_yaw = UTIL_AngleMod( flCurrentYaw - pTask->flData );
			AtstTurn() ;

			break;
		
		}
	
	case TASK_TURN_LEFT:
		{
		
		float flCurrentYaw;
			
			flCurrentYaw = UTIL_AngleMod( pev->angles.y );
			pev->ideal_yaw = UTIL_AngleMod( flCurrentYaw + pTask->flData );
			AtstTurn() ;

			break;
		}
		
	
	default:
		CSquadMonster :: StartTask ( pTask );
		break;

	}

}
//=========================================================
// GetSchedule - Decides which type of schedule best suits
// the monster's current state and conditions. Then calls
// monster's member function to get a pointer to a schedule
// of the proper type.
//=========================================================
Schedule_t *CAtst :: GetSchedule ( void )
{
	if ( HasConditions(bits_COND_HEAR_SOUND) )
	{
		CSound *pSound;
		pSound = PBestSound();

		ASSERT( pSound != NULL );
		if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
		{
			// dangerous sound nearby!
			return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
		}
	}

	switch	( m_MonsterState )
	{
	
	case MONSTERSTATE_IDLE:
	case MONSTERSTATE_ALERT:
		{

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}


		}
		break;

	case MONSTERSTATE_COMBAT:
		{
	// dead enemy
			if ( HasConditions( bits_COND_ENEMY_DEAD ) )
			{
				// call base class, all code to handle dead enemies is centralized there.
				return CBaseMonster :: GetSchedule();
			}

			if ( HasConditions(bits_COND_NEW_ENEMY) )
			{
				return GetScheduleOfType( SCHED_WAKE_ANGRY );
			}

	// zap player!
			if ( HasConditions ( bits_COND_CAN_MELEE_ATTACK1 ) )
			{
				AttackSound();// this is a total hack. Should be parto f the schedule
				return GetScheduleOfType ( SCHED_MELEE_ATTACK1 );
			}

			

	// can attack
			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) && OccupySlot ( bits_SLOTS_ATST_TIR ) )
			{
				return GetScheduleOfType ( SCHED_RANGE_ATTACK1 );
			}

			if ( OccupySlot ( bits_SLOT_ATST_CHASE ) )
			{
				return GetScheduleOfType ( SCHED_CHASE_ENEMY );
			}

			return GetScheduleOfType ( SCHED_STANDOFF );
		}
	}

	return CSquadMonster :: GetSchedule();
}

//=========================================================
//=========================================================
Schedule_t* CAtst :: GetScheduleOfType ( int Type ) 
{
	switch	( Type )
	{
	case SCHED_TAKE_COVER_FROM_ENEMY:
		return &slAtstTakeCoverFromEnemy[ 0 ];
		break;
	
	case SCHED_RANGE_ATTACK1:
		if ( HasConditions( bits_COND_SEE_ENEMY ) )
		{
			return &slAtstRangeAttack1[ 0 ];
		}
		break;

	case SCHED_ATST_SUPPRESS:
		return &slAtstSuppress[ 0 ];
		break;

	case SCHED_STANDOFF:
		return &slAtstStandoff[ 0 ];
		break;

	case SCHED_ATST_RECHERCHE:
		return &slAtstRecherche[ 0 ];
		break;

	case SCHED_VICTORY_DANCE:
		return &slAtstVictoryDance[ 0 ];
		break;

	case SCHED_FAIL:
		// no fail schedule specified, so pick a good generic one.
		{
			if ( m_hEnemy != NULL )
			{
				// I have an enemy
				// !!!LATER - what if this enemy is really far away and i'm chasing him?
				// this schedule will make me stop, face his last known position for 2 
				// seconds, and then try to move again
				return &slAtstCombatFail[ 0 ];
			}

			return &slAtstFail[ 0 ];
		}
		break;

	}

	return CSquadMonster :: GetScheduleOfType( Type );
}

