/***
*
*	Code pour l'arbalte des Wookies
*
*	Par Jean-Franois Vuagniaux 
*
*	vuagniaux.jf@com.mcnet.ch
*
****/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "soundent.h"
#include "gamerules.h"
#include "effects.h"
#include "decals.h"
#include "customentity.h"
//#include "pm_defs.h"


int m_Wsprite;
int m_Wsmoke;
float m_bowDamage;
int m_WInzoom;
int m_iWTrail;
int m_WWallSmoke;
BOOL m_StopEclair;

extern int gmsgPlayerEffects;//pour le message des effets du modele du joueur
extern int gmsgFade;

enum pist_e
{
	BOW_LONGIDLE = 0,
	BOW_IDLE1,
	BOW_RELOAD,
	BOW_DEPLOY,
	BOW_CHARGE,
	BOW_FIRE,
	BOW_HOLSTER,
	
};



//================================================================================
// Projectile de blaster pour les armes lgres de la companie BlasTech industries
//================================================================================

class CWBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity, int StartEclair );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_blastballs;
	int  m_blastglow;
	float m_flCreateTime;
	int nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol

};

LINK_ENTITY_TO_CLASS( wblaster, CWBlaster );

TYPEDESCRIPTION	CWBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CWBlaster, m_maxFrame, FIELD_INTEGER ),
	DEFINE_FIELD( CWBlaster, m_flCreateTime, FIELD_TIME ),
};

IMPLEMENT_SAVERESTORE( CWBlaster, CBaseEntity );


void CWBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "wblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blastvert.spr");
	pev->frame = 0;
	pev->scale = 0.3;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iWTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END(); 
	
	m_flCreateTime = gpGlobals->time;

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}

void CWBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 100 );		// r
			WRITE_BYTE( 255 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		Vector vecVelocity;
		

		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}
		
		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;//si la vitesse est trop basse on dtruit le blaster

		if ( vecVelocity.Length() < 1000 && m_flCreateTime + 4.0 < gpGlobals->time)//ajout un temps d'initialisation sinon le blaster est dtruit  sa cration en mode clair
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 8 );	
						WRITE_SHORT( m_Wsmoke );		// modle
						WRITE_BYTE( 4 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );

			m_StopEclair = TRUE;//pour supprimer l'clair immdiatement

			pev->nextthink = gpGlobals->time;
		}
	}
}

void CWBlaster::Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity, int StartEclair )
{
	CWBlaster *pBlast = GetClassPtr( (CWBlaster *)NULL );
	pBlast->Spawn();
	
	UTIL_SetOrigin( pBlast->pev, vecStart );
	pBlast->pev->velocity = vecVelocity;
	pBlast->pev->owner = ENT(pevOwner);
	pBlast->pev->iuser1 = StartEclair;

	pBlast->SetThink ( Animate );
	pBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CWBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iPitch;
	m_blastglow = m_Wsprite;
	m_blastballs = m_Wsprite;

	Vector vecDirImpact;
	
	Vector vecTrOrigin;
	//float	m_flVitesse;
	
	iPitch = RANDOM_FLOAT( 90, 110 );

	m_StopEclair = TRUE;//pour supprimer l'clair immdiatement

	entvars_t *pevAttacker = NULL;
	if ( pev->owner )
	{
		pevAttacker = VARS(pev->owner);
	}

	if ( pev->owner == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	//ALERT( at_console, "Touche %s\n", STRING(pOther->pev->classname));


	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		pev->owner = NULL;//on dfini le propritaire comme NULL pour que le joueur puisse tre touch aprs un ricochet

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}
	
	
	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			//ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		if ( !pOther->pev->takedamage )
		{
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );

				

				pev->nextthink = gpGlobals->time;

				return;

			}

			
			//sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
		

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_blastglow );				// modle
						WRITE_BYTE( 40 );	// dure
						WRITE_BYTE( 3 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_blastballs );		// modle
						WRITE_BYTE( 8 );				// nombre
						WRITE_BYTE( 6 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 18);	
						WRITE_SHORT( m_WWallSmoke );		// modle
						WRITE_BYTE( 12 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else
		{

			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
			Vector centre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( centre.x );	// position
					WRITE_COORD( centre.y );	
					WRITE_COORD( centre.z + 6 );	
					WRITE_SHORT( m_Wsmoke );		// modle
					WRITE_BYTE( 3 );				//taille * 10
					WRITE_BYTE( 255 );			//luminosit
				MESSAGE_END();
			
				
					
				m_bowDamage = 1;
			// plus de dommages avec la lunette de vise

				if ( m_WInzoom )
				{
					m_bowDamage = 2;
				}

				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg * m_pistDamage, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, (gSkillData.blasterDmg * m_bowDamage) * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
					
			
				ApplyMultiDamage( pev, pevAttacker );
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

//======================================================================
// Arbalte blaster  polarisateurs des Wookies
//======================================================================

class CBowcaster : public CBasePlayerWeapon
{
public:
	int		Save( CSave &save );
	int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];
	
	void Spawn( void );	
	void Precache( void );
	int iItemSlot( void ) { return 3; }
	int GetItemInfo(ItemInfo *p);
	int AddToPlayer( CBasePlayer *pPlayer );
	void PrimaryAttack( void );
	void SecondaryAttack ( void );
	BOOL Deploy( void );
	void Holster( int skiplocal = 0 );
	void Reload( void );
	void WeaponIdle( void );
	Vector GetGunPosition( void );
	float m_flNextAnimTime;
	void Shoot( void );
	void Eclair( entvars_t *pevOwner, Vector vecOrigin, Vector vecDir, int m_charge );
	void Zap( void );
	void MultiShoot( entvars_t *pevOwner, Vector vecOrigin, Vector vecDir, int m_charge );
	int m_charge;  // niveau de charge des polarisateurs
	float m_flStartCharge; //dbut de la charge
	int pitch;
	CBeam *m_pEclair;
	void EXPORT CreateEclair(void);
	void UpdateEclair( void );
	void DestroyEclair( void );
	CBaseEntity *pStart;
	CBaseEntity *pEnd;
	Vector vecSearch;
	entvars_t *pevBlastOwner;
	void StartEffect(void);
	void DestroyEffect(void);
	void UpdateEffect(void);
	CBeam *m_pArc;
	BOOL m_ShouldUpdate;
	float m_flGlowStart;
	void GlowEffect( entvars_t *pEntity, float m_StartTime, float m_flDuree);
	BOOL m_GlowPlayer;
	int GlowOn;
	int m_GlowPower;
	
	
	
};
LINK_ENTITY_TO_CLASS( weapon_bowcaster, CBowcaster );

TYPEDESCRIPTION	CBowcaster::m_SaveData[] = 
{
	//DEFINE_FIELD( CBowcaster, m_pEclair, FIELD_CLASSPTR ),
	//DEFINE_FIELD( CBowcaster, m_pArc, FIELD_CLASSPTR ),
	//DEFINE_FIELD( CBowcaster, pStart, FIELD_CLASSPTR ),
	//DEFINE_FIELD( CBowcaster, pEnd, FIELD_CLASSPTR ),
	DEFINE_FIELD( CBowcaster, m_flNextAnimTime, FIELD_TIME ),
	DEFINE_FIELD( CBowcaster, m_charge, FIELD_INTEGER ),
	DEFINE_FIELD( CBowcaster, GlowOn, FIELD_INTEGER ),
	DEFINE_FIELD( CBowcaster, m_GlowPower, FIELD_INTEGER ),
	DEFINE_FIELD( CBowcaster, m_flStartCharge, FIELD_TIME ),
	DEFINE_FIELD( CBowcaster, m_flGlowStart, FIELD_TIME ),
	DEFINE_FIELD( CBowcaster, m_ShouldUpdate, FIELD_BOOLEAN ),
	DEFINE_FIELD( CBowcaster, m_GlowPlayer, FIELD_BOOLEAN ),
};
IMPLEMENT_SAVERESTORE( CBowcaster, CBasePlayerWeapon );

//=========================================================
//=========================================================

void CBowcaster::Spawn( )
{
	pev->classname = MAKE_STRING("weapon_bowcaster"); 
	Precache( );
	SET_MODEL(ENT(pev), "models/w_bowcaster.mdl");
	m_iId = WEAPON_BOWCASTER;
	

/*	//debut glowshell
	pev->rendermode = kRenderNormal;

	pev->renderamt = 255;

	pev->rendercolor.x = 0;

	pev->rendercolor.y = 0;

	pev->rendercolor.z = 255;

	pev->renderamt = 10;

	pev->renderfx = kRenderFxGlowShell;

	//fin glowshell
*/

	pev->iuser3 = 1;
	m_iDefaultAmmo = BOWCASTER_DEFAULT_GIVE;

	FallInit();// prt  tomber au sol.
}


void CBowcaster::Precache( void )
{
	PRECACHE_MODEL("models/v_bowcaster.mdl");
	PRECACHE_MODEL("models/w_bowcaster.mdl");
	PRECACHE_MODEL("models/p_bowcaster.mdl");

	PRECACHE_MODEL("sprites/blastvert.spr");

	PRECACHE_MODEL("models/w_strifleclip.mdl");
	PRECACHE_SOUND("items/strfclip1.wav");              

	PRECACHE_SOUND("items/clipinsert.wav");	// les sons de recharges sont dfinis dans le ficier strifle.qc
	PRECACHE_SOUND("items/cliprelease.wav");	// ils sont lancs lors de l'animation de recharge.
	PRECACHE_SOUND ("weapons/chute1.wav");

	PRECACHE_SOUND ("weapons/bow1.wav");
	PRECACHE_SOUND ("weapons/bow2.wav");
    PRECACHE_SOUND ("weapons/polarise.wav");
	PRECACHE_SOUND ("weapons/chargeup.wav");
	PRECACHE_SOUND ("weapons/electro.wav");
	
	PRECACHE_SOUND ("weapons/choc1.wav");
	PRECACHE_SOUND ("weapons/choc2.wav");
	PRECACHE_SOUND ("weapons/choc3.wav");
	PRECACHE_SOUND ("weapons/choc4.wav");
	PRECACHE_SOUND ("weapons/grill.wav");

	m_Wsprite = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_Wsmoke = PRECACHE_MODEL( "sprites/blasthit.spr" );
	m_iWTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_WWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
	PRECACHE_MODEL( "sprites/blastvert.spr" );
	PRECACHE_MODEL( "sprites/lgtning.spr" );
	

}

int CBowcaster::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "bowcel";
	p->iMaxAmmo1 = _ENERCEL_MAX_CARRY;
	p->iMaxClip = STRF_MAX_CLIP;
	p->iSlot = 2;
	p->iPosition = 1;
	p->iFlags = 0;
	p->iId = m_iId = WEAPON_BOWCASTER;
	p->iWeight = BOWCASTER_WEIGHT;

	return 1;
}

int CBowcaster::AddToPlayer( CBasePlayer *pPlayer )
{
	if ( CBasePlayerWeapon::AddToPlayer( pPlayer ) )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
			WRITE_BYTE( m_iId );
		MESSAGE_END();
		return TRUE;
	}
	return FALSE;
}

BOOL CBowcaster::Deploy( )
{
	return DefaultDeploy( "models/v_bowcaster.mdl", "models/p_bowcaster.mdl", BOW_DEPLOY, "bowcaster" );
	m_charge = 0;
	GlowOn = 0;
}

Vector CBowcaster :: GetGunPosition( )
{
	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); 
	return vecArmPos;
}

void CBowcaster::PrimaryAttack()
{
	/*
	if ( m_GlowPlayer )
	{
		m_pPlayer->pev->renderamt = 10; 
		m_pPlayer->pev->rendermode = kRenderTransAlpha;
		m_GlowPlayer = 0;
	}
	else
	{
		m_pPlayer->pev->renderamt = 255; 
		m_pPlayer->pev->renderfx = kRenderFxNone; 
		m_pPlayer->pev->rendermode = kRenderNormal;
		m_GlowPlayer = 1;
	}


*/
	// ne pas tirer sous l'eau
	if (m_pPlayer->pev->waterlevel == 3)
	{
		if ( m_charge != 0 )
		{
			
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/electro.wav", 1.0, ATTN_NORM);//lance le bruit de polarisation
			Zap();//lectrochoc si on entre dans l'eau pendant la charge
		}
		else
		{
			PlayEmptySound( );
		}
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;
		return;
	}

	

	m_pPlayer->m_iWeaponVolume = NORMAL_GUN_VOLUME;
	m_pPlayer->m_iWeaponFlash = NORMAL_GUN_FLASH;
	
	if ( m_charge == 0 )//on vient de presser sur la dtente
	{
		if (m_iClip <= 0)//si plus de munitions
			{
				PlayEmptySound();
				m_flNextPrimaryAttack = gpGlobals->time + 0.5;
				return;
			}

		StartEffect();//dmarre l'effet d'arc lectrique de polarisation

		m_ShouldUpdate = TRUE;
		
		m_iClip--;//on retire une unit de munitions

		EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/polarise.wav", 1.0, ATTN_NORM);//lance le bruit de polarisation

		SendWeaponAnim( BOW_CHARGE );
		m_flNextAnimTime = gpGlobals->time + 0.5;
		
		m_charge = 1;

		m_flStartCharge = gpGlobals->time ;

	}
	
	if ( m_flNextAnimTime < gpGlobals->time )
	{

		if ( m_charge == 1)//change le son de polarisation pour un son de charge
		{
			STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/polarise.wav");//stoppe le bruit de polarisation
		
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/chargeup.wav", 1.0, ATTN_NORM, 0, 80 );
	
		}
		else //rend le son plus agu  chaque charge
		{
			STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/chargeup.wav");
		
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/chargeup.wav", 1.0, ATTN_NORM, 0, 80 + pitch );
		}
		
		if ( m_WInzoom )//pas de charge additionnelle si en mode lunette
		{
			m_flNextPrimaryAttack = gpGlobals->time + 0.5;
			Shoot();
			
		}
	
		SendWeaponAnim( BOW_CHARGE );
		m_flNextAnimTime = gpGlobals->time + 0.5;

		m_iClip--; //retire une unit chaque 0.5 seconde
		m_charge++; // augmente la charge

		pitch = pitch + 5;
	}
	
	if ( m_iClip <= 0 )
	{
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;
		Shoot();

	}

	if ( m_flStartCharge + 4.0 < gpGlobals->time )//lectrocution aprs 4 secondes de charge
		Zap();
	
	
	m_flTimeWeaponIdle = gpGlobals->time + 0.1;//prochaine animation de pause dans 0.1 seconde pour pouvoir dclencher le tir

		
}

void CBowcaster::Shoot(void)
{
	
	DestroyEffect();//supprime l'arc de polarisation

	m_ShouldUpdate = FALSE;

	if ( m_charge == 1 )//tir d'un seul coup normal
	{
		SendWeaponAnim( BOW_FIRE );
				
		
		STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/polarise.wav");//stoppe le bruit de polarisation

		STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/chargeup.wav");//stoppe le son de charge
				

		m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;

		// animation de tir du joueur
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

		
		EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/bow1.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); 
		

		UTIL_MakeVectors( m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle );

		//modifier pour prendre en compte le dsalignement de la main par rapport  la ligne de vise 
		//car le coup porte trop bas  droite:
		//
		//tracer une ligne avec le vecteur: vector aiming et trouver le point d'impacte
		//corriger le vecteur de tir en consquence.
		
		Vector vecSrc	 = m_pPlayer->GetGunPosition( ) ; //point de vise du HUD
		Vector vecAiming = m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );
		
		TraceResult tr;
		UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

		vecSrc = vecSrc + gpGlobals->v_forward * 35 + gpGlobals->v_right * 0 + gpGlobals->v_up * -8;//position du canon
		
		vecAiming = tr.vecEndPos - vecSrc;
		
		vecAiming = vecAiming.Normalize();

		// fin de correction

		if ( ! m_WInzoom )
		{
		
		
		Vector vecRight = gpGlobals->v_right;
		Vector vecUp = gpGlobals->v_up;

		float x, y, z;
		
				x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
				y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
				z = x*x+y*y;
		
		Vector vecSpread = VECTOR_CONE_1DEGREES ;
		vecAiming = vecAiming + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;

		}
		
	// code pour tirer un projectile de blaster
		
		CWBlaster::Shoot(m_pPlayer->pev,vecSrc,vecAiming * 2000, 0);
		
		UTIL_MakeVectors( m_pPlayer->pev->v_angle );
		
		if (!m_iClip && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)
			// la combinaison HEV indique : plus de munitions
			m_pPlayer->SetSuitUpdate("!HEV_AMO0", FALSE, 0);

		m_flNextPrimaryAttack = m_flNextPrimaryAttack + 0.5;
		if (m_flNextPrimaryAttack < gpGlobals->time)
			m_flNextPrimaryAttack = gpGlobals->time + 0.5;

		m_GlowPower = 1;
		m_charge = 0;//remise  zro de la charge


		m_pPlayer->pev->punchangle.x = RANDOM_FLOAT( -2, 2 );
	}

	if ( m_charge > 1 )
	{

		SendWeaponAnim( BOW_FIRE );
				
		
		STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/polarise.wav");//stoppe le bruit de polarisation

		STOP_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/chargeup.wav");//stoppe le son de charge
				

		m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;

		// animation de tir du joueur
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

		
		EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/bow2.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); 
		

		UTIL_MakeVectors( m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle );

		//modifier pour prendre en compte le dsalignement de la main par rapport  la ligne de vise 
		//car le coup porte trop bas  droite:
		//
		//tracer une ligne avec le vecteur: vector aiming et trouver le point d'impacte
		//corriger le vecteur de tir en consquence.
		
		Vector vecSrc	 = m_pPlayer->GetGunPosition( ) ; //point de vise du HUD
		Vector vecAiming = m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );
		
		TraceResult tr;
		UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

		vecSrc = vecSrc + gpGlobals->v_forward * 35 + gpGlobals->v_right * 0 + gpGlobals->v_up * -8;//position du canon
		
		vecAiming = tr.vecEndPos - vecSrc;
		
		vecAiming = vecAiming.Normalize();

		// fin de correction

		if ( g_pGameRules->IsMultiplayer() == 0 )
		{
			Eclair(m_pPlayer->pev, vecSrc, vecAiming, m_charge);//tir de deux blaster avec clair
		}
		else//tir de plusieurs projectiles en evantail
		{
			MultiShoot(m_pPlayer->pev, vecSrc, vecAiming, m_charge);
		}
		
		UTIL_MakeVectors( m_pPlayer->pev->v_angle );
		
		if (!m_iClip && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)
			// la combinaison HEV indique : plus de munitions
			m_pPlayer->SetSuitUpdate("!HEV_AMO0", FALSE, 0);

		m_flNextPrimaryAttack = m_flNextPrimaryAttack + 0.5;
		if (m_flNextPrimaryAttack < gpGlobals->time)
			m_flNextPrimaryAttack = gpGlobals->time + 0.5;

		m_GlowPower = m_charge;//pour l'effet de GlowShell

		m_charge = 0;//remise  zro de la charge


		m_pPlayer->pev->punchangle.x = RANDOM_FLOAT( -2, 2 );
	}

}
//==============================================
//Tir d'une srie de blasters en vantail
//==============================================
void CBowcaster::MultiShoot(entvars_t *pevOwner, Vector vecOrigin, Vector vecDir, int m_charge)
{
	int i;
	Vector vecDir1 = ((vecDir * 28) + gpGlobals->v_right).Normalize();
	Vector vecDir2 = ((vecDir * 28) - gpGlobals->v_right).Normalize();
	Vector vecDir3 = ((vecDir * 10) + gpGlobals->v_right).Normalize();
	Vector vecDir4 = ((vecDir * 10) - gpGlobals->v_right).Normalize();
	Vector vecDir5 = ((vecDir * 6) + gpGlobals->v_right).Normalize();
	Vector vecDir6 = ((vecDir * 6) - gpGlobals->v_right).Normalize();
	Vector vecDir7 = ((vecDir * 4) + gpGlobals->v_right).Normalize();
	Vector vecDir8 = ((vecDir * 4) - gpGlobals->v_right).Normalize();

	for ( i=1; i<=m_charge; i=i+1)
	{
		if ( i == 1 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir1 * 2000, 0);
		}
		if ( i == 2 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir2 * 2000, 0);
		}
		if ( i == 3 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir3 * 2000, 0);
		}
		if ( i == 4 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir4 * 2000, 0);
		}
		if ( i == 5 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir5 * 2000, 0);
		}
		if ( i == 6 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir6 * 2000, 0);
		}
		if ( i == 7 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir7 * 2000, 0);
		}
		if ( i == 8 )
		{
			CWBlaster::Shoot(m_pPlayer->pev, vecOrigin, vecDir8 * 2000, 0);
		}
		
	}
}

//==============================================
//Tir de deux boules lies par un arc lectrique
//==============================================
void CBowcaster::Eclair(entvars_t *pevOwner, Vector vecOrigin, Vector vecDir, int m_charge)
{

	vecSearch = vecOrigin + gpGlobals->v_forward * 0; //point de dpart de la recherche des blasters
	pevBlastOwner = pevOwner; //propritaire des blasters

	//cration des deux vecteur de directions

	Vector vecDir1 = ((vecDir * 3) + gpGlobals->v_right).Normalize();
	Vector vecDir2 = ((vecDir * 3) - gpGlobals->v_right).Normalize();

	CWBlaster::Shoot(m_pPlayer->pev,vecOrigin + (gpGlobals->v_forward * 10) + (gpGlobals->v_right * 2),vecDir1, 2);//blaster de dpart avec vitesse 1
	
	CWBlaster::Shoot(m_pPlayer->pev,vecOrigin + (gpGlobals->v_forward * 10) - (gpGlobals->v_right * 2),vecDir2, 1);//blaster d'arrive avec vitesse 1

	SetThink( CreateEclair );//pour laisser le temps aux blasters d'apparatre
	pev->nextthink = gpGlobals->time + 0.1;

	
}

void CBowcaster::CreateEclair( void )
{
	float m_flRayon = 20;
	CBaseEntity *pEntity = NULL;
	int count = 0;
	
	

	DestroyEclair();
	
	while ((pEntity = UTIL_FindEntityInSphere( pEntity, vecSearch, m_flRayon)) != NULL)
	{

		if ( pEntity->pev->classname == MAKE_STRING( "wblaster" ))

		{

			if ( pEntity->pev->iuser1 == 2 )
			{

				//ALERT( at_console, "DEPART\n");
				pStart = pEntity;
			}
			else if (pEntity->pev->iuser1 == 1 )
			{

				//ALERT( at_console, "ARRIVEE\n");
				pEnd = pEntity;
			}
			else 
			{

				
				pStart = NULL;
				pEnd = NULL;
			}
			count++;


		}
	}

	//ALERT( at_console, "COUNT %d\n", count);


	if ( pStart && pEnd)
	{
		pStart->pev->velocity = pStart->pev->velocity * 500;
		pEnd->pev->velocity = pEnd->pev->velocity * 500;

		m_StopEclair = FALSE;
		
		m_pEclair = CBeam::BeamCreate("sprites/lgtning.spr", 30 );

		m_pEclair->EntsInit( pStart->entindex(), pEnd->entindex() );

		m_pEclair->pev->spawnflags |= SF_BEAM_TEMPORARY;
	
		m_pEclair->SetScrollRate( 50 );
		m_pEclair->SetNoise( 40 );
		m_pEclair->SetColor( 0, 255, 0 );
		m_pEclair->SetBrightness( 255 );
		m_pEclair->SetWidth( 30 );
	
	}
}

void CBowcaster::UpdateEclair( void )
{
	TraceResult tr;

	if ( m_StopEclair )
	{
		//ALERT( at_console, "TERMINE\n");

		DestroyEclair();
		return;
	}

	if ( m_pEclair )//code pour endommager une entit qui se trouve dans le chemin de l'clair
	{

		UTIL_TraceLine ( pStart->pev->origin, pEnd->pev->origin, ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

		if ( tr.flFraction < 1.0 )//l'clair est interrompu par un mur
		{

			DestroyEclair();
			return;

		}

		UTIL_TraceLine ( pStart->pev->origin, pEnd->pev->origin, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

		if ( tr.flFraction < 1.0 )
		{

			CBaseEntity *pEntity = CBaseEntity::Instance(tr.pHit);
			
			if ( pEntity && pEntity->pev->takedamage )//l'clair est interrompu par un monstre
			{

				GlowEffect( pEntity->pev, gpGlobals->time, 1.0 * m_GlowPower);//effet de glowshell

				ClearMultiDamage( );

				pEntity->TakeDamage(m_pEclair->pev, pevBlastOwner, (gSkillData.blasterDmg * m_GlowPower) / 3, DMG_SHOCK); 

				ApplyMultiDamage( m_pEclair->pev, pevBlastOwner );
			}
		}

	}
	
	//remise  jour de l'clair
	DestroyEclair();

	if ( pStart && pEnd)
	{
	
		m_pEclair = CBeam::BeamCreate("sprites/lgtning.spr", 30 );

		m_pEclair->EntsInit( pStart->entindex(), pEnd->entindex() );

		m_pEclair->pev->spawnflags |= SF_BEAM_TEMPORARY;
	
		m_pEclair->SetScrollRate( 50 );
		m_pEclair->SetNoise( 40 );
		m_pEclair->SetColor( 0, 255, 0 );
		m_pEclair->SetBrightness( 255 );
		m_pEclair->SetWidth( 30 );
	
	}

}

void CBowcaster::DestroyEclair( void )
{

	if ( m_pEclair )
	{
		UTIL_Remove( m_pEclair );
		m_pEclair = NULL;

	}

}


//================================
//Electrocution du joueur
//================================
void CBowcaster::Zap(void)
{

	m_pPlayer->TakeDamage( VARS(eoNullEntity), VARS(eoNullEntity), 50, DMG_SHOCK );

	DestroyEffect();

	m_ShouldUpdate = FALSE;

	
	m_pPlayer->pev->rendermode = kRenderNormal;

	m_pPlayer->pev->renderamt = 255;

	m_pPlayer->pev->rendercolor.x = 0;

	m_pPlayer->pev->rendercolor.y = 255;

	m_pPlayer->pev->rendercolor.z = 0;

	m_pPlayer->pev->renderamt = 15;

	m_pPlayer->pev->renderfx = kRenderFxGlowShell;

			

	//message vers le client pour appliquer l'effet sur le modle viemodel (mains/arme)
			
	MESSAGE_BEGIN(MSG_ONE, gmsgPlayerEffects, NULL, m_pPlayer->pev);

	WRITE_BYTE(kRenderFxGlowShell);
	WRITE_BYTE(1);
	WRITE_BYTE(0);
	WRITE_BYTE(255);
	WRITE_BYTE(0);
	WRITE_BYTE(15);

	MESSAGE_END();

	m_GlowPlayer = TRUE;
	
	m_flGlowStart = gpGlobals->time;

	m_charge = 0;//vide la charge

	m_iClip = 0;//vide le chargeur

}


//======================================================
//Effet d'arc lectrique sur les boules du polarisateur
//======================================================
void CBowcaster::StartEffect(void)
{
	if ( g_pGameRules->IsMultiplayer() == 0 )//pas d'arc en multijoueurs  cause des attachements
	{

		m_pArc = CBeam::BeamCreate("sprites/lgtning.spr", 30 );

		m_pArc->EntsInit( m_pPlayer->entindex(), m_pPlayer->entindex() );
		m_pArc->SetEndAttachment( 1 );
		m_pArc->SetStartAttachment( 2 );

		m_pArc->pev->spawnflags |= SF_BEAM_TEMPORARY;
	
		m_pArc->SetScrollRate( 50 );
		m_pArc->SetNoise( 50 );
		m_pArc->SetColor( 3, 255, 50 );
		m_pArc->SetBrightness( 255 );
		m_pArc->SetWidth( 20 );
	}

}


//======================================================
//Annulation de l'arc de polarisation
//======================================================
void CBowcaster::DestroyEffect(void)
{

	if ( g_pGameRules->IsMultiplayer() == 0 )//pas d'arc en multijoueurs  cause des attachements
	{
			if ( m_pArc )
		{
			UTIL_Remove( m_pArc );
			m_pArc = NULL;

		}
	}

}

//======================================================
//Mise  jour de l'arc de polarisation
//======================================================
void CBowcaster::UpdateEffect(void)
{

	if ( g_pGameRules->IsMultiplayer() == 0 )//pas d'arc en multijoueurs  cause des attachements
	{
		if ( m_ShouldUpdate )
		{
			DestroyEffect();

			m_pArc = CBeam::BeamCreate("sprites/lgtning.spr", 15 );

			m_pArc->EntsInit( m_pPlayer->entindex(), m_pPlayer->entindex() );
			m_pArc->SetEndAttachment( 1 );
			m_pArc->SetStartAttachment( 2 );

			m_pArc->pev->spawnflags |= SF_BEAM_TEMPORARY;
		
			m_pArc->SetScrollRate( 50 );
			m_pArc->SetNoise( 80 );
			m_pArc->SetColor( 3, 255, 130 );
			m_pArc->SetBrightness( 255 );
			m_pArc->SetWidth( 20 );

		}
	}
}

//========================================================
//Effet de glowshell sur les victimes
//========================================================

void CBowcaster::GlowEffect( entvars_t *pEntity, float m_StartTime, float m_flDuree)
{

	ALERT(at_console, "DUREE %f\n", m_flDuree);

	pEntity->rendermode = kRenderNormal;

	pEntity->renderamt = 255;

	pEntity->rendercolor.x = 0;

	pEntity->rendercolor.y = 255;

	pEntity->rendercolor.z = 0;

	pEntity->renderamt = 15;

	pEntity->renderfx = kRenderFxGlowShell;

	pEntity->fuser1 = m_StartTime + m_flDuree / 2;//mise en mmoire du moment de fin de glowshell

	//le code de base des entits doit tre modifi pour pouvoir remettre l'effet normal aprs le dlais coul.


}



//==========================================
//vue avec lunette, coup normal suractiv
//==========================================
void CBowcaster::SecondaryAttack()
{
	
	if (m_WInzoom)
	{
		m_pPlayer->m_iFOV = 0; // 0 remet l'angle de vue normal
		m_WInzoom = 0;
	}
	else
	{
		m_pPlayer->m_iFOV = 20;
		m_WInzoom = 1;

	}
	
	m_flNextSecondaryAttack = gpGlobals->time + 0.5;
}


void CBowcaster::Reload( void )
{
	if (m_WInzoom)//pas de recharge en mode lunette
		SecondaryAttack();

	DefaultReload( STRF_MAX_CLIP, BOW_RELOAD, 4.0 );
}

void CBowcaster::Holster( int skiplocal )
{
	
	if ( m_WInzoom )
	{
		SecondaryAttack( ); // pour viter de rester avec le champs de vision de 20 
	}

}
void CBowcaster::WeaponIdle( void )
{
	
	if ( m_charge != 0 )//tire si il y a une charge
	{
		Shoot();
	}
	
	if ( m_GlowPlayer ) // effet de glowshell
	{

		if ( m_flGlowStart + 2.0 < gpGlobals->time )
		{
			m_GlowPlayer = FALSE;		
		}
			
		GlowOn = 1;

	}
	else if ( GlowOn )
	{

		m_pPlayer->pev->rendermode = kRenderNormal;

		m_pPlayer->pev->renderamt = 255;

		m_pPlayer->pev->renderfx = kRenderFxNone;

		
		MESSAGE_BEGIN(MSG_ONE, gmsgPlayerEffects, NULL, m_pPlayer->pev);

		WRITE_BYTE(kRenderFxGlowShell);
		WRITE_BYTE(0);
		WRITE_BYTE(0);
		WRITE_BYTE(0);
		WRITE_BYTE(0);
		WRITE_BYTE(255);

		MESSAGE_END();

		GlowOn = 0;

	}

	pitch = 0;

	UpdateEclair();//met  jour l'clair s'il y a lieu
	UpdateEffect();//met  jour l'arc de polarisation

	ResetEmptySound( );

	m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );

	if ( m_WInzoom ) 
		return;

	if (m_flTimeWeaponIdle > gpGlobals->time)
		return;

	int iAnim;
	switch ( RANDOM_LONG( 0, 1 ) )
	{
	case 0:	
		iAnim = BOW_LONGIDLE;	
		break;
	
	default:
	case 1:
		iAnim = BOW_IDLE1;
		break;
	}

	SendWeaponAnim( iAnim );

	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 5, 15 );// temps d'attente avant la prochaine animation.
}



// la munitions est spciale pour le bowcaster

class CBOWAmmoClip : public CBasePlayerAmmo // classe de la munitions du blaster
{
	void Spawn( void )
	{ 
		Precache( );
		SET_MODEL(ENT(pev), "models/w_bowclip.mdl");
		CBasePlayerAmmo::Spawn( );
	}
	void Precache( void )
	{
		PRECACHE_MODEL ("models/w_bowclip.mdl");
		PRECACHE_SOUND("items/strfclip1.wav");
	}
	BOOL AddAmmo( CBaseEntity *pOther ) 
	{ 
		int bResult = (pOther->GiveAmmo( AMMO_STRFCLIP_GIVE, "bowcel", _ENERCEL_MAX_CARRY) != -1);
		if (bResult)
		{
			EMIT_SOUND(ENT(pev), CHAN_ITEM, "items/strfclip1.wav", 1, ATTN_NORM);
		}
		return bResult;
	}
};
LINK_ENTITY_TO_CLASS( ammo_bowclip, CBOWAmmoClip );




















