/***
*
*	Code pour le commando des forces de l'empire
*
****/


//=========================================================
// commando - commando rapide avec strifle ou repeatergun
//=========================================================

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"monsters.h"
#include	"schedule.h"
#include	"squadmonster.h"
#include	"weapons.h"
#include	"soundent.h"
#include	"animation.h"


extern DLL_GLOBAL int  g_iSkillLevel;

int m_Cisprite;
int m_Cismoke;
int m_iCOTrail;
int m_iYcTrail;
int m_RWallSmoke; 

//=========================================================
// monster-specific schedule types
//=========================================================
enum
{
	SCHED_COMMANDO_EXPOSED = LAST_COMMON_SCHEDULE + 1,// plus  couvert
	SCHED_COMMANDO_JUMP_AWAY,  // saute en cas de blessure
	SCHED_COMMANDO_JUMP,	// saut
	SCHED_COMMANDO_JUMP_ATTACK,	// saute et tire
	SCHED_COMMANDO_JUMP_LAND, // tire et se met  couvert
	SCHED_COMMANDO_ESTABLISH_LINE_OF_FIRE,
	SCHED_COMMANDO_COVER_AND_RELOAD,
	SCHED_COMMANDO_ELOF_FAIL,
	SCHED_COMMANDO_RECHERCHE,
};

//=========================================================
// monster-specific tasks
//=========================================================

enum
{
	TASK_COMMANDO_FALL_TO_GROUND = LAST_COMMON_TASK + 1, // chute jusqu'au sol
};

//=========================================================
//Dfinition spcifiques
//=========================================================

#define	COMMANDO_CLIP_SIZE					50
#define COMMANDO_LIMP_HEALTH				20 
#define	COMMANDO_MELEE_DIST					100

#define COMMANDO_STRIFLE				( 1 << 0)	//strifle  numro	1	
#define COMMANDO_HANDGRENADE			( 1 << 1)	//thermal  numro	2
#define COMMANDO_REPEATER				( 1 << 2)	//repeater numro	4
													//strifle+thermal	3 ou 0 
													//repeater+thermal	6			

#define GUN_GROUP					1
#define GUN_STRIFLE					0
#define GUN_REPEATER				1
#define GUN_NONE					2

//=========================================================
// Monster's Anim Events Go Here
//=========================================================
#define		COMMANDO_AE_SHOOT1		1
#define		COMMANDO_AE_SHOOT2		2
#define		COMMANDO_AE_SHOOT3		3
#define		COMMANDO_AE_SHOOT4		4
#define		COMMANDO_AE_SHOOT5		5

#define		COMMANDO_AE_TOSS1		6

#define		COMMANDO_AE_JUMP		7
#define		COMMANDO_AE_RELOAD		8
#define		COMMANDO_AE_RELOAD2		9
#define		COMMANDO_AE_RIGHT_PUNCH		10
#define		COMMANDO_AE_LEFT_PUNCH		11
#define		COMMANDO_AE_DROP_GUN	12

#define bits_MEMORY_BADJUMP		(bits_MEMORY_CUSTOM1)
//=========================================================
// Projectile de blaster pour les Strifle des Stormtroopers de la companie BlasTech industries
//=========================================================

class CCBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_Mblastballs;
	int  m_Mblastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;

	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol
};

LINK_ENTITY_TO_CLASS( Cblaster, CCBlaster );

TYPEDESCRIPTION	CCBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CCBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CCBlaster, CBaseEntity );


void CCBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "Cblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blaster.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iCOTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}

void CCBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 255 );		// r
			WRITE_BYTE( 100 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		
		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_Cismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}


	
}

void CCBlaster::Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity )
{
	CCBlaster *pCBlast = GetClassPtr( (CCBlaster *)NULL );
	pCBlast->Spawn();
	
	UTIL_SetOrigin( pCBlast->pev, MvecStart );
	pCBlast->pev->velocity = MvecVelocity;
	pCBlast->pev->euser1 = ENT(pevOwner);
	pCBlast->pev->owner = NULL;// modifi pour que le ricochet du sabre l'atteigne

	pCBlast->SetThink ( Animate );
	pCBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CCBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iMPitch;
	m_Mblastglow = m_Cisprite;
	m_Mblastballs = m_Cisprite;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	// son de choc
	iMPitch = RANDOM_FLOAT( 90, 110 );

	entvars_t *pevAttacker = NULL;
	if ( pev->euser1 )
	{
		pevAttacker = VARS(pev->euser1);
	}

	if ( pev->euser1 == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}

	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{
	
		if ( !pOther->pev->takedamage )
		{
			
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			// sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

			// placer un decal sur les murs
		
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_Mblastglow );		// modle
						WRITE_BYTE( 30 );	// dure
						WRITE_BYTE( 2 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_Mblastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 16 );	
						WRITE_SHORT( m_RWallSmoke );		// modle
						WRITE_BYTE( 10 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

				
		
		}
		else
		{
			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

				Vector Mcentre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, Mcentre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( Mcentre.x );	// pos
					WRITE_COORD( Mcentre.y );	
					WRITE_COORD( Mcentre.z + 6 );	
					WRITE_SHORT( m_Cismoke );		// model
					WRITE_BYTE( 3 );				// size * 10
					WRITE_BYTE( 255 );			// brightness
				MESSAGE_END();
			
				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, gSkillData.blasterDmg * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
					

				ApplyMultiDamage( pev, pevAttacker);
			
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}


//=========================================================
// Projectile de blaster pour les Repeatergun des Commandos de la companie BlasTech industries
//=========================================================

class CRBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_Mblastballs;
	int  m_Mblastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol

	
};

LINK_ENTITY_TO_CLASS( Rblaster, CRBlaster );

TYPEDESCRIPTION	CRBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CRBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CRBlaster, CBaseEntity );


void CRBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "Rblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/yblaster.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iYcTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;
	m_flAttenuation = 1;
}

void CRBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 10 );		// radius * 0.1
			WRITE_BYTE( 50 );		// r
			WRITE_BYTE( 255 );		// g
			WRITE_BYTE( 255 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;


		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_Cismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}

}

void CRBlaster::Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity )
{
	CRBlaster *pRBlast = GetClassPtr( (CRBlaster *)NULL );
	pRBlast->Spawn();
	
	UTIL_SetOrigin( pRBlast->pev, MvecStart );
	pRBlast->pev->velocity = MvecVelocity;
	pRBlast->pev->euser1 = ENT(pevOwner);
	pRBlast->pev->owner = NULL;// modifi pour que le ricochet du sabre l'atteigne

	pRBlast->SetThink ( Animate );
	pRBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CRBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iMPitch;
	m_Mblastglow = m_Cisprite;
	m_Mblastballs = m_Cisprite;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	// son de choc
	iMPitch = RANDOM_FLOAT( 90, 110 );

	
	entvars_t *pevAttacker = NULL;
	if ( pev->euser1 )
	{
		pevAttacker = VARS(pev->euser1);
	}

	if ( pev->euser1 == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}


	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		if ( !pOther->pev->takedamage )
		{
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			
			// sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_Mblastglow );		// modle
						WRITE_BYTE( 20 );	// dure
						WRITE_BYTE( 1 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_Mblastballs );		// modle
						WRITE_BYTE( 3 );				// nombre
						WRITE_BYTE( 4 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 6 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 6 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 9 );	
						WRITE_SHORT( m_RWallSmoke );	// modle
						WRITE_BYTE( 6 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else
		{
			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

				Vector Mcentre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, Mcentre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( Mcentre.x );	// pos
					WRITE_COORD( Mcentre.y );	
					WRITE_COORD( Mcentre.z + 2 );	
					WRITE_SHORT( m_Cismoke );		// model
					WRITE_BYTE( 1 );				// size * 10
					WRITE_BYTE( 255 );			// brightness
				MESSAGE_END();
			
				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg / 2, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, (gSkillData.blasterDmg / 2) * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
				
				ApplyMultiDamage( pev, pevAttacker);

			
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

class CCommando : public CSquadMonster
{
public:
	void Spawn( void );
	void Precache( void );
	void SetYawSpeed ( void );
	int  Classify ( void );
	int  ISoundMask ( void);
	
	void Shoot( void );
	void Repeater( void );
	void CheckAmmo ( void );

	void HandleAnimEvent( MonsterEvent_t *pEvent );
	Schedule_t* GetSchedule ( void );
	Schedule_t* GetScheduleOfType ( int Type );
	
	BOOL CheckMeleeAttack1 ( float flDot, float flDist );	// saut	
	BOOL CheckRangeAttack1 ( float flDot, float flDist );	// tir
	BOOL CheckRangeAttack2 ( float flDot, float flDist );	// lancer de grenade
	
	void StartTask ( Task_t *pTask );
	void RunAI( void );
	void RunTask ( Task_t *pTask );
	void SetActivity ( Activity NewActivity );
	void TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType);
	int  TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType );
	void GibMonster ( void );
	void Killed( entvars_t *pevAttacker, int iGib );
	
	void DeathSound ( void );
	void IdleSound ( void );
	void AlertSound( void );
	void PainSound ( void );
	void AttackSound ( void );
	void StopTalking ( void );
	BOOL ShouldSpeak( void );
	void PrescheduleThink ( void );

	CUSTOM_SCHEDULES;
	Vector GetGunPosition( void );

	int	Save( CSave &save ); 
	int Restore( CRestore &restore );
	static TYPEDESCRIPTION m_SaveData[];

	float	m_flNextGrenadeCheck;
	Vector	m_vecTossVelocity;
	BOOL	m_fThrowGrenade;
	BOOL	m_fStanding;
	BOOL    m_jesuismort;
	int		m_ouille;

	float	m_flNextJump;
	Vector	m_vecJumpVelocity;

	int		m_iTargetRanderamt;

	int		m_iFrustration;
	int		m_cClipSize;

	static const char *pAttackHitSounds[];
	static const char *pAttackMissSounds[];
	static const char *pDieSounds[];
	static const char *pIdleSounds[];
	static const char *pAttackSounds[];
	static const char *pAlertSounds[];
	static const char *pPainSounds[];

	float	m_flNextPainTime;
	float	m_flNextSpeakTime;
	float	m_flNextWordTime;
	int		m_iLastWord;
	float   m_flNextAttackSound;
	float   m_flNextAlertSound;
		
};
LINK_ENTITY_TO_CLASS( monster_commando, CCommando );

const char *CCommando::pAttackHitSounds[] = 
{
	"zombie/claw_strike1.wav",
	"zombie/claw_strike2.wav",
	"zombie/claw_strike3.wav",
};

const char *CCommando::pAttackMissSounds[] = 
{
	"zombie/claw_miss1.wav",
	"zombie/claw_miss2.wav",
};

const char *CCommando::pAttackSounds[] =
{
	"commando/co_attack1.wav",
	"commando/co_attack2.wav",
	"commando/co_attack3.wav",
};

const char *CCommando::pDieSounds[] =
{
	"commando/co_die1.wav",
	"commando/co_die2.wav",
	"commando/co_die3.wav",
};

const char *CCommando::pPainSounds[] =
{
	"commando/co_pain1.wav",
	"commando/co_pain2.wav",
	"commando/co_pain3.wav",
	"commando/co_pain4.wav",
	"commando/co_pain5.wav",
};

const char *CCommando::pIdleSounds[] =
{
	"commando/co_idle1.wav",
	"commando/co_idle2.wav",
	"commando/co_idle3.wav",
	"commando/co_idle4.wav",
};

const char *CCommando::pAlertSounds[] =
{
	"commando/co_alert1.wav",
	"commando/co_alert2.wav",
	"commando/co_alert3.wav",
	"commando/co_alert4.wav",
};


TYPEDESCRIPTION	CCommando::m_SaveData[] = 
{
	DEFINE_FIELD( CCommando, m_flNextPainTime, FIELD_TIME ),
	DEFINE_FIELD( CCommando, m_flNextSpeakTime, FIELD_TIME ),
	DEFINE_FIELD( CCommando, m_flNextWordTime, FIELD_TIME ),
	DEFINE_FIELD( CCommando, m_iLastWord, FIELD_INTEGER ),

	DEFINE_FIELD( CCommando, m_flNextGrenadeCheck, FIELD_TIME ),
	DEFINE_FIELD( CCommando, m_vecTossVelocity, FIELD_VECTOR ),
	DEFINE_FIELD( CCommando, m_fThrowGrenade, FIELD_BOOLEAN ),

	DEFINE_FIELD( CCommando, m_flNextJump, FIELD_TIME ),
	DEFINE_FIELD( CCommando, m_vecJumpVelocity, FIELD_VECTOR ),

	DEFINE_FIELD( CCommando, m_iTargetRanderamt, FIELD_INTEGER ),
	DEFINE_FIELD( CCommando, m_iFrustration, FIELD_INTEGER ),
	
	DEFINE_FIELD( CCommando, m_cClipSize, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CCommando, CBaseMonster );



//=========================================================
// TraceAttack
//=========================================================
void CCommando :: TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	
		m_LastHitGroup = ptr->iHitgroup;

		switch ( ptr->iHitgroup )
		{
		case HITGROUP_GENERIC:
			break;
		case HITGROUP_HEAD:
			flDamage *= gSkillData.monHead;
			break;
		case HITGROUP_CHEST:
			flDamage *= gSkillData.monChest;
			break;
		case HITGROUP_STOMACH:
			flDamage *= gSkillData.monStomach;
			break;
		case HITGROUP_LEFTARM:
		case HITGROUP_RIGHTARM:
			flDamage *= gSkillData.monArm;
			break;
		case HITGROUP_LEFTLEG:
		case HITGROUP_RIGHTLEG:
			flDamage *= gSkillData.monLeg;
			break;
		default:
			break;
		}

		if ( bitsDamageType == DMG_SABER ) // pour comprendre, il faut couper la tte!
		{
			if ( ptr->iHitgroup == HITGROUP_HEAD )
			{
				if ( pev->health <= flDamage )
				{
					// code pour changer le modle (sans tte), 
					// crer une tte qui va rouler et jouer l'animation de mort correspondante.	
				}
			}
		}

		SpawnBlood(ptr->vecEndPos, BloodColor(), flDamage);
		TraceBleed( flDamage, vecDir, ptr, bitsDamageType );

	
	m_ouille = 1;

	AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType ); 
}

int CCommando :: TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType )
{
	Forget( bits_MEMORY_INCOVER );

	m_ouille = 1;

	
	return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );
}

void CCommando::Killed( entvars_t *pevAttacker, int iGib )
{
	
	CBaseMonster::Killed( pevAttacker, GIB_NORMAL );


}

//=========================================================
// projette une arme
//=========================================================
 
void CCommando :: GibMonster ( void )
{
	Vector	vecGunPos;
	Vector	vecGunAngles;

	if (m_jesuismort)
	{
		return;
	}

	if ( GetBodygroup( 1 ) != 2 )
	{
		GetAttachment( 0, vecGunPos, vecGunAngles );
		
		CBaseEntity *pGun;
		
			if ( FBitSet( pev -> weapons , COMMANDO_STRIFLE ))
			{
			pGun = DropItem( "weapon_strifle", vecGunPos, vecGunAngles );
			}
			else
			{
			pGun = DropItem( "weapon_repeatergun", vecGunPos, vecGunAngles );
			}
	
		if ( pGun )
		{
			pGun->pev->velocity = Vector (RANDOM_FLOAT(-100,100), RANDOM_FLOAT(-100,100), RANDOM_FLOAT(200,300));
			pGun->pev->avelocity = Vector ( 0, RANDOM_FLOAT( 200, 400 ), 0 );
		}
	
		
	}

	CBaseMonster :: GibMonster();
}

//=========================================================
// DieSound
//=========================================================
void CCommando :: DeathSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pDieSounds[RANDOM_LONG(0,ARRAYSIZE(pDieSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// IdleSound
//=========================================================
void CCommando :: IdleSound ( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		return;
	}

	m_flNextSpeakTime = gpGlobals->time + 10;

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1)], 1.0, ATTN_NORM );

}

//=========================================================
// AlertSound
//=========================================================
void CCommando :: AlertSound( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAlertSounds[RANDOM_LONG(0,ARRAYSIZE(pAlertSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AttackSound
//=========================================================
void CCommando :: AttackSound ( void )
{
		StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// PainSound
//=========================================================
void CCommando :: PainSound ( void )
{
	if ( m_flNextPainTime > gpGlobals->time )
	{
		return;
	}

	m_flNextPainTime = gpGlobals->time + 0.6;

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pPainSounds[RANDOM_LONG(0,ARRAYSIZE(pPainSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// StopTalking - ne parle plus pendant 10-20 secondes
//=========================================================
void CCommando::StopTalking( void )
{
	m_flNextWordTime = m_flNextSpeakTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);
}

//=========================================================
// ShouldSpeak - est-ce qu'il doit parler?
//=========================================================
BOOL CCommando::ShouldSpeak( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		
		return FALSE;
	}

	if ( pev->spawnflags & SF_MONSTER_GAG )
	{
		if ( m_MonsterState != MONSTERSTATE_COMBAT )
		{
			// si 'gag' est mis il ne parle pas hors du combat
			// on repousse un peu plus loim
			m_flNextSpeakTime = gpGlobals->time + 3;
			return FALSE;
		}
	}

	return TRUE;
}

//=========================================================
// PrescheduleThink 
//=========================================================
void CCommando :: PrescheduleThink ( void )
{
	if ( ShouldSpeak() )
	{
		if ( m_flNextWordTime < gpGlobals->time )
		{
			int num = -1;

			switch	( m_MonsterState )
				{
				case MONSTERSTATE_IDLE:
					{
			
						do
						{
							num = RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1);
						} while( num == m_iLastWord );

						m_iLastWord = num;

						
						EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[ num ], 1.0, ATTN_NORM );
					}
					break;
				
				case MONSTERSTATE_COMBAT:// faut tre logique 
					{
			
						do
						{
							num = RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1);
						} while( num == m_iLastWord );

						m_iLastWord = num;

						
						EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[ num ], 1.0, ATTN_NORM );
					}
					break;

				}

			
			if ( RANDOM_LONG( 1, 10 ) <= 7 )
			{
				
				StopTalking();
			}
			else
			{
				m_flNextWordTime = gpGlobals->time + RANDOM_FLOAT( 4, 8 );
			}
		}
	}
}
//=========================================================
// ISoundMask - returns a bit mask indicating which types
// of sounds this monster regards. 
//=========================================================
int CCommando :: ISoundMask ( void) 
{
	return	bits_SOUND_WORLD	|
			bits_SOUND_COMBAT	|
			bits_SOUND_DANGER	|
			bits_SOUND_PLAYER;
}


//=========================================================
// Classify - indicates this monster's place in the 
// relationship table.
//=========================================================
int	CCommando :: Classify ( void )
{
	return	CLASS_HUMAN_MILITARY;
}

//=========================================================
// SetYawSpeed - allows each sequence to have a different
// turn rate associated with it.
//=========================================================
void CCommando :: SetYawSpeed ( void )
{
	int ys;

	switch ( m_Activity )
	{
	case ACT_TURN_LEFT:
	case ACT_TURN_RIGHT:
		ys = 360;
		break;
	default:			
		ys = 360;
		break;
	}

	pev->yaw_speed = ys;
}


//=========================================================
// GetGunPosition	donne l'extrmit du canon
//=========================================================

Vector CCommando :: GetGunPosition( )
{

	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); 
	return vecArmPos;

/*
	if (m_fStanding )
	{
		return pev->origin + Vector( 0, 0, 60 );
	}
	else
	{
		return pev->origin + Vector( 0, 0, 48 );
	}

*/
}

//=========================================================
// Contrle de la munitions
//=========================================================

void CCommando :: CheckAmmo ( void )
{
	if ( m_cAmmoLoaded <= 0 )
	{
		SetConditions(bits_COND_NO_AMMO_LOADED);
	}
}
//=========================================================
// Shoot pour le strifle
//=========================================================
void CCommando :: Shoot ( void )
{
	if (m_hEnemy == NULL)
	{
		return;
	}

	Vector vecShootOrigin = GetGunPosition();
	Vector vecShootDir = ShootAtEnemy( vecShootOrigin );

	UTIL_MakeVectors ( pev->angles );
	
	// code pour tirer un projectile de blaster
	// ajout de la dispersion du tir automatique rapide

	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_3DEGREES ;
	vecShootDir = vecShootDir + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;


	CCBlaster::Shoot(pev,vecShootOrigin,vecShootDir * 2000);

	pev->effects |= EF_MUZZLEFLASH;
	
	m_cAmmoLoaded--;// retire un coup du chargeur!

	Vector angDir = UTIL_VecToAngles( vecShootDir );
	SetBlending( 0, angDir.x ); // donne l'inclinaison de tir du stormtrooper pour l'animation
}

//========================================================
// tir pour le repeater
//========================================================

void CCommando :: Repeater ( void )
{
	if (m_hEnemy == NULL)
	{
		return;
	}

	Vector vecShootOrigin = GetGunPosition();
	Vector vecShootDir = ShootAtEnemy( vecShootOrigin );

	UTIL_MakeVectors ( pev->angles );
	
	// code pour tirer un projectile de blaster
	// ajout de la dispersion du tir automatique rapide

	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_5DEGREES ;
	vecShootDir = vecShootDir + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;


	CRBlaster::Shoot(pev,vecShootOrigin,vecShootDir * 2000);

	pev->effects |= EF_MUZZLEFLASH;
	
	m_cAmmoLoaded--;// retire un coup du chargeur!

	Vector angDir = UTIL_VecToAngles( vecShootDir );
	SetBlending( 0, angDir.x ); // donne l'inclinaison de tir du stormtrooper pour l'animation
}

//=========================================================
// HandleAnimEvent - catches the monster-specific messages
// that occur when tagged animation frames are played.
//
// Returns number of events handled, 0 if none.
//=========================================================
void CCommando :: HandleAnimEvent( MonsterEvent_t *pEvent )
{
	switch( pEvent->event )
	{

	case COMMANDO_AE_DROP_GUN:
		{
		Vector	vecGunPos;
		Vector	vecGunAngles;

		GetAttachment( 0, vecGunPos, vecGunAngles );

		// switch to body group with no gun.
		SetBodygroup( GUN_GROUP, GUN_NONE );

		// now spawn a gun.
		if (FBitSet( pev->weapons, COMMANDO_REPEATER ))
		{
			 DropItem( "weapon_repeatergun", vecGunPos, vecGunAngles );
		}
		else
		{
			 DropItem( "weapon_strifle", vecGunPos, vecGunAngles );
		}

		m_jesuismort = 1;

		}
		break;
	
	case COMMANDO_AE_SHOOT1:
		{
		
		if ( FBitSet( pev->weapons, COMMANDO_STRIFLE ))
			{
				Shoot();

				
				if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf2.wav", 1, ATTN_NORM );
				}
			}
		else
			{
				Repeater( );

				if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept2.wav", 1, ATTN_NORM );
				}

			}
		
			
		}
		break;

	case COMMANDO_AE_SHOOT2:
		{

		if ( FBitSet( pev->weapons, COMMANDO_STRIFLE ))
			{
				Shoot();

				
				if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf2.wav", 1, ATTN_NORM );
				}
			}
		else
			{
				Repeater( );

				if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept2.wav", 1, ATTN_NORM );
				}

			}
		
			
		}
		break;

	case COMMANDO_AE_SHOOT3:
		{

		
			Repeater( );

			if ( RANDOM_LONG(0,1) )
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept1.wav", 1, ATTN_NORM );
			}
			else
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept2.wav", 1, ATTN_NORM );
			}
		}
		break;

	case COMMANDO_AE_SHOOT4:
		{

		
			Repeater( );

			if ( RANDOM_LONG(0,1) )
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept1.wav", 1, ATTN_NORM );
			}
			else
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept2.wav", 1, ATTN_NORM );
			}
		}
		break;

	case COMMANDO_AE_SHOOT5:
		{

		
			Repeater( );

			if ( RANDOM_LONG(0,1) )
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept1.wav", 1, ATTN_NORM );
			}
			else
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/rept2.wav", 1, ATTN_NORM );
			}
		}
		break;
	
	case COMMANDO_AE_TOSS1:
		{
			UTIL_MakeVectors( pev->angles );
			CThermal::ShootTimed( pev, pev->origin + gpGlobals->v_forward * 34 + Vector (0, 0, 32), m_vecTossVelocity, 3.5 );

			m_flNextGrenadeCheck = gpGlobals->time + 6;// wait six seconds before even looking again to see if a grenade can be thrown.
			m_fThrowGrenade = FALSE;
			// !!!LATER - when in a group, only try to throw grenade if ordered.
		}
		break;

	case COMMANDO_AE_RELOAD:
		{
			if (FBitSet( pev->weapons, COMMANDO_REPEATER ))
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "commando/rept_reload.wav", 1, ATTN_NORM );
				m_cAmmoLoaded = m_cClipSize * 2;
			}

			else
			{
				EMIT_SOUND( ENT(pev), CHAN_WEAPON, "stormt/st_reload1.wav", 1, ATTN_NORM );
				m_cAmmoLoaded = m_cClipSize;
			}

			ClearConditions(bits_COND_NO_AMMO_LOADED);

		}
		break;

	case COMMANDO_AE_RIGHT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( COMMANDO_MELEE_DIST, gSkillData.commandoDmgPunch, DMG_CLUB );
			
			if ( pHurt )//touch
			{
				pHurt->pev->punchangle.y = -25;
				pHurt->pev->punchangle.x = -8;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * -150;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				Vector vecArmPos, vecArmAng;
				GetAttachment( 0, vecArmPos, vecArmAng );
				SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				// c'est rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}

		}
		break;

	case COMMANDO_AE_LEFT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( COMMANDO_MELEE_DIST, gSkillData.commandoDmgPunch, DMG_CLUB );
			
			if ( pHurt )//touch
			{
				pHurt->pev->punchangle.y = -25;
				pHurt->pev->punchangle.x = 8;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * 150 + gpGlobals->v_forward * 200;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				//Vector vecArmPos, vecArmAng;
				//GetAttachment( 0, vecArmPos, vecArmAng );
				//SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				// c'est rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}

		}
		break;

	case COMMANDO_AE_JUMP:
		{
			// ALERT( at_console, "jumping");
			UTIL_MakeAimVectors( pev->angles );
			pev->movetype = MOVETYPE_TOSS;
			pev->flags &= ~FL_ONGROUND;
			pev->velocity = m_vecJumpVelocity;
			m_flNextJump = gpGlobals->time + 3.0;
		}
		return;
	default:
		CBaseMonster::HandleAnimEvent( pEvent );
		break;
	}	

}

//=========================================================
// Spawn
//=========================================================
void CCommando :: Spawn()
{
	Precache( );

	SET_MODEL(ENT(pev), "models/commando.mdl");
	UTIL_SetSize(pev, VEC_HUMAN_HULL_MIN, VEC_HUMAN_HULL_MAX);

	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_STEP;
	m_bloodColor		= BLOOD_COLOR_RED;
	pev->effects		= 0;
	pev->health			= gSkillData.commandoHealth;
	m_flFieldOfView		= VIEW_FIELD_WIDE; // indicates the width of this monster's forward view cone ( as a dotproduct result )
	m_MonsterState		= MONSTERSTATE_NONE;
	m_afCapability		= bits_CAP_MELEE_ATTACK1 | bits_CAP_TURN_HEAD | bits_CAP_DOORS_GROUP;
	pev->friction		= 1;

	m_flNextSpeakTime	= m_flNextWordTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);

	m_HackedGunPos		= Vector( 0, 0, 55 );

	m_iTargetRanderamt	= 20;
	pev->renderamt		= 20;
	pev->rendermode		= kRenderTransTexture;
	pev->iuser3			= 1;//masse
	pev->iuser4			= 1;//incendie

	if (pev->weapons == 0)
	{
		
		pev->weapons = COMMANDO_STRIFLE | COMMANDO_HANDGRENADE;
		
	}

	if (FBitSet( pev->weapons, COMMANDO_REPEATER )) //numro 4 pour la map
	{
		SetBodygroup( GUN_GROUP, GUN_REPEATER );
		m_cClipSize		= 50;
		COMMANDO_AE_RELOAD == COMMANDO_AE_RELOAD2;
	}
	else
	{
		SetBodygroup( GUN_GROUP, GUN_STRIFLE );
		m_cClipSize		= COMMANDO_CLIP_SIZE;
	}
	m_cAmmoLoaded		= m_cClipSize;
	m_jesuismort		= 0;
	m_ouille			= 0;

	MonsterInit();
}

//=========================================================
// Precache - precaches all resources this monster needs
//=========================================================
void CCommando :: Precache()
{
	int i;

	PRECACHE_MODEL("models/commando.mdl");

	for ( i = 0; i < ARRAYSIZE( pAttackHitSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackHitSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackMissSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackMissSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pIdleSounds ); i++ )
		PRECACHE_SOUND((char *)pIdleSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pDieSounds ); i++ )
		PRECACHE_SOUND((char *)pDieSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pPainSounds ); i++ )
		PRECACHE_SOUND((char *)pPainSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAlertSounds ); i++ )
		PRECACHE_SOUND((char *)pAlertSounds[i]);


	PRECACHE_SOUND("weapons/strf1.wav");
	PRECACHE_SOUND("weapons/strf2.wav");
	PRECACHE_SOUND("weapons/rept1.wav");
	PRECACHE_SOUND("weapons/rept2.wav");
	PRECACHE_SOUND ("weapons/choc1.wav");
	PRECACHE_SOUND ("weapons/choc2.wav");
	PRECACHE_SOUND ("weapons/choc3.wav");
	PRECACHE_SOUND ("weapons/choc4.wav");
	PRECACHE_SOUND ("weapons/grill.wav");

	PRECACHE_SOUND( "stormt/st_reload1.wav" );
	PRECACHE_SOUND( "commando/rept_reload.wav" );

	PRECACHE_SOUND("debris/beamstart1.wav");

	m_Cisprite = PRECACHE_MODEL( "sprites/hotglow.spr" ); //pour le tir du blaster
	m_Cismoke = PRECACHE_MODEL( "sprites/blasthit.spr" ); //pour l'impacte du blaster
	m_iCOTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_iYcTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_RWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
	PRECACHE_MODEL( "sprites/yblaster.spr" );
	PRECACHE_MODEL( "sprites/blaster.spr" );
	
}	
	


//=========================================================
// AI Schedules Specific to this monster
//=========================================================

//=========================================================
// Commando reload schedule
//=========================================================
Task_t	tlCommandoHideReload[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RELOAD			},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
	{ TASK_PLAY_SEQUENCE,			(float)ACT_RELOAD			},
};

Schedule_t slCommandoHideReload[] = 
{
	{
		tlCommandoHideReload,
		ARRAYSIZE ( tlCommandoHideReload ),
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_HEAR_SOUND,

		bits_SOUND_DANGER,
		"CommandoHideReload"
	}
};

//=========================================================
// Fail Schedule
//=========================================================
Task_t	tlCommandoFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT_FACE_ENEMY,		(float)2		},
	// { TASK_WAIT_PVS,			(float)0		},
	{ TASK_SET_SCHEDULE,		(float)SCHED_CHASE_ENEMY },
};

Schedule_t	slCommandoFail[] =
{
	{
		tlCommandoFail,
		ARRAYSIZE ( tlCommandoFail ),
		bits_COND_LIGHT_DAMAGE		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_PROVOKED			|
		bits_COND_CAN_RANGE_ATTACK1 |
		bits_COND_CAN_RANGE_ATTACK2 |
		bits_COND_CAN_MELEE_ATTACK1 |
		bits_COND_HEAR_SOUND,
	
		bits_SOUND_DANGER |
		bits_SOUND_PLAYER,
		"CommandoFail"
	},
};


//=========================================================
// Enemy exposed Agrunt's cover
//=========================================================
Task_t	tlCommandoExposed[] =
{
	{ TASK_STOP_MOVING,			(float)0							},
	{ TASK_RANGE_ATTACK1,		(float)0							},
	{ TASK_SET_FAIL_SCHEDULE,	(float)SCHED_COMMANDO_JUMP			},
	{ TASK_SET_SCHEDULE,		(float)SCHED_TAKE_COVER_FROM_ENEMY	},
};

Schedule_t slCommandoExposed[] =
{
	{
		tlCommandoExposed,
		ARRAYSIZE ( tlCommandoExposed ),
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"CommandoExposed",
	},
};


//=========================================================
// Take cover from enemy! Tries lateral cover before node 
// cover! 
//=========================================================
Task_t	tlCommandoTakeCoverFromEnemy[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RANGE_ATTACK1	},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slCommandoTakeCoverFromEnemy[] =
{
	{ 
		tlCommandoTakeCoverFromEnemy,
		ARRAYSIZE ( tlCommandoTakeCoverFromEnemy ), 
		bits_COND_NEW_ENEMY |
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoTakeCoverFromEnemy"
	},
};


//=========================================================
// Take cover from enemy! Tries lateral cover before node 
// cover! 
//=========================================================
Task_t	tlCommandoTakeCoverFromEnemy2[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_FACE_ENEMY,				(float)0					},
	{ TASK_RANGE_ATTACK1,			(float)0					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RANGE_ATTACK2	},
	{ TASK_FIND_FAR_NODE_COVER_FROM_ENEMY,	(float)384			},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slCommandoTakeCoverFromEnemy2[] =
{
	{ 
		tlCommandoTakeCoverFromEnemy2,
		ARRAYSIZE ( tlCommandoTakeCoverFromEnemy2 ), 
		bits_COND_NEW_ENEMY |
		bits_COND_CAN_MELEE_ATTACK2		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoTakeCoverFromEnemy2"
	},
};


//=========================================================
// hide from the loudest sound source
//=========================================================
Task_t	tlCommandoTakeCoverFromBestSound[] =
{
	{ TASK_SET_FAIL_SCHEDULE,			(float)SCHED_MELEE_ATTACK1	},
	{ TASK_STOP_MOVING,					(float)0					},
	{ TASK_FIND_COVER_FROM_BEST_SOUND,	(float)0					},
	{ TASK_RUN_PATH,					(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,			(float)0					},
	{ TASK_REMEMBER,					(float)bits_MEMORY_INCOVER	},
	{ TASK_TURN_LEFT,					(float)179					},
};

Schedule_t	slCommandoTakeCoverFromBestSound[] =
{
	{ 
		tlCommandoTakeCoverFromBestSound,
		ARRAYSIZE ( tlCommandoTakeCoverFromBestSound ), 
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_NEW_ENEMY,
		0,
		"CommandoTakeCoverFromBestSound"
	},
};





//=========================================================
// AlertIdle Schedules
//=========================================================
Task_t	tlCommandoHide[] =
{
	{ TASK_STOP_MOVING,			0						 },
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE			 },
	{ TASK_WAIT,				(float)2				 },
	{ TASK_SET_SCHEDULE,		(float)SCHED_CHASE_ENEMY },
};

Schedule_t	slCommandoHide[] =
{
	{ 
		tlCommandoHide,
		ARRAYSIZE ( tlCommandoHide ), 
		bits_COND_NEW_ENEMY				|
		bits_COND_SEE_ENEMY				|
		bits_COND_SEE_FEAR				|
		bits_COND_LIGHT_DAMAGE			|
		bits_COND_HEAVY_DAMAGE			|
		bits_COND_PROVOKED		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoHide"
	},
};



//=========================================================
// HUNT Schedules
//=========================================================
Task_t tlCommandoHunt[] = 
{
	{ TASK_GET_PATH_TO_ENEMY,	(float)0		},
	{ TASK_RUN_PATH,			(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0		},
};

Schedule_t slCommandoHunt[] =
{
	{ 
		tlCommandoHunt,
		ARRAYSIZE ( tlCommandoHunt ),
		bits_COND_NEW_ENEMY			|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoHunt"
	},
};


//=========================================================
// Jumping Schedules
//=========================================================
Task_t	tlCommandoJump[] =
{
	{ TASK_STOP_MOVING,			(float)0		},
	{ TASK_PLAY_SEQUENCE,		(float)ACT_HOP	},
	{ TASK_SET_SCHEDULE,		(float)SCHED_COMMANDO_JUMP_ATTACK },
};

Schedule_t	slCommandoJump[] =
{
	{ 
		tlCommandoJump,
		ARRAYSIZE ( tlCommandoJump ), 
		0, 
		0, 
		"CommandoJump"
	},
};


//=========================================================
// repel 
//=========================================================
Task_t	tlCommandoJumpAttack[] =
{
	{ TASK_SET_FAIL_SCHEDULE,	(float)SCHED_COMMANDO_JUMP_LAND	},
	// { TASK_SET_ACTIVITY,		(float)ACT_FLY	},
	{ TASK_COMMANDO_FALL_TO_GROUND, (float)0		},
};


Schedule_t	slCommandoJumpAttack[] =
{
	{ 
		tlCommandoJumpAttack,
		ARRAYSIZE ( tlCommandoJumpAttack ), 
		0, 
		0,
		"CommandoJumpAttack"
	},
};


//=========================================================
// repel 
//=========================================================
Task_t	tlCommandoJumpLand[] =
{
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_COMMANDO_EXPOSED	},
	// { TASK_SET_FAIL_SCHEDULE,		(float)SCHED_MELEE_ATTACK1	},
	{ TASK_SET_ACTIVITY,			(float)ACT_IDLE				},
	{ TASK_REMEMBER,				(float)bits_MEMORY_BADJUMP	},
	{ TASK_FIND_NODE_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_FORGET,					(float)bits_MEMORY_BADJUMP	},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RANGE_ATTACK1	},
};

Schedule_t	slCommandoJumpLand[] =
{
	{ 
		tlCommandoJumpLand,
		ARRAYSIZE ( tlCommandoJumpLand ), 
		0, 
		0,
		"CommandoJumpLand"
	},
};

//=========================================================
// Establish line of fire - move to a position that allows
// the commando to attack.
//=========================================================
Task_t tlCommandoEstablishLineOfFire[] = 
{
	{ TASK_SET_FAIL_SCHEDULE,	(float)SCHED_COMMANDO_ELOF_FAIL	},
	{ TASK_GET_PATH_TO_ENEMY,	(float)0						},
	{ TASK_RUN_PATH,			(float)0						},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0						},
};

Schedule_t slCommandoEstablishLineOfFire[] =
{
	{ 
		tlCommandoEstablishLineOfFire,
		ARRAYSIZE ( tlCommandoEstablishLineOfFire ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_CAN_MELEE_ATTACK2	|
		bits_COND_LIGHT_DAMAGE		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoEstablishLineOfFire"
	},
};


Task_t tlCommandoRecherche[] =
{
	{ TASK_GET_PATH_TO_SPOT,		(float)0		},
	{ TASK_RUN_PATH,				(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0		},
};

Schedule_t slCommandoRecherche[] =
{
	{
		tlCommandoRecherche,
		ARRAYSIZE ( tlCommandoRecherche ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"CommandoRecherche"
	},
};



DEFINE_CUSTOM_SCHEDULES( CCommando )
{
	slCommandoHideReload,
	slCommandoFail,
	slCommandoExposed,
	slCommandoTakeCoverFromEnemy,
	slCommandoTakeCoverFromEnemy2,
	slCommandoTakeCoverFromBestSound,
	slCommandoHide,
	slCommandoHunt,
	slCommandoJump,
	slCommandoJumpAttack,
	slCommandoJumpLand,
	slCommandoEstablishLineOfFire,
	slCommandoRecherche,
};

IMPLEMENT_CUSTOM_SCHEDULES( CCommando, CBaseMonster );


//=========================================================
// CheckMeleeAttack1 -  
//=========================================================
BOOL CCommando :: CheckMeleeAttack1 ( float flDot, float flDist )
{

	CBaseMonster *pEnemy;

	if ( m_hEnemy != NULL )
	{
		pEnemy = m_hEnemy->MyMonsterPointer();

		if ( !pEnemy )
		{
			return FALSE;
		}
	}

	if ( flDist <= 64 && flDot >= 0.7	&& 
		 pEnemy->Classify() != CLASS_ALIEN_BIOWEAPON &&
		 pEnemy->Classify() != CLASS_PLAYER_BIOWEAPON )
	{
		return TRUE;
	}
	return FALSE;



/*

	CBaseMonster *pEnemy;

	if ( m_hEnemy != NULL )
	{
		pEnemy = m_hEnemy->MyMonsterPointer();

		if ( !pEnemy )
		{
			return FALSE;
		}
	}

	if ( flDist <= 64 && flDot >= 0.7	&& 
		 pEnemy->Classify() != CLASS_ALIEN_BIOWEAPON &&
		 pEnemy->Classify() != CLASS_PLAYER_BIOWEAPON )
	{
		return TRUE;

		if ( m_flNextJump < gpGlobals->time && (flDist <= 128 || HasMemory( bits_MEMORY_BADJUMP )) && m_hEnemy != NULL )
	{
		TraceResult	tr;

		Vector vecDest = pev->origin + Vector( RANDOM_FLOAT( -64, 64), RANDOM_FLOAT( -64, 64 ), 160 );

		UTIL_TraceHull( pev->origin + Vector( 0, 0, 36 ), vecDest + Vector( 0, 0, 36 ), dont_ignore_monsters, human_hull, ENT(pev), &tr);

		if ( tr.fStartSolid || tr.flFraction < 1.0)
		{
			return FALSE;
		}

		float flGravity = CVAR_GET_FLOAT( "sv_gravity" );

		float time = sqrt( 160 / (0.5 * flGravity));
		float speed = flGravity * time / 160;
		m_vecJumpVelocity = (vecDest - pev->origin) * speed;

		return TRUE;
	}
	}
	return FALSE;
	

  */
}

//=========================================================
// CheckRangeAttack1  - drop a cap in their ass
//
//=========================================================
BOOL CCommando :: CheckRangeAttack1 ( float flDot, float flDist )
{
	if ( !HasConditions( bits_COND_ENEMY_OCCLUDED ) && flDist > 64 && flDist <= 2048 /* && flDot >= 0.5 */ /* && NoFriendlyFire() */ )
	{
		TraceResult	tr;

		Vector vecSrc = GetGunPosition();

		// verify that a bullet fired from the gun will hit the enemy before the world.
		UTIL_TraceLine( vecSrc, m_hEnemy->BodyTarget(vecSrc), dont_ignore_monsters, ENT(pev), &tr);

		if ( tr.flFraction == 1 || tr.pHit == m_hEnemy->edict() )
		{
			return TRUE;
		}
	}
	return FALSE;
}

//=========================================================
// CheckRangeAttack2 - toss grenade if enemy gets in the way and is too close. 
//=========================================================
BOOL CCommando :: CheckRangeAttack2 ( float flDot, float flDist )
{

	if ( m_flNextGrenadeCheck > gpGlobals->time )
	{
		return FALSE;
	}

	if (! FBitSet(pev->weapons, (COMMANDO_HANDGRENADE )))
	{
		return FALSE;
	}

	if ( !FBitSet ( m_hEnemy->pev->flags, FL_ONGROUND ) && m_hEnemy->pev->waterlevel == 0 && m_vecEnemyLKP.z > pev->absmax.z  )
	{
		
		m_fThrowGrenade = FALSE;
		return m_fThrowGrenade;
	}

	// don't get grenade happy unless the player starts to piss you off
	if ( m_iFrustration <= 2)
		return FALSE;


	
	Vector vecTarget;

	// find feet
	if (RANDOM_LONG(0,1))
	{
		// magically know where they are
		vecTarget = Vector( m_hEnemy->pev->origin.x, m_hEnemy->pev->origin.y, m_hEnemy->pev->absmin.z );
	}
	else
	{
		// toss it to where you last saw them
		vecTarget = m_vecEnemyLKP;
	}
		

	if ( InSquad() )
	{
		if (SquadMemberInRange( vecTarget, 384 ))
		{
			// crap, I might blow my own guy up. Don't throw a grenade and don't check again for a while.
			m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
			m_fThrowGrenade = FALSE;
		}
	}
	
	if ( ( vecTarget - pev->origin ).Length2D() <= 384 )
	{
		// crap, I don't want to blow myself up
		m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
		m_fThrowGrenade = FALSE;
		return m_fThrowGrenade;
	}
	
	
	Vector vecToss = VecCheckToss( pev, GetGunPosition(), vecTarget, 0.5 );

	if ( vecToss != g_vecZero )
	{
		m_vecTossVelocity = vecToss;

		// throw a hand grenade
		m_fThrowGrenade = TRUE;
		// don't check again for a while.
		m_flNextGrenadeCheck = gpGlobals->time; // 1/3 second.
	}
	else
	{
		// don't throw
		m_fThrowGrenade = FALSE;
		// don't check again for a while.
		m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
	}
	
	
	return m_fThrowGrenade;
}


//=========================================================
// RunAI
//=========================================================
void CCommando :: RunAI( void )
{
	CBaseMonster :: RunAI();

	// always visible if moving
	// always visible is not on hard
	if (g_iSkillLevel != SKILL_HARD || m_hEnemy == NULL || pev->deadflag != DEAD_NO || m_Activity == ACT_RUN || m_Activity == ACT_WALK || !(pev->flags & FL_ONGROUND))
		m_iTargetRanderamt = 255;
	else
		m_iTargetRanderamt = 20;

	if (pev->renderamt > m_iTargetRanderamt)
	{
		if (pev->renderamt == 255)
		{
			EMIT_SOUND (ENT(pev), CHAN_BODY, "debris/beamstart1.wav", 0.2, ATTN_NORM );
		}

		pev->renderamt = max( pev->renderamt - 50, m_iTargetRanderamt );
		pev->rendermode = kRenderTransTexture;
	}
	else if (pev->renderamt < m_iTargetRanderamt)
	{
		pev->renderamt = min( pev->renderamt + 50, m_iTargetRanderamt );
		if (pev->renderamt == 255)
			pev->rendermode = kRenderNormal;
	}

	if (m_Activity == ACT_RUN || m_Activity == ACT_WALK)
	{
		static int iStep = 0;
		iStep = ! iStep;
		if (iStep)
		{
			switch( RANDOM_LONG( 0, 3 ) )
			{
			case 0:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step1.wav", 0.3, ATTN_NORM);	break;
			case 1:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step3.wav", 0.3, ATTN_NORM);	break;
			case 2:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step2.wav", 0.3, ATTN_NORM);	break;
			case 3:	EMIT_SOUND( ENT(pev), CHAN_BODY, "player/pl_step4.wav", 0.3, ATTN_NORM);	break;
			}
		}
	}
}


//===================================================
//Activits dpendant de l'tat actuel
//===================================================

void CCommando :: SetActivity ( Activity NewActivity )
{
	int	iSequence = ACTIVITY_NOT_AVAILABLE;
	void *pmodel = GET_MODEL_PTR( ENT(pev) );

	switch ( NewActivity)
	{
	case ACT_RANGE_ATTACK1:
		
		if (FBitSet( pev->weapons, COMMANDO_STRIFLE ))
		{
		
			if ( m_fStanding )
			{
					
				iSequence = LookupSequence( "standing_strifle" );
			}
			else
			{
				
				iSequence = LookupSequence( "crouching_strifle" );
			}
		}
		else
		{
			if ( m_fStanding )
			{
					
				iSequence = LookupSequence( "standing_repeater" );
			}
			else
			{
				
				iSequence = LookupSequence( "crouching_repeater" );
			}

		}
				
		break;
	
	case ACT_RUN:
		if ( pev->health <= COMMANDO_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_RUN_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_WALK:
		if ( pev->health <= COMMANDO_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_WALK_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_IDLE:
		if ( m_MonsterState == MONSTERSTATE_COMBAT )
		{
			NewActivity = ACT_IDLE_ANGRY;
		}
		iSequence = LookupActivity ( NewActivity );
		break;
	default:
		iSequence = LookupActivity ( NewActivity );
		break;
	}
	
	m_Activity = NewActivity; 

	
	if ( iSequence > ACTIVITY_NOT_AVAILABLE )
	{
		if ( pev->sequence != iSequence || !m_fSequenceLoops )
		{
			pev->frame = 0;
		}

		pev->sequence		= iSequence;	
		ResetSequenceInfo( );
		SetYawSpeed();
	}
	else
	{
		
		ALERT ( at_console, "%s has no sequence for act:%d\n", STRING(pev->classname), NewActivity );
		pev->sequence		= 0;	
	}
}

//=========================================================
// StartTask
//=========================================================
void CCommando :: StartTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_RANGE_ATTACK2:
		if (!m_fThrowGrenade)
		{
			TaskComplete( );
		}
		else
		{
			CSquadMonster :: StartTask ( pTask );
		}
		break;
	case TASK_COMMANDO_FALL_TO_GROUND:
		break;
	default:
		CSquadMonster :: StartTask ( pTask );
		break;
	}
}


//=========================================================
// RunTask 
//=========================================================
void CCommando :: RunTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_COMMANDO_FALL_TO_GROUND:
		MakeIdealYaw( m_vecEnemyLKP );
		ChangeYaw( pev->yaw_speed );

		if (m_fSequenceFinished)
		{
			if (pev->velocity.z > 0)
			{
				pev->sequence = LookupSequence( "fly_up" );
			}
			else if (HasConditions ( bits_COND_SEE_ENEMY ))
			{
				pev->sequence = LookupSequence( "fly_attack" );
				pev->frame = 0;
			}
			else
			{
				pev->sequence = LookupSequence( "fly_down" );
				pev->frame = 0;
			}
			
			ResetSequenceInfo( );
			SetYawSpeed();
		}
		if (pev->flags & FL_ONGROUND)
		{
			// ALERT( at_console, "on ground\n");
			TaskComplete( );
		}
		break;
	default: 
		CSquadMonster :: RunTask ( pTask );
		break;
	}
}

//=========================================================
// GetSchedule - Decides which type of schedule best suits
// the monster's current state and conditions. Then calls
// monster's member function to get a pointer to a schedule
// of the proper type.
//=========================================================
Schedule_t *CCommando :: GetSchedule ( void )
{
	switch	( m_MonsterState )
	{
	case MONSTERSTATE_IDLE:
	case MONSTERSTATE_ALERT:
		{
			if ( HasConditions ( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_INVESTIGATE_SOUND );
				}
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}


		}
		break;

	case MONSTERSTATE_COMBAT:
		{
// dead enemy
			if ( HasConditions( bits_COND_ENEMY_DEAD ) )
			{
				// call base class, all code to handle dead enemies is centralized there.
				return CBaseMonster :: GetSchedule();
			}

			// flying?
			if ( pev->movetype == MOVETYPE_TOSS)
			{
				if (pev->flags & FL_ONGROUND)
				{
					// ALERT( at_console, "landed\n");
					// just landed
					pev->movetype = MOVETYPE_STEP;
					return GetScheduleOfType ( SCHED_COMMANDO_JUMP_LAND );
				}
				else
				{
					// ALERT( at_console, "jump\n");
					// jump or jump/shoot
					if ( m_MonsterState == MONSTERSTATE_COMBAT )
						return GetScheduleOfType ( SCHED_COMMANDO_JUMP );
					else
						return GetScheduleOfType ( SCHED_COMMANDO_JUMP_ATTACK );
				}
			}

			if ( pev->iuser4 == 2 )
			{
				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}

			if ( HasConditions ( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
			}

			if ( HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{
				if ( m_flNextAlertSound < gpGlobals->time )// pas  chaque fois
				{
					AlertSound();
			
					m_flNextAlertSound = gpGlobals->time + 10;// on verra tout  l'heure
				}
				m_iFrustration++;
			}

			/*
			if( m_ouille == 1 )
			{
				// fait un saut pour se mettre  l'abris
				ALERT( at_console, "CA FAIT MAL!!!\n");
				
				if ( m_flNextJump < gpGlobals->time )//&& HasMemory( bits_MEMORY_BADJUMP ) && m_hEnemy != NULL )
				{
					ALERT( at_console, "UN PETIT SAUT\n");
					
					TraceResult	tr;

					Vector vecDest = pev->origin + Vector( RANDOM_FLOAT( -64, 64), RANDOM_FLOAT( -64, 64 ), 60 );

					UTIL_TraceHull( pev->origin + Vector( 0, 0, 36 ), vecDest + Vector( 0, 0, 36 ), dont_ignore_monsters, human_hull, ENT(pev), &tr);

					if ( tr.fStartSolid || tr.flFraction < 1.0)
					{
						return FALSE;
					}

					float flGravity = CVAR_GET_FLOAT( "sv_gravity" );

					float time = sqrt( 160 / (0.5 * flGravity));
					float speed = flGravity * time / 160;
					m_vecJumpVelocity = (vecDest - pev->origin) * speed;

					return GetScheduleOfType ( SCHED_COMMANDO_JUMP_AWAY );
				}

				m_ouille = 0;
			}

			*/	
			
			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) )
			{
				if ( m_flNextAlertSound < gpGlobals->time )// pas  chaque fois
				{
					AlertSound();
			
					m_flNextAlertSound = gpGlobals->time + 10;// on verra tout  l'heure
				}
				m_iFrustration++;
			}

						
			if ( HasConditions ( bits_COND_CAN_MELEE_ATTACK1 ) )
			{
				// ALERT( at_console, "melee attack 1\n");
				if ( m_flNextAttackSound < gpGlobals->time )// pas  chaque fois
				{
					AttackSound();
			
					m_flNextAttackSound = gpGlobals->time + 10;// on verra tout  l'heure
				}

				return GetScheduleOfType ( SCHED_MELEE_ATTACK1 );
			}

		// throw grenade
			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK2 ) )
			{
				// ALERT( at_console, "range attack 2\n");
				return GetScheduleOfType ( SCHED_RANGE_ATTACK2 );
			}

		// spotted
			if ( HasConditions ( bits_COND_SEE_ENEMY ) && HasConditions ( bits_COND_ENEMY_FACING_ME ) )
			{
				// ALERT( at_console, "exposed\n");
				m_iFrustration++;
				return GetScheduleOfType ( SCHED_COMMANDO_EXPOSED );
			}

		// can attack
			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) )
			{
				// ALERT( at_console, "range attack 1\n");
				m_iFrustration = 0;
				return GetScheduleOfType ( SCHED_RANGE_ATTACK1 );
			}

			if ( HasConditions ( bits_COND_SEE_ENEMY ) )
			{
				// ALERT( at_console, "face\n");
				return GetScheduleOfType ( SCHED_COMBAT_FACE );
			}

		// new enemy
			if ( HasConditions ( bits_COND_NEW_ENEMY ) )
			{
				if ( HasConditions( bits_COND_ENEMY_OCCLUDED ) )
				{
					if ( HasConditions( bits_COND_CAN_RANGE_ATTACK2 )  )
					{
						return GetScheduleOfType( SCHED_RANGE_ATTACK2 );
					}
					else 
					{
						return GetScheduleOfType( SCHED_COMMANDO_ESTABLISH_LINE_OF_FIRE );
					}
				}
				else	
				{
					// ALERT( at_console, "take cover\n");
					return GetScheduleOfType ( SCHED_TAKE_COVER_FROM_ENEMY );
				}
			}

			if ( HasConditions ( bits_COND_NO_AMMO_LOADED ) )
			{
				
				return GetScheduleOfType ( SCHED_COMMANDO_COVER_AND_RELOAD );
			}

			// ALERT( at_console, "stand\n");
			return GetScheduleOfType ( SCHED_ALERT_STAND );
		}
		break;
	}

	return CSquadMonster :: GetSchedule();
}

//=========================================================
//=========================================================
Schedule_t* CCommando :: GetScheduleOfType ( int Type ) 
{
	// ALERT( at_console, "%d\n", m_iFrustration );
	switch	( Type )
	{
	case SCHED_TAKE_COVER_FROM_ENEMY:
		if (pev->health > 30)
			return slCommandoTakeCoverFromEnemy;
		else
			return slCommandoTakeCoverFromEnemy2;
	case SCHED_TAKE_COVER_FROM_BEST_SOUND:
		return slCommandoTakeCoverFromBestSound;
	
	case SCHED_COMMANDO_EXPOSED:
		return slCommandoExposed;
	
	case SCHED_FAIL:
		if (m_MonsterState == MONSTERSTATE_COMBAT)
			return slCommandoFail;
		break;

	case SCHED_COMMANDO_RECHERCHE:
		return &slCommandoRecherche[ 0 ];
		break;
	
	case SCHED_ALERT_STAND:
		if (m_MonsterState == MONSTERSTATE_COMBAT)
			return slCommandoHide;
		break;
	case SCHED_COMMANDO_ELOF_FAIL:
		{
			// commando is unable to move to a position that allows him to attack the enemy.
			return GetScheduleOfType ( SCHED_TAKE_COVER_FROM_ENEMY );
		}
		break;
	case SCHED_COMMANDO_ESTABLISH_LINE_OF_FIRE:
		{
			return &slCommandoEstablishLineOfFire[ 0 ];
		}
		break;
	
	case SCHED_COMMANDO_COVER_AND_RELOAD:
		{
			return &slCommandoHideReload[ 0 ];
		}

	case SCHED_CHASE_ENEMY:
		return slCommandoHunt;
	
	case SCHED_COMMANDO_JUMP_AWAY:
		if (pev->flags & FL_ONGROUND)
		{
			if (m_flNextJump > gpGlobals->time)
			{
				// can't jump yet, go ahead and fail
				return slCommandoFail;
			}
			else
			{
				return slCommandoJump;
			}
		}
		else
		{
			return slCommandoJumpAttack;
		}
	case SCHED_COMMANDO_JUMP:
	case SCHED_COMMANDO_JUMP_ATTACK:
		return slCommandoJumpAttack;
	case SCHED_COMMANDO_JUMP_LAND:
		return slCommandoJumpLand;
	}

	return CSquadMonster :: GetScheduleOfType( Type );
}

//=========================================================
// Classe  pour un cadavre de commando
//=========================================================
class CDeadCommando : public CBaseMonster
{
public:
	void Spawn( void );
	int	Classify ( void ) { return	CLASS_HUMAN_MILITARY; }

	void KeyValue( KeyValueData *pkvd );

	int	m_iPose;
	static char *m_szPoses[3];
};

char *CDeadCommando::m_szPoses[] = { "deadstomach", "deadside", "deadsitting" };

void CDeadCommando::KeyValue( KeyValueData *pkvd )
{
	if (FStrEq(pkvd->szKeyName, "pose"))
	{
		m_iPose = atoi(pkvd->szValue);
		pkvd->fHandled = TRUE;
	}
	else 
		CBaseMonster::KeyValue( pkvd );
}

LINK_ENTITY_TO_CLASS( monster_commando_dead, CDeadCommando );

//=========================================================
// ********** Cadavre de commando **********
//=========================================================
void CDeadCommando :: Spawn( void )
{
	PRECACHE_MODEL("models/commando.mdl");
	SET_MODEL(ENT(pev), "models/commando.mdl");

	pev->effects		= 0;
	pev->yaw_speed		= 8;
	pev->sequence		= 0;
	m_bloodColor		= BLOOD_COLOR_RED;

	pev->sequence = LookupSequence( m_szPoses[m_iPose] );

	if (pev->sequence == -1)
	{
		ALERT ( at_console, "Dead commando with bad pose\n" );
	}

	
	pev->health			= 8;

	
	switch( pev->body )
	{
	case 0: // commando avec repeater
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_REPEATER );
		break;
	case 1: // commando sans arme
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_NONE );
		break;
	}

	MonsterInitDead();
}
