/***
*
*	Code pour Greedo le Rodien
*	Par Jean-Franois Vuagniaux
*	vuagniaux.jf@com.mcnet.ch
*
****/
//=========================================================
// Greedo petit contrebandier et homme de main tout vert
//=========================================================

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"monsters.h"
#include	"schedule.h"
#include	"squadmonster.h"
#include	"weapons.h"
#include	"soundent.h"
#include	"animation.h"


int m_Goisprite;
int m_Goismoke;
int  m_iGoTrail;
int m_GWallSmoke;
int m_NombreCoups;

//==========================================================
//Dfinitions spcifiques
//==========================================================

#define	GREEDO_CLIP_SIZE			25

#define GREEDO_PISTOL				( 1 << 0)

#define GUN_GROUP					1
#define GUN_PISTOL					0
#define GUN_NONE					1

#define GREEDO_LIMP_HEALTH			20

#define	GREEDO_MELEE_DIST			100

//=========================================================
// types de schedule spcifiques
//=========================================================
enum
{
	SCHED_GREEDO_SUPPRESS = LAST_COMMON_SCHEDULE + 1,
	SCHED_GREEDO_ESTABLISH_LINE_OF_FIRE,
	SCHED_GREEDO_COVER_AND_RELOAD,
	SCHED_GREEDO_ELOF_FAIL,
	SCHED_GREEDO_RECHERCHE,
	SCHED_GREEDO_DRAW_WEAPON,
	SCHED_GREEDO_HOLSTER,
};


//=========================================================
// taches spcifique
//=========================================================
enum 
{

	TASK_GREEDO_GET_PATH_TO_ENEMY_CORPSE = LAST_COMMON_TASK + 1,
	TASK_GREEDO_CHECK_FIRE,
};


//=========================================================
// conditions spcifiques
//=========================================================
#define bits_COND_GREEDO_NOFIRE	( bits_COND_SPECIAL1 )


int iGreedoMuzzleFlash;

//=========================================================
// evnements d'animation
//=========================================================
#define		GREEDO_AE_TIR1	( 1 )
#define		GREEDO_AE_LEFT_PUNCH ( 2 )
#define		GREEDO_AE_RIGHT_PUNCH ( 3 )
#define		GREEDO_AE_RELOAD		( 4 )
#define		GREEDO_AE_DROP_GUN		( 5 ) 
#define		GREEDO_AE_DRAW_WEAPON	( 6 )
#define		GREEDO_AE_HOLSTER		( 7 )
#define		GREEDO_AE_BLABLA		( 8 )




//=========================================================
// Classe du projectile Blaster du pistol ddu greedo
//=========================================================

class CGoBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_Mblastballs;
	int  m_Mblastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol

	
};

LINK_ENTITY_TO_CLASS( Goblaster, CGoBlaster );

TYPEDESCRIPTION	CGoBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CGoBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CGoBlaster, CBaseEntity );


void CGoBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "Goblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blastvert.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iGoTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}

void CGoBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 100 );		// r
			WRITE_BYTE( 255 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_Goismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}

}

void CGoBlaster::Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity )
{
	CGoBlaster *pGoBlast = GetClassPtr( (CGoBlaster *)NULL );
	pGoBlast->Spawn();
	
	UTIL_SetOrigin( pGoBlast->pev, MvecStart );
	pGoBlast->pev->velocity = MvecVelocity;
	pGoBlast->pev->euser1 = ENT(pevOwner);// euser1 reprend le propritaire car owner est mis  NULL pour le ricochet
	pGoBlast->pev->owner = NULL;		  // modifi pour que le ricochet du sabre l'atteigne, sinon pOther n'est pas touch.

	pGoBlast->SetThink ( Animate );
	pGoBlast->pev->nextthink = gpGlobals->time + 0.1;

}

void CGoBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iMPitch;
	m_Mblastglow = m_Goisprite;
	m_Mblastballs = m_Goisprite;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	// son de choc
	iMPitch = RANDOM_FLOAT( 90, 110 );

	
	
	
	entvars_t *pevAttacker = NULL;
	if ( pev->euser1 )
	{
		pevAttacker = VARS(pev->euser1);
	}

	if ( pev->euser1 == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}
	
	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}


	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		
		if ( !pOther->pev->takedamage )
		{
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			
			// sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_Mblastglow );		// modle
						WRITE_BYTE( 30 );	// dure
						WRITE_BYTE( 2 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_Mblastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 16 );	
						WRITE_SHORT( m_GWallSmoke );	// modle
						WRITE_BYTE( 10 );				//taille * 10
						WRITE_BYTE( 255 );				//luminosit
					MESSAGE_END();
		
		}
		else
		{
			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

				Vector Mcentre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, Mcentre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( Mcentre.x );	// pos
					WRITE_COORD( Mcentre.y );	
					WRITE_COORD( Mcentre.z + 6 );	
					WRITE_SHORT( m_Goismoke );		// model
					WRITE_BYTE( 3 );				// size * 10
					WRITE_BYTE( 255 );			// brightness
				MESSAGE_END();
			
				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, gSkillData.blasterDmg * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
					
				ApplyMultiDamage( pev, pevAttacker );
			
				if ( pOther->IsPlayer() )
				{
					m_NombreCoups++;
				}
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

class CGreedo : public CSquadMonster
{
public:
	void Spawn( void );
	void Precache( void );
	void SetYawSpeed ( void );
	int  Classify ( void );
	int  ISoundMask ( void );
	void HandleAnimEvent( MonsterEvent_t *pEvent );
	void SetObjectCollisionBox( void )
	{
		pev->absmin = pev->origin + Vector( -16, -16, 0 );
		pev->absmax = pev->origin + Vector( 16, 16, 65 );
	}

	Schedule_t* GetSchedule ( void );
	Schedule_t* GetScheduleOfType ( int Type );
	BOOL FCanCheckAttacks ( void );
	BOOL CheckMeleeAttack1 ( float flDot, float flDist );
	BOOL CheckRangeAttack1 ( float flDot, float flDist );
	void CheckAmmo ( void );
	void StartTask ( Task_t *pTask );
	
	void AlertSound( void );
	void DeathSound ( void );
	void PainSound ( void );
	void AttackSound ( void );
	
	void PrescheduleThink ( void );
	void TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType);
	int TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType );
	void GibMonster ( void );
	int IRelationship( CBaseEntity *pTarget );
	
	void StopTalking ( void );
	BOOL ShouldSpeak( void );
	
	void Shoot ( void );
	Vector GetGunPosition( void );
	BOOL	m_fStanding;
	BOOL    m_jesuismort;
	void SetActivity( Activity NewActivity );
	void BlaBla( void );
	void RunAI( void );

	CUSTOM_SCHEDULES;

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	static const char *pAttackHitSounds[];
	static const char *pAttackMissSounds[];
	static const char *pAttackSounds[];
	static const char *pDieSounds[];
	static const char *pPainSounds[];
	static const char *pIdleSounds[];
	static const char *pAlertSounds[];

	int		m_cClipSize;

	float	m_flNextPainTime;
	float	m_flNextSpeakTime;
	float	m_flNextWordTime;
	int		m_iLastWord;
	float   m_flNextAttackSound;
	BOOL    m_enalerte;
	BOOL	m_fGunDrawn;
	float	m_healthPaix;
	
};
LINK_ENTITY_TO_CLASS( monster_greedo, CGreedo );

TYPEDESCRIPTION	CGreedo::m_SaveData[] = 
{

	DEFINE_FIELD( CGreedo, m_flNextPainTime, FIELD_TIME ),
	DEFINE_FIELD( CGreedo, m_flNextSpeakTime, FIELD_TIME ),
	DEFINE_FIELD( CGreedo, m_flNextWordTime, FIELD_TIME ),
	DEFINE_FIELD( CGreedo, m_iLastWord, FIELD_INTEGER ),
	DEFINE_FIELD( CGreedo, m_cClipSize, FIELD_INTEGER ),
	DEFINE_FIELD( CGreedo, m_enalerte, FIELD_BOOLEAN ),
	DEFINE_FIELD( CGreedo, m_fGunDrawn, FIELD_BOOLEAN ),
};

IMPLEMENT_SAVERESTORE( CGreedo, CSquadMonster );

const char *CGreedo::pAttackHitSounds[] = 
{
	"zombie/claw_strike1.wav",
	"zombie/claw_strike2.wav",
	"zombie/claw_strike3.wav",
};

const char *CGreedo::pAttackMissSounds[] = 
{
	"zombie/claw_miss1.wav",
	"zombie/claw_miss2.wav",
};

const char *CGreedo::pAttackSounds[] =
{
	"greedo/gr_attack1.wav",
	"greedo/gr_attack2.wav",
	"greedo/gr_attack3.wav",
	"greedo/gr_attack4.wav",
	"greedo/gr_attack5.wav",
};

const char *CGreedo::pDieSounds[] =
{
	"greedo/gr_die1.wav",
	"greedo/gr_die2.wav",
	"greedo/gr_die3.wav",
	"greedo/gr_die4.wav",
	"greedo/gr_die5.wav",
	"greedo/gr_die6.wav",
};

const char *CGreedo::pPainSounds[] =
{
	"greedo/gr_pain1.wav",
	"greedo/gr_pain2.wav",
	"greedo/gr_pain3.wav",
	"greedo/gr_pain4.wav",
	"greedo/gr_pain5.wav",
	"greedo/gr_pain6.wav",
	"greedo/gr_pain7.wav",
	"greedo/gr_pain8.wav",
};

const char *CGreedo::pIdleSounds[] =
{
	"greedo/gr_idle1.wav",
	"greedo/gr_idle2.wav",
	"greedo/gr_idle3.wav",
	"greedo/gr_idle4.wav",
	"greedo/gr_idle5.wav",
	"greedo/gr_idle6.wav",
	"greedo/gr_idle8.wav",
	"greedo/gr_idle9.wav",
	"greedo/gr_idle10.wav",
	"greedo/gr_idle11.wav",
	"greedo/gr_idle12.wav",
	"greedo/gr_idle13.wav",
	"greedo/gr_idle14.wav",
	"greedo/gr_idle15.wav",
	"greedo/gr_idle16.wav",
	"greedo/gr_idle17.wav",
	"greedo/gr_idle18.wav",
	"greedo/gr_idle19.wav",
	"greedo/gr_idle20.wav",
	"greedo/gr_idle21.wav",
	"greedo/gr_idle22.wav",
	"greedo/gr_idle23.wav",
};

const char *CGreedo::pAlertSounds[] =
{
	"greedo/gr_alert1.wav",
	"greedo/gr_alert2.wav",
	"greedo/gr_alert3.wav",
	"greedo/gr_alert4.wav",
	"greedo/gr_alert5.wav",
	"greedo/gr_alert6.wav",
};

//=========================================================
// IRelationship .
//=========================================================
int CGreedo::IRelationship ( CBaseEntity *pTarget )
{
	if ( FClassnameIs( pTarget->pev, "monster_alien_grunt" ) )
	{
		return R_NM;
	}

	return CSquadMonster :: IRelationship( pTarget );
}

//=========================================================
// ISoundMask 
//=========================================================
int CGreedo :: ISoundMask ( void )
{
	return	bits_SOUND_WORLD	|
			bits_SOUND_COMBAT	|
			bits_SOUND_DANGER	|
			bits_SOUND_PLAYER;
}

//=========================================================
// TraceAttack
//=========================================================
void CGreedo :: TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	
	
		m_LastHitGroup = ptr->iHitgroup;

		switch ( ptr->iHitgroup )
		{
		case HITGROUP_GENERIC:
			break;
		case HITGROUP_HEAD:
			flDamage *= gSkillData.monHead;
			break;
		case HITGROUP_CHEST:
			flDamage *= gSkillData.monChest;
			break;
		case HITGROUP_STOMACH:
			flDamage *= gSkillData.monStomach;
			break;
		case HITGROUP_LEFTARM:
		case HITGROUP_RIGHTARM:
			flDamage *= gSkillData.monArm;
			break;
		case HITGROUP_LEFTLEG:
		case HITGROUP_RIGHTLEG:
			flDamage *= gSkillData.monLeg;
			break;
		default:
			break;
		}

		if ( bitsDamageType == DMG_SABER ) // pour comprendre, il faut couper la tte!
		{
			if ( ptr->iHitgroup == HITGROUP_HEAD )
			{
				if ( pev->health <= flDamage )
				{
					// code pour changer le modle (sans tte), 
					// crer une tte qui va rouler et jouer l'animation de mort correspondante.	
				}
			}
		}



		SpawnBlood(ptr->vecEndPos, BloodColor(), flDamage);
		TraceBleed( flDamage, vecDir, ptr, bitsDamageType );
		
		AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType );

}

int CGreedo :: TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType )
{
	Forget( bits_MEMORY_INCOVER );


	
	
	return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );
}
//=========================================================
// projette une arme
//=========================================================
 

void CGreedo :: GibMonster ( void )
{
	Vector	vecGunPos;
	Vector	vecGunAngles;

	if ( m_jesuismort )
	{
		return;
	}

	if ( GetBodygroup( 1 ) != 1 )
	{
		GetAttachment( 0, vecGunPos, vecGunAngles );
		
		CBaseEntity *pGun;
		
			pGun = DropItem( "weapon_pistol", vecGunPos, vecGunAngles );
	
		if ( pGun )
		{
			pGun->pev->velocity = Vector (RANDOM_FLOAT(-100,100), RANDOM_FLOAT(-100,100), RANDOM_FLOAT(200,300));
			pGun->pev->avelocity = Vector ( 0, RANDOM_FLOAT( 200, 400 ), 0 );
		}
	
		
	}

	CBaseMonster :: GibMonster();
}

//=========================================================
// StopTalking - ne parle plus pendant 10-20 secondes
//=========================================================
void CGreedo::StopTalking( void )
{
	m_flNextWordTime = m_flNextSpeakTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);
}

//=========================================================
// ShouldSpeak - est-ce qu'il doit parler?
//=========================================================
BOOL CGreedo::ShouldSpeak( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		
		return FALSE;
	}

	if ( pev->spawnflags & SF_MONSTER_GAG )
	{
		if ( m_MonsterState != MONSTERSTATE_COMBAT )
		{
			// si 'gag' est mis il ne parle pas hors du combat
			// on repousse un peu plus loim
			m_flNextSpeakTime = gpGlobals->time + 3;
			return FALSE;
		}
	}

	return TRUE;
}

//==================================================================
// BlaBla : Fonction qui fait parler le greedo pendant les pauses en 
// synchronisation avec les mouvements des lvres
//==================================================================

void CGreedo :: BlaBla ( void )
{
	
	int num = -1;

	if ( RANDOM_LONG(0, 10) > 6 )//ne bavarde pas tout le temps
	{
		do
			{
				num = RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1);
			} while( num == m_iLastWord );

			m_iLastWord = num;


						
		EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[ num ], 1.0, ATTN_NORM );
	}



}
//=========================================================
// PrescheduleThink 
//=========================================================
void CGreedo :: PrescheduleThink ( void )
{
	if ( ShouldSpeak() )
	{
		if ( m_flNextWordTime < gpGlobals->time )
		{
			int num = -1;

				switch	( m_MonsterState )
				{
				case MONSTERSTATE_IDLE:
					{
			
						
					}
					break;
				
				case MONSTERSTATE_COMBAT:// faut tre logique 
					{
			
						do
						{
							num = RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1);
						} while( num == m_iLastWord );

						m_iLastWord = num;

						
						EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[ num ], 1.0, ATTN_NORM );
					}
					break;

				}

			
			if ( RANDOM_LONG( 1, 10 ) <= 7 )
			{
				
				StopTalking();
			}
			else
			{
				m_flNextWordTime = gpGlobals->time + RANDOM_FLOAT( 3.5, 8 );
			}
		}
	}
}

//=========================================================
// DieSound
//=========================================================
void CGreedo :: DeathSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pDieSounds[RANDOM_LONG(0,ARRAYSIZE(pDieSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AlertSound
//=========================================================
void CGreedo :: AlertSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAlertSounds[RANDOM_LONG(0,ARRAYSIZE(pAlertSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AttackSound
//=========================================================
void CGreedo :: AttackSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// PainSound
//=========================================================
void CGreedo :: PainSound ( void )
{
	if ( m_flNextPainTime > gpGlobals->time )
	{
		return;
	}

	m_flNextPainTime = gpGlobals->time + 1.6;

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pPainSounds[RANDOM_LONG(0,ARRAYSIZE(pPainSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// Classify - position dans la table des relations
//=========================================================
int	CGreedo :: Classify ( void )
{
	float m_sante = gSkillData.greedoHealth;

	float m_health = pev-> health;

	float m_PlayerDamage = m_NombreCoups * gSkillData.blasterDmg;//dommages caus au joueur par le greedo

	//ALERT ( at_console, "DOMMAGE JOUEUR :%f\n", m_PlayerDamage );

	int m_arme = ArmeEnmain( );

	BOOL m_passif;

	if ( m_arme == WEAPON_NONE )
	{
		m_passif = 1;
	}

	if ( m_arme == WEAPON_HANDS )
	{
		m_passif = 1;
	}
	else
	{
		m_passif = 0;
	}


	if ( m_passif == 1 )
	{
		m_enalerte = FALSE;
	}

	if ( (m_sante - 5) > pev-> health )
	{ 
		if ( m_healthPaix == 0 || (m_health + 3)  < m_healthPaix )
		{		
			m_enalerte = TRUE;
			//ALERT ( at_console, "ENALERTE\n");
		}
		else 
		{
			m_enalerte = FALSE;
		}
	}

	if ( m_passif == 0 )
		{
			m_enalerte = TRUE;
		}

	if ( pev->health < m_sante * 0.5 )
		{
			m_enalerte = TRUE;
		}

	if ( m_MonsterState == MONSTERSTATE_COMBAT )//|| MONSTERSTATE_ALERT || MONSTERSTATE_HUNT )	
	{
		// ajout du contrle sur le fait que si le joueur n'a bless personne 
		// plus qu'il n'a t bless, l'ennemi redevient pacifique si le joueur range son arme
		if ( m_passif == 1 )
		{
		
			//ALERT ( at_console, "DOMMAGE Greedo :%f\n", (m_sante - m_health) );
			
			if ( (m_sante - m_health) <= m_PlayerDamage && pev->health > m_sante * 0.5 )
			{
				m_enalerte = FALSE; //a suffit, t'en a pris plein la gueule, on fait la paix.

				m_healthPaix = m_health;

				m_hEnemy = NULL;

				m_IdealMonsterState = MONSTERSTATE_IDLE;

				m_NombreCoups = 0;

			}
			else
			{
				m_enalerte = TRUE;
			}

		}
		
		else
		{
			m_enalerte = TRUE;
		}
		
		
		
		//ALERT ( at_console, "ENALERTE\n");
	}

	
	
	if ( m_enalerte )
	{
		
		return  CLASS_ALIEN_MILITARY;
	}

	else
	{
		
		return	CLASS_ALIEN_PASSIVE;
	}
	
}

//=========================================================
// SetYawSpeed - permet d'avoir un taux de rotation pour chaque squence
//=========================================================
void CGreedo :: SetYawSpeed ( void )
{
	int ys;

	switch ( m_Activity )
	{
	case ACT_IDLE:	
		ys = 150;		
		break;
	case ACT_RUN:	
		ys = 150;	
		break;
	case ACT_WALK:	
		ys = 180;		
		break;
	case ACT_RANGE_ATTACK1:	
		ys = 120;	
		break;
	case ACT_MELEE_ATTACK1:	
		ys = 120;	
		break;	
	case ACT_TURN_LEFT:
	case ACT_TURN_RIGHT:	
		ys = 180;
		break;
	case ACT_GLIDE:
	case ACT_FLY:
		ys = 30;
		break;
	default:
		ys = 90;
		break;
	}

	pev->yaw_speed = ys;
}

//=========================================================
// GetGunPosition	donne l'extrmit du canon
//=========================================================

Vector CGreedo :: GetGunPosition( )
{
	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); 
	return vecArmPos;
/*/
	if (m_fStanding )
	{
		return pev->origin + Vector( 0, 0, 60 );
	}
	else
	{
		return pev->origin + Vector( 0, 0, 48 );
	}
*/
}


//=========================================================
//Tir d'un projectile Blaster
//=========================================================

void CGreedo :: Shoot ( void )
{
	if (m_hEnemy == NULL)
	{
		return;
	}

	Vector vecShootOrigin = GetGunPosition();
	Vector vecShootDir = ShootAtEnemy( vecShootOrigin );

	UTIL_MakeVectors ( pev->angles );
	
	// code pour tirer un projectile de blaster
	// ajout de la dispersion du tir automatique rapide

	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_1DEGREES ;
	vecShootDir = vecShootDir + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;


	CGoBlaster::Shoot(pev,vecShootOrigin,vecShootDir * 2000);

	pev->effects |= EF_MUZZLEFLASH;
	
	m_cAmmoLoaded--;// retire un coup du chargeur!

	Vector angDir = UTIL_VecToAngles( vecShootDir );
	SetBlending( 0, angDir.x ); // donne l'inclinaison de tir du greedo pour l'animation
}

//=========================================================
// HandleAnimEvent - prend en compte les message spcifiques contenus dans les animations
// Retourne le nombre d'venements traits.
//=========================================================
void CGreedo :: HandleAnimEvent( MonsterEvent_t *pEvent )
{
	switch( pEvent->event )
	{

	case GREEDO_AE_BLABLA:
		
		{

			BlaBla();

		}

		break;


	case GREEDO_AE_DRAW_WEAPON:

		{
			if ( !m_jesuismort )
			{
				SetBodygroup( GUN_GROUP, GUN_PISTOL ); 
			}
			m_fGunDrawn = TRUE;
			
		}

		break;

	case GREEDO_AE_HOLSTER:

		{
			SetBodygroup( GUN_GROUP, GUN_NONE );
			m_fGunDrawn = FALSE;
			
		}

		break;

	case GREEDO_AE_DROP_GUN:
		
		{		
		Vector	vecGunPos;
		Vector	vecGunAngles;

		GetAttachment( 1, vecGunPos, vecGunAngles );

		// passe au corps sans arme
		SetBodygroup( GUN_GROUP, GUN_NONE );

		// cre un pistol
		
			 DropItem( "weapon_pistol", vecGunPos, vecGunAngles );
			 
			 m_jesuismort = 1;
		}

		break;

	case GREEDO_AE_RELOAD:
		
		
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, "stormt/st_reload1.wav", 1, ATTN_NORM );
			m_cAmmoLoaded = m_cClipSize;
	

		ClearConditions(bits_COND_NO_AMMO_LOADED);
		break;

	case GREEDO_AE_TIR1: 
		{
			// m_vecEnemyLKP doit tre le centre de l'ennemi
			Vector vecArmPos, vecArmDir;
			Vector vecDirToEnemy;
			Vector angDir;

			vecDirToEnemy = ( ( m_vecEnemyLKP ) - pev->origin );
			angDir = UTIL_VecToAngles( vecDirToEnemy );
			vecDirToEnemy = vecDirToEnemy.Normalize();
			
			GetAttachment( 0, vecArmPos, vecArmDir );
			
			TraceResult tr;

			//dernier contrle avant de tirer pour viter de toucher un collgue
			UTIL_TraceLine( vecArmPos, vecArmPos + vecDirToEnemy * 1024 , dont_ignore_monsters, ignore_glass, ENT(pev), &tr);
		
			CBaseEntity *pMonster;

			pMonster = Instance(tr.pHit);

			if ( pMonster->Classify() == Classify() )
			{
				ALERT(at_console, "Pousse toi Ducon!\n");
				break;//on arrte tout si c'est un ami
			}

			pev->effects = EF_MUZZLEFLASH;// clair de dpart du coup

			// make angles +-180
			if (angDir.x > 180)
			{
				angDir.x = angDir.x - 360;
			}

			SetBlending( 0, angDir.x );
			

			vecArmPos = vecArmPos + vecDirToEnemy * 32;
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecArmPos );
				WRITE_BYTE( TE_SPRITE );
				WRITE_COORD( vecArmPos.x );	// position
				WRITE_COORD( vecArmPos.y );	
				WRITE_COORD( vecArmPos.z );	
				WRITE_SHORT( iGreedoMuzzleFlash );		// model
				WRITE_BYTE( 6 );				// taille * 10
				WRITE_BYTE( 128 );			// luminosit
			MESSAGE_END();

			// code pour le tir d'un projectile blaster pistolet (vert)

			Shoot();

			if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/pist1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/pist2.wav", 1, ATTN_NORM );
				}


		}
		break;

	

	case GREEDO_AE_LEFT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( GREEDO_MELEE_DIST, ( gSkillData.greedoDmgPunch ) - 2, DMG_CLUB );
			
			if ( pHurt )//touch
			{
				pHurt->pev->punchangle.y = -25;
				pHurt->pev->punchangle.x = 8;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * 150;

					m_NombreCoups++;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				//Vector vecArmPos, vecArmAng;
				//GetAttachment( 0, vecArmPos, vecArmAng );
				//SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				// c'est rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}
		}
		break;

	case GREEDO_AE_RIGHT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( GREEDO_MELEE_DIST, gSkillData.greedoDmgPunch, DMG_CLUB );

			if ( pHurt )
			{
				pHurt->pev->punchangle.y = 25;
				pHurt->pev->punchangle.x = 8;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * -150;

					m_NombreCoups++;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				Vector vecArmPos, vecArmAng;
				GetAttachment( 0, vecArmPos, vecArmAng );
				SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				//caramba! encore rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}
		}
		break;

	default:
		CSquadMonster::HandleAnimEvent( pEvent );
		break;
	}
}


//========================================================
//vrifie la munitions
//========================================================

void CGreedo :: CheckAmmo ( void )
{
	if ( m_cAmmoLoaded <= 0 )
	{
		SetConditions(bits_COND_NO_AMMO_LOADED);
	}
}


//=========================================================
// Spawn
//=========================================================
void  CGreedo:: Spawn()
{
	Precache( );

	SET_MODEL(ENT(pev), "models/greedo.mdl");
	UTIL_SetSize(pev, Vector(-16, -16, 0), Vector(16, 16, 50));

	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_STEP;
	m_bloodColor		= BLOOD_COLOR_GREEN;
	pev->effects		= 0;
	pev->health			= gSkillData.greedoHealth;
	m_flFieldOfView		= 0.2;
	m_MonsterState		= MONSTERSTATE_NONE;
	m_afCapability		|= bits_CAP_SQUAD | bits_CAP_TURN_HEAD | bits_CAP_DOORS_GROUP;

	m_flNextSpeakTime	= m_flNextWordTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);

	m_HackedGunPos = Vector ( 0, 0, 45 );

	pev->iuser3	= 1;
	pev->iuser4	= 1;//incendie
	
	if (pev->weapons == 0)
	{
		
		pev->weapons = GREEDO_PISTOL ;
				
	}

	if (FBitSet( pev->weapons, GREEDO_PISTOL ))
	{
		SetBodygroup( GUN_GROUP, GUN_NONE );// classify mettra ensuite le bon modle selon l'tat de l'AI
		m_cClipSize		= GREEDO_CLIP_SIZE;

	}
	
	m_cAmmoLoaded		= m_cClipSize;

	m_healthPaix		= 0;
	m_fGunDrawn			= FALSE;

	MonsterInit();
}

//=========================================================
// Precache - met en prcache les ressources
//=========================================================
void CGreedo :: Precache()
{
	int i;

	PRECACHE_MODEL("models/greedo.mdl");

	for ( i = 0; i < ARRAYSIZE( pAttackHitSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackHitSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackMissSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackMissSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pIdleSounds ); i++ )
		PRECACHE_SOUND((char *)pIdleSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pDieSounds ); i++ )
		PRECACHE_SOUND((char *)pDieSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pPainSounds ); i++ )
		PRECACHE_SOUND((char *)pPainSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAlertSounds ); i++ )
		PRECACHE_SOUND((char *)pAlertSounds[i]);


	PRECACHE_SOUND( "weapons/pist1.wav" );
	PRECACHE_SOUND( "stormt/st_reload1.wav" );
	
  
	iGreedoMuzzleFlash = PRECACHE_MODEL( "sprites/muz4.spr" );

	m_Goisprite = PRECACHE_MODEL( "sprites/hotglow.spr" ); //pour le tir du blaster
	m_Goismoke = PRECACHE_MODEL( "sprites/blasthit.spr" ); //pour l'impacte du blaster
	m_iGoTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	PRECACHE_MODEL( "sprites/blastvert.spr" );
	m_GWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
}	
	
//=========================================================
// AI Schedules spcifiques au greedo
//=========================================================

//=========================================================
// Fail Schedule
//=========================================================
Task_t	tlGreedoFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT,				(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slGreedoFail[] =
{
	{
		tlGreedoFail,
		ARRAYSIZE ( tlGreedoFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Greedo Fail"
	},
};

//=========================================================
// Combat Fail Schedule
//=========================================================
Task_t	tlGreedoCombatFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT_FACE_ENEMY,		(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slGreedoCombatFail[] =
{
	{
		tlGreedoCombatFail,
		ARRAYSIZE ( tlGreedoCombatFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Greedo Combat Fail"
	},
};

//=========================================================
// Standoff schedule. Utilis en combat lorsque le monstre a perdu de vue l'ennemi
// Doit-on aller voir dans le coin?
//=========================================================
Task_t	tlGreedoStandoff[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_ACTIVITY,			(float)ACT_IDLE				},
	{ TASK_WAIT_FACE_ENEMY,			(float)2					},
};

Schedule_t slGreedoStandoff[] = 
{
	{
		tlGreedoStandoff,
		ARRAYSIZE ( tlGreedoStandoff ),
		bits_COND_CAN_RANGE_ATTACK1		|
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_SEE_ENEMY				|
		bits_COND_NEW_ENEMY				|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Greedo Standoff"
	}
};


//=========================================================
// primary range attacks
//=========================================================
Task_t	tlGreedoRangeAttack1[] =
{
	{ TASK_STOP_MOVING,			(float)0		},
	{ TASK_FACE_ENEMY,			(float)0		},
	{ TASK_RANGE_ATTACK1,		(float)0		},
};

Schedule_t	slGreedoRangeAttack1[] =
{
	{ 
		tlGreedoRangeAttack1,
		ARRAYSIZE ( tlGreedoRangeAttack1 ), 
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Greedo Range Attack1"
	},
};


//=========================================================
// Se mettre  couvert, d'abord de ct puis vers un noeud
//=========================================================
Task_t	tlGreedoTakeCoverFromEnemy[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SMALL_FLINCH,			(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slGreedoTakeCoverFromEnemy[] =
{
	{ 
		tlGreedoTakeCoverFromEnemy,
		ARRAYSIZE ( tlGreedoTakeCoverFromEnemy ), 
		bits_COND_NEW_ENEMY |
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"GreedoTakeCoverFromEnemy"
	},
};

//Attention aux grenades

Task_t	tlGreedoTakeCoverFromBestSound[] =
{
	{ TASK_SET_FAIL_SCHEDULE,			(float)SCHED_COWER	},
	{ TASK_STOP_MOVING,					(float)0					},
	{ TASK_FIND_COVER_FROM_BEST_SOUND,	(float)0					},
	{ TASK_RUN_PATH,					(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,			(float)0					},
	{ TASK_REMEMBER,					(float)bits_MEMORY_INCOVER	},
	{ TASK_TURN_LEFT,					(float)179					},
};

Schedule_t	slGreedoTakeCoverFromBestSound[] =
{
	{ 
		tlGreedoTakeCoverFromBestSound,
		ARRAYSIZE ( tlGreedoTakeCoverFromBestSound ), 
		bits_COND_NEW_ENEMY,
		0,
		"GreedoTakeCoverFromBestSound"
	},
};


//=========================================================
// J'ai gagn !!!
//=========================================================
Task_t	tlGreedoVictoryDance[] =
{
	{ TASK_STOP_MOVING,						(float)0					},
	{ TASK_WAIT,							(float)0.2					},
	{ TASK_GREEDO_GET_PATH_TO_ENEMY_CORPSE,	(float)0					},
	{ TASK_WALK_PATH,						(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,				(float)0					},
	{ TASK_FACE_ENEMY,						(float)0					},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_CROUCH			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_STAND			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_CROUCH			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_STAND			},
};

Schedule_t	slGreedoVictoryDance[] =
{
	{ 
		tlGreedoVictoryDance,
		ARRAYSIZE ( tlGreedoVictoryDance ), 
		bits_COND_NEW_ENEMY		|
		bits_COND_LIGHT_DAMAGE	|
		bits_COND_HEAVY_DAMAGE,
		0,
		"GreedoVictoryDance"
	},
};

Task_t	tlGreedoSuppress[] =
{
	{ TASK_STOP_MOVING,			0							},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_GREEDO_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_GREEDO_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_GREEDO_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_GREEDO_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_GREEDO_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
};

Schedule_t	slGreedoSuppress[] =
{
	{ 
		tlGreedoSuppress,
		ARRAYSIZE ( tlGreedoSuppress ), 
		bits_COND_ENEMY_DEAD		|
		bits_COND_LIGHT_DAMAGE		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_HEAR_SOUND		|
		bits_COND_GREEDO_NOFIRE		|
		bits_COND_NO_AMMO_LOADED,

		bits_SOUND_DANGER,
		"Suppress"
	},
};

//=========================================================
// Greedo reload schedule
//=========================================================
Task_t	tlGreedoHideReload[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RELOAD			},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
	{ TASK_PLAY_SEQUENCE,			(float)ACT_RELOAD			},
};

Schedule_t slGreedoHideReload[] = 
{
	{
		tlGreedoHideReload,
		ARRAYSIZE ( tlGreedoHideReload ),
		bits_COND_HEAVY_DAMAGE	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"GreedoHideReload"
	}
};

// Recherche l'ennemi

Task_t tlGreedoHunt[] = 
{
	{ TASK_GET_PATH_TO_ENEMY,	(float)0		},
	{ TASK_RUN_PATH,			(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0		},
};

Schedule_t slGreedoHunt[] =
{
	{ 
		tlGreedoHunt,
		ARRAYSIZE ( tlGreedoHunt ),
		bits_COND_NEW_ENEMY			|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"GreedoHunt"
	},
};

//=========================================================
// Establish line of fire - dplace vers une position de tir
//=========================================================
Task_t tlGreedoEstablishLineOfFire[] = 
{
	{ TASK_SET_FAIL_SCHEDULE,	(float)SCHED_GREEDO_ELOF_FAIL	},
	{ TASK_GET_PATH_TO_ENEMY,	(float)0						},					
	{ TASK_RUN_PATH,			(float)0						},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0						},
};

Schedule_t slGreedoEstablishLineOfFire[] =
{
	{ 
		tlGreedoEstablishLineOfFire,
		ARRAYSIZE ( tlGreedoEstablishLineOfFire ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"GreedoEstablishLineOfFire"
	},
};

Task_t tlGreedoRecherche[] =
{
	{ TASK_GET_PATH_TO_SPOT,		(float)0		},
	{ TASK_RUN_PATH,				(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0		},
};

Schedule_t slGreedoRecherche[] =
{
	{
		tlGreedoRecherche,
		ARRAYSIZE ( tlGreedoRecherche ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"GreedoRecherche"
	},
};

Task_t   tlGreedoDrawWeapon[] =
{
	{ TASK_STOP_MOVING,				0			},		
	{ TASK_FACE_ENEMY,				0			},
	{ TASK_PLAY_SEQUENCE_FACE_ENEMY, 	(float)  ACT_ARM 	},
};

Schedule_t   slGreedoDrawWeapon[] =
{
	{ 
		tlGreedoDrawWeapon,
		ARRAYSIZE ( tlGreedoDrawWeapon ),
		0,
		0,
		"Greedo Draw Weapon"
	}
};

Task_t   tlGreedoHolster[] =
{
	{ TASK_STOP_MOVING,				0					},		
	{ TASK_WAIT,					(float)0.2			},
	{ TASK_PLAY_SEQUENCE, 			(float)  ACT_DISARM 	},
};

Schedule_t   slGreedoHolster[] =
{
	{ 
		tlGreedoHolster,
		ARRAYSIZE ( tlGreedoHolster ),
		0,
		0,
		"Greedo Holster Weapon"
	}
};

//=========================================================
//=========================================================

DEFINE_CUSTOM_SCHEDULES( CGreedo )
{
	slGreedoFail,
	slGreedoCombatFail,
	slGreedoStandoff,
	slGreedoRangeAttack1,
	slGreedoTakeCoverFromEnemy,
	slGreedoTakeCoverFromBestSound,
	slGreedoVictoryDance,
	slGreedoHideReload,
	slGreedoSuppress,
	slGreedoEstablishLineOfFire,
	slGreedoHunt,
	slGreedoRecherche,
	slGreedoDrawWeapon,
	slGreedoHolster,
	
};

IMPLEMENT_CUSTOM_SCHEDULES( CGreedo, CSquadMonster );

//=========================================================
// FCanCheckAttacks 
//=========================================================
BOOL CGreedo :: FCanCheckAttacks ( void )
{
	if ( !HasConditions( bits_COND_ENEMY_TOOFAR ) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//=========================================================
// CheckMeleeAttack1 
//=========================================================
BOOL CGreedo :: CheckMeleeAttack1 ( float flDot, float flDist )
{
	
	CBaseMonster *pEnemy;

	if ( m_hEnemy != NULL )
	{
		pEnemy = m_hEnemy->MyMonsterPointer();

		if ( !pEnemy )
		{
			return FALSE;
		}
	}

	if ( flDist <= 64 && flDot >= 0.7	&& 
		 pEnemy->Classify() != CLASS_ALIEN_BIOWEAPON &&
		 pEnemy->Classify() != CLASS_PLAYER_BIOWEAPON )
	{
		return TRUE;
	}
	return FALSE;
	
}

//=========================================================
// CheckRangeAttack1 
//=========================================================
BOOL CGreedo :: CheckRangeAttack1 ( float flDot, float flDist )
{
	

	if ( !HasConditions( bits_COND_ENEMY_OCCLUDED ) && flDist <= 2048 && flDot >= 0.5 && NoFriendlyFire() )
	{
		TraceResult	tr;
		
		
		if ( !m_hEnemy->IsPlayer() && flDist <= 64 )
		{
			
			return FALSE;
		}

		Vector vecSrc = GetGunPosition();

		
		UTIL_TraceLine( vecSrc, m_hEnemy->BodyTarget(vecSrc), ignore_monsters, ignore_glass, ENT(pev), &tr);

		if ( tr.flFraction == 1.0 ) //si gal  1 cel veut dire que la voie est libre
		{
			return TRUE;
		}
	}

	return FALSE;
}

//=========================================================
// StartTask
//=========================================================
void CGreedo :: StartTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_GREEDO_GET_PATH_TO_ENEMY_CORPSE:
		{
			UTIL_MakeVectors( pev->angles );
			if ( BuildRoute ( m_vecEnemyLKP - gpGlobals->v_forward * 50, bits_MF_TO_LOCATION, NULL ) )
			{
				TaskComplete();
			}
			else
			{
				ALERT ( at_aiconsole, "GreedoGetPathToEnemyCorpse failed!!\n" );
				TaskFail();
			}
		}
		break;

	case TASK_GREEDO_CHECK_FIRE:
		if ( !NoFriendlyFire() )
		{
			SetConditions( bits_COND_GREEDO_NOFIRE );
		}
		TaskComplete();
		break;

	case TASK_WALK_PATH:
	case TASK_RUN_PATH:
		
		Forget( bits_MEMORY_INCOVER );
		CSquadMonster ::StartTask( pTask );
		break;
		
	case TASK_RELOAD:
		m_IdealActivity = ACT_RELOAD;
		break;

	case TASK_FACE_IDEAL:
	case TASK_FACE_ENEMY:
		CSquadMonster :: StartTask( pTask );
		if (pev->movetype == MOVETYPE_FLY)
		{
			m_IdealActivity = ACT_GLIDE;
		}
		break;

	default: 
		CSquadMonster :: StartTask( pTask );
		break;
	}
}

//===================================================
//Activits dpendant de l'tat actuel
//===================================================

void CGreedo :: SetActivity ( Activity NewActivity )
{
	int	iSequence = ACTIVITY_NOT_AVAILABLE;
	void *pmodel = GET_MODEL_PTR( ENT(pev) );

	switch ( NewActivity)
	{
	case ACT_RANGE_ATTACK1:
		
		
		if ( m_fStanding )
		{
				
			iSequence = LookupSequence( "standing_pistol" );
		}
		else
		{
			
			iSequence = LookupSequence( "standing_pistol" );
		}
				
		break;
	
	case ACT_RUN:
		if ( pev->health <= GREEDO_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_RUN_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_WALK:
		if ( pev->health <= GREEDO_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_WALK_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_IDLE:
		if ( m_MonsterState == MONSTERSTATE_COMBAT )
		{
			NewActivity = ACT_IDLE_ANGRY;
		}
		iSequence = LookupActivity ( NewActivity );
		break;
	default:
		iSequence = LookupActivity ( NewActivity );
		break;
	}
	
	m_Activity = NewActivity; 

	
	if ( iSequence > ACTIVITY_NOT_AVAILABLE )
	{
		if ( pev->sequence != iSequence || !m_fSequenceLoops )
		{
			pev->frame = 0;
		}

		pev->sequence		= iSequence;	
		ResetSequenceInfo( );
		SetYawSpeed();
	}
	else
	{
		
		ALERT ( at_console, "%s has no sequence for act:%d\n", STRING(pev->classname), NewActivity );
		pev->sequence		= 0;	
	}
}

void CGreedo::RunAI( void )
{

	CBaseMonster :: RunAI();

	

	//ALERT( at_console, "INCENDIE %i\n: ", pev->iuser4);

	//ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
}
//=========================================================
// GetSchedule - dcide du type de schedule qui convient le mieux
// Appelle ensuite la fonction pour obtenir un pointeur vers la schedule 
// qui convient
//=========================================================

Schedule_t *CGreedo :: GetSchedule ( void )
{
	
	
	switch	( m_MonsterState )
	{


	case MONSTERSTATE_IDLE:
		{

			
			//ALERT ( at_console, "IDLE\n");
			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					//ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_INVESTIGATE_SOUND );
				}
			}

			if ( m_fGunDrawn )
			{
				return GetScheduleOfType( SCHED_GREEDO_HOLSTER );
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}

		}
		break;
	
	
	case MONSTERSTATE_ALERT:
		{
			

			//ALERT ( at_console, "ALERT\n");
			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_INVESTIGATE_SOUND );
				}
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}
		}
		break;

	
	case MONSTERSTATE_COMBAT:
		{
			

			//ALERT ( at_console, "COMBAT\n");
			if ( HasConditions( bits_COND_ENEMY_DEAD ) )
			{
				
				return CBaseMonster :: GetSchedule();
			}

			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
			}

			if ( pev->iuser4 == 2 )
			{
				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}

			if ( HasConditions(bits_COND_NEW_ENEMY) )
			{
				
				return GetScheduleOfType( SCHED_WAKE_ANGRY );
			}

			if ( !m_fGunDrawn )
			{
				return GetScheduleOfType( SCHED_GREEDO_DRAW_WEAPON );
			}

			else if ( HasConditions ( bits_COND_NO_AMMO_LOADED ) )
			{
				
				return GetScheduleOfType ( SCHED_GREEDO_COVER_AND_RELOAD );
			}

	// zap player!
			if ( HasConditions ( bits_COND_CAN_MELEE_ATTACK1 ) )
			{
				
				if ( m_flNextAttackSound < gpGlobals->time )// pas  chaque fois
				{
					AttackSound();
			
					m_flNextAttackSound = gpGlobals->time + 10;// on verra tout  l'heure
				}

				
				return GetScheduleOfType ( SCHED_MELEE_ATTACK1 );
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) )
			{
				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ENEMY );
			}


			if ( HasConditions( bits_COND_SEE_ENEMY ) && !HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) )
			{
				
				return GetScheduleOfType ( SCHED_GREEDO_ESTABLISH_LINE_OF_FIRE );
			}

			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) && OccupySlot ( bits_SLOTS_GREEDO_TIR ) )
			{
				return GetScheduleOfType ( SCHED_RANGE_ATTACK1 );
			}

			if ( OccupySlot ( bits_SLOT_GREEDO_CHASE ) )
			{
				return GetScheduleOfType ( SCHED_CHASE_ENEMY );
			}
			
		}

		return GetScheduleOfType ( SCHED_STANDOFF );
	}

	return CSquadMonster :: GetSchedule();
}

//=========================================================
//=========================================================
Schedule_t* CGreedo :: GetScheduleOfType ( int Type ) 
{
	switch	( Type )
	{

	case SCHED_GREEDO_HOLSTER:

		return	&slGreedoHolster[ 0 ];

		break;

	case SCHED_GREEDO_DRAW_WEAPON:
		if ( m_hEnemy != NULL )
		{
			return &slGreedoDrawWeapon[ 0 ];
		}
		break;

	case SCHED_TAKE_COVER_FROM_ENEMY:
		return &slGreedoTakeCoverFromEnemy[ 0 ];

	case SCHED_TAKE_COVER_FROM_BEST_SOUND:
		return &slGreedoTakeCoverFromBestSound[ 0 ];
		break;
	
	case SCHED_CHASE_ENEMY:
		return &slGreedoHunt[ 0 ];	
	
	case SCHED_RANGE_ATTACK1:
		
			return &slGreedoRangeAttack1[ 0 ];
				
		break;

	case SCHED_STANDOFF:
		return &slGreedoStandoff[ 0 ];
		break;

	case SCHED_GREEDO_RECHERCHE:
		return &slGreedoRecherche[ 0 ];
		break;

	case SCHED_VICTORY_DANCE:
		return &slGreedoVictoryDance[ 0 ];
		break;

	case SCHED_GREEDO_ELOF_FAIL:
		{			
			return GetScheduleOfType ( SCHED_TAKE_COVER_FROM_ENEMY );
		}
		break;

	case SCHED_GREEDO_ESTABLISH_LINE_OF_FIRE:
		{
			return &slGreedoEstablishLineOfFire[ 0 ];
		}
		break;

	case SCHED_GREEDO_COVER_AND_RELOAD:
		{
			return &slGreedoHideReload[ 0 ];
		}

	case SCHED_FAIL:
			
		{
			if ( m_hEnemy != NULL )
			{
				
				return &slGreedoCombatFail[ 0 ];
			}

			return &slGreedoFail[ 0 ];
		}
		break;

	}

	return CSquadMonster :: GetScheduleOfType( Type );
}

//=========================================================
// Classe  pour un cadavre de greedo
//=========================================================
class CDeadGreedo : public CBaseMonster
{
public:
	void Spawn( void );
	int	Classify ( void ) { return	CLASS_ALIEN_MILITARY; }

	void KeyValue( KeyValueData *pkvd );

	int	m_iPose;
	static char *m_szPoses[3];
};

char *CDeadGreedo::m_szPoses[] = { "deadstomach", "deadside", "deadsitting" };

void CDeadGreedo::KeyValue( KeyValueData *pkvd )
{
	if (FStrEq(pkvd->szKeyName, "pose"))
	{
		m_iPose = atoi(pkvd->szValue);
		pkvd->fHandled = TRUE;
	}
	else 
		CBaseMonster::KeyValue( pkvd );
}

LINK_ENTITY_TO_CLASS( monster_greedo_dead, CDeadGreedo );

//=========================================================
// ********** Cadavre de greedo **********
//=========================================================
void CDeadGreedo :: Spawn( void )
{
	PRECACHE_MODEL("models/greedo.mdl");
	SET_MODEL(ENT(pev), "models/greedo.mdl");

	pev->effects		= 0;
	pev->yaw_speed		= 8;
	pev->sequence		= 0;
	m_bloodColor		= BLOOD_COLOR_GREEN;

	pev->sequence = LookupSequence( m_szPoses[m_iPose] );

	if (pev->sequence == -1)
	{
		ALERT ( at_console, "Dead greedo with bad pose\n" );
	}

	
	pev->health			= 8;

	
	switch( pev->body )
	{
	case 0: // greedo avec pistolet
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_PISTOL );
		break;
	case 1: // greedo sans arme
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_NONE );
		break;
	}

	MonsterInitDead();
}
