/***
*
*	Code pour l'Hugnauth, petit ouvrier avec un tte de cochon gris
*   Par Jean-Franois Vuagniaux
*	vuagniaux.jf@com.mcnet.ch
*
****/
//==========================================================
// Hugnauth petit ouvrier non syndiqu pay au lance-pierres
//==========================================================
#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"monsters.h"
#include	"schedule.h"
#include	"weapons.h"
#include	"soundent.h"
#include	"animation.h"
#include	"nodes.h"

//=========================================================
// evnements d'animation
//=========================================================
#define HUG_AE_BLABLA   ( 1 )


//==========================================================
//Dfinitions des groupe du modle
//==========================================================
#define TOOL_GROUP					1	//groupe des outils
#define TOOL_NONE					0	
#define TOOL_WRENCH					1	//outil en main

//==========================================================
//Dfinitions spcifiques (arme/outils)
//==========================================================

#define HUG_WRENCH				( 1 << 0)

//=========================================================
// types de schedule spcifiques
//=========================================================
enum
{
	SCHED_HUG_WORK = LAST_COMMON_SCHEDULE + 1,
	SCHED_HUG_WALKAROUND,
	SCHED_HUG_TALK,
};


//=========================================================
// taches spcifique
//=========================================================
enum 
{
	TASK_HUG_FIND_HINTNODE = LAST_COMMON_TASK + 1,
	TASK_HUG_FIND_FRIEND,   //on recherche un autre ouvrier prs d'un hintnode
	TASK_HUG_PLAY_ACTIVITY, //arriv  un hintnode, il va effectuer une animation dfinie par le hintnode
	TASK_HUG_PLAY_DIALOG,	//arriv vers un collgue, il va lui parler
	TASK_HUG_FACE_FRIEND,	//se tourne vers son interlocuteur
};



class CHug : public CBaseMonster
{
public:
	void Spawn( void );
	void Precache( void );
	void SetYawSpeed( void );
	int  Classify ( void );
	void HandleAnimEvent( MonsterEvent_t *pEvent );
	int ISoundMask ( void );

	void SetObjectCollisionBox( void )
	{
		pev->absmin = pev->origin + Vector( -16, -16, 0 );
		pev->absmax = pev->origin + Vector( 16, 16, 65 );
	}

	void PrescheduleThink ( void );
	Schedule_t* GetSchedule ( void );
	Schedule_t* GetScheduleOfType ( int Type );

	void SetActivity( Activity NewActivity );
	int FindWorkNode(void);
	int FValidateHintType ( short sHint );
	int FindFRiend( void );

	void Use(CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value);

	void AlertSound( void );
	void DeathSound ( void );
	void PainSound ( void );
	void StopTalking ( void );
	BOOL ShouldSpeak( void );
	void BlaBla( void );

	CUSTOM_SCHEDULES;

	static const char *pDieSounds[];
	static const char *pPainSounds[];
	static const char *pIdleSounds[];
	static const char *pAlertSounds[];

	virtual int	Save( CSave &save ); 
	virtual int Restore( CRestore &restore );
	static TYPEDESCRIPTION m_SaveData[];

	void StartTask( Task_t *pTask );
	void RunTask( Task_t *pTask );
	int  TakeDamage( entvars_t* pevInflictor, entvars_t* pevAttacker, float flDamage, int bitsDamageType );
	void TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType);
	
	float	m_flNextPainTime;
	float	m_flNextSpeakTime;
	float	m_flNextWordTime;
	int		m_iLastWord;

	CBaseEntity *Friend;
	CBaseEntity *Activator;
};
LINK_ENTITY_TO_CLASS( monster_hug, CHug );


TYPEDESCRIPTION	CHug::m_SaveData[] = 
{
	DEFINE_FIELD( CHug, m_flNextPainTime, FIELD_TIME ),
	DEFINE_FIELD( CHug, m_flNextSpeakTime, FIELD_TIME ),
	DEFINE_FIELD( CHug, m_flNextWordTime, FIELD_TIME ),
	DEFINE_FIELD( CHug, m_iLastWord, FIELD_INTEGER ),
	DEFINE_FIELD( CHug, Friend, FIELD_ENTITY ),
	DEFINE_FIELD( CHug, Activator, FIELD_ENTITY ),
};
IMPLEMENT_SAVERESTORE( CHug, CBaseMonster );

const char *CHug::pDieSounds[] =
{
	"hugn/hg_die1.wav",
	"hugn/hg_die2.wav",
	"hugn/hg_die3.wav",
};

const char *CHug::pPainSounds[] =
{
	"hugn/hg_pain1.wav",
	"hugn/hg_pain2.wav",
	"hugn/hg_pain3.wav",
	"hugn/hg_pain4.wav",
	"hugn/hg_pain5.wav",
};

const char *CHug::pIdleSounds[] =
{
	"hugn/hg_idle1.wav",
	"hugn/hg_idle2.wav",
	"hugn/hg_idle3.wav",
	"hugn/hg_idle4.wav",
	"hugn/hg_idle5.wav",
	"hugn/hg_idle6.wav",
	"hugn/hg_idle8.wav",
};

const char *CHug::pAlertSounds[] =
{
	"hugn/hg_alert1.wav",
	"hugn/hg_alert2.wav",
	"hugn/hg_alert3.wav",
	"hugn/hg_alert4.wav",
};
//=========================================================
// Classify - indicates this monster's place in the 
// relationship table.
//=========================================================
int	CHug :: Classify ( void )
{
	return	CLASS_ALIEN_PASSIVE;
}

//=========================================================
// SetYawSpeed - allows each sequence to have a different
// turn rate associated with it.
//=========================================================
void CHug :: SetYawSpeed ( void )
{
	int ys;

	switch ( m_Activity )
	{
	case ACT_RUN:	
		ys = 150;	
	break;
	case ACT_IDLE:
		ys = 90;
	break;
	default:
		ys = 90;
	break;
	}

	pev->yaw_speed = ys;
}

//=========================================================
// HandleAnimEvent - catches the monster-specific messages
// that occur when tagged animation frames are played.
//=========================================================
void CHug :: HandleAnimEvent( MonsterEvent_t *pEvent )
{
	switch( pEvent->event )
	{
	case HUG_AE_BLABLA:
		
		{
			BlaBla();//c'est un bavard ce type l
		}
		break;
	default:
		CBaseMonster::HandleAnimEvent( pEvent );
		break;
	}
}

//=========================================================
// ISoundMask - son que le Hugnauth peut entendre
//=========================================================
int CHug :: ISoundMask ( void )
{
	return	bits_SOUND_WORLD	|
			bits_SOUND_COMBAT	|
			bits_SOUND_DANGER	|
			bits_SOUND_PLAYER;
}

//=========================================================
// Spawn
//=========================================================
void CHug :: Spawn()
{
	Precache();

	SET_MODEL( ENT(pev), "models/hug.mdl" );
	UTIL_SetSize(pev, Vector(-16, -16, 0), Vector(16, 16, 50));

	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_STEP;
	m_bloodColor		= BLOOD_COLOR_YELLOW;
	pev->effects		= 0;
	pev->health			= gSkillData.civilHealth;
	m_flFieldOfView		= 0.5; //cne de vision
	m_MonsterState		= MONSTERSTATE_NONE;
	m_afCapability		|= bits_CAP_TURN_HEAD | bits_CAP_DOORS_GROUP;

	m_flNextSpeakTime	= m_flNextWordTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);

	pev->iuser3	= 1;//masse
	pev->iuser4	= 1;//incendie
	
	if (pev->weapons == 0)
	{		
		pev->weapons = HUG_WRENCH ;				
	}

	if (FBitSet( pev->weapons, HUG_WRENCH ))//par defaut on prend la cl  molette
	{
		SetBodygroup( TOOL_GROUP, TOOL_WRENCH );
	}

	MonsterInit();
}

//=========================================================
// Precache - precache les ressources
//=========================================================
void CHug :: Precache()
{
	int i;

	PRECACHE_MODEL( "models/hug.mdl" );

	for ( i = 0; i < ARRAYSIZE( pIdleSounds ); i++ )
		PRECACHE_SOUND((char *)pIdleSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pDieSounds ); i++ )
		PRECACHE_SOUND((char *)pDieSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pPainSounds ); i++ )
		PRECACHE_SOUND((char *)pPainSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAlertSounds ); i++ )
		PRECACHE_SOUND((char *)pAlertSounds[i]);

}	


//=========================================================
// Takedamage si les hitgroups ne sont pas pris en compte
//=========================================================
int CHug :: TakeDamage( entvars_t* pevInflictor, entvars_t* pevAttacker, float flDamage, int bitsDamageType )
{
	if ( pevInflictor && pevInflictor->flags & FL_CLIENT )
	{
		Remember( bits_MEMORY_PROVOKED );
		StopFollowing( TRUE );
	}

	
	return CBaseMonster::TakeDamage(pevInflictor, pevAttacker, flDamage, bitsDamageType);
}

//=========================================================
// TraceAttack si les hitgroups sont pris en compte
//=========================================================
void CHug::TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	m_LastHitGroup = ptr->iHitgroup;

		switch ( ptr->iHitgroup )
		{
		case HITGROUP_GENERIC:
			break;
		case HITGROUP_HEAD:
			flDamage *= gSkillData.monHead;
			break;
		case HITGROUP_CHEST:
			flDamage *= gSkillData.monChest;
			break;
		case HITGROUP_STOMACH:
			flDamage *= gSkillData.monStomach;
			break;
		case HITGROUP_LEFTARM:
		case HITGROUP_RIGHTARM:
			flDamage *= gSkillData.monArm;
			break;
		case HITGROUP_LEFTLEG:
		case HITGROUP_RIGHTLEG:
			flDamage *= gSkillData.monLeg;
			break;
		default:
			break;
		}

		if ( bitsDamageType == DMG_SABER ) // Confucius a dit : pour comprendre, il faut couper la tte!
		{
			if ( ptr->iHitgroup == HITGROUP_HEAD )
			{
				if ( pev->health <= flDamage )
				{
					//  faire:
					// code pour changer le modle (sans tte), 
					// crer une tte qui va rouler 	
				}
			}
		}



		SpawnBlood(ptr->vecEndPos, BloodColor(), flDamage);
		TraceBleed( flDamage, vecDir, ptr, bitsDamageType );
		
		AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType );
}

//=========================================================
// StopTalking - ne parle plus pendant 10-20 secondes
//=========================================================
void CHug::StopTalking( void )
{
	m_flNextWordTime = m_flNextSpeakTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);
}

//=========================================================
// ShouldSpeak - est-ce qu'il doit parler?
//=========================================================
BOOL CHug::ShouldSpeak( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		
		return FALSE;
	}

	if ( pev->spawnflags & SF_MONSTER_GAG )
	{
		if ( m_MonsterState != MONSTERSTATE_COMBAT )
		{
			// si 'gag' est mis il ne parle pas hors du combat
			// on repousse un peu plus loim
			m_flNextSpeakTime = gpGlobals->time + 3;
			return FALSE;
		}
	}

	return TRUE;
}

//==================================================================
// BlaBla : Fonction qui fait parler le hugnauth pendant les pauses en 
// synchronisation avec les mouvements des lvres
//==================================================================

void CHug :: BlaBla ( void )
{
	
	int num = -1;

	if ( RANDOM_LONG(0, 10) > 6 )//ne bavarde pas tout le temps
	{
		do
			{
				num = RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1);
			} while( num == m_iLastWord );

			m_iLastWord = num;


						
		EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[ num ], 1.0, ATTN_NORM );
	}

}

//=========================================================
// PrescheduleThink, temporise les dialogues avant les programmes
//=========================================================
void CHug :: PrescheduleThink ( void )
{
	if ( ShouldSpeak() )
	{
		if ( m_flNextWordTime < gpGlobals->time )
		{
			int num = -1;

				switch	( m_MonsterState )
				{
				case MONSTERSTATE_IDLE:
					{
			
						
					}
					break;
				}

			
			if ( RANDOM_LONG( 1, 10 ) <= 7 )
			{
				
				StopTalking();
			}
			else
			{
				m_flNextWordTime = gpGlobals->time + RANDOM_FLOAT( 3.5, 8 );
			}
		}
	}
}

//=========================================================
// DieSound
//=========================================================
void CHug :: DeathSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pDieSounds[RANDOM_LONG(0,ARRAYSIZE(pDieSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AlertSound
//=========================================================
void CHug :: AlertSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAlertSounds[RANDOM_LONG(0,ARRAYSIZE(pAlertSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// PainSound
//=========================================================
void CHug :: PainSound ( void )
{
	if ( m_flNextPainTime > gpGlobals->time )
	{
		return;
	}

	m_flNextPainTime = gpGlobals->time + 1.6;

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pPainSounds[RANDOM_LONG(0,ARRAYSIZE(pPainSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AI Schedules spcifiques au Hugnauth 
// pour qu'il vaque  ses occupations
//=========================================================

//=========================================================
// Fail Schedule
//=========================================================
Task_t	tlHugFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT,				(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slHugFail[] =
{
	{
		tlHugFail,
		ARRAYSIZE ( tlHugFail ),
		0,
		0,
		"Hug Fail"
	},
};


//=========================================================
// Standoff schedule. Utilis en combat lorsque le monstre a perdu de vue l'ennemi
// Doit-on aller voir dans le coin?
//=========================================================
Task_t	tlHugStandoff[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_ACTIVITY,			(float)ACT_IDLE				},
	{ TASK_WAIT_FACE_ENEMY,			(float)2					},
};

Schedule_t slHugStandoff[] = 
{
	{
		tlHugStandoff,
		ARRAYSIZE ( tlHugStandoff ),
		bits_COND_SEE_ENEMY				|
		bits_COND_NEW_ENEMY				|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Hug Standoff"
	}
};

//=========================================================
// Se mettre  couvert, d'abord de ct puis vers un noeud
//=========================================================
Task_t	tlHugTakeCoverFromEnemy[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SMALL_FLINCH,			(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slHugTakeCoverFromEnemy[] =
{
	{ 
		tlHugTakeCoverFromEnemy,
		ARRAYSIZE ( tlHugTakeCoverFromEnemy ), 
		bits_COND_NEW_ENEMY |
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"HugTakeCoverFromEnemy"
	},
};

//Attention aux grenades

Task_t	tlHugTakeCoverFromBestSound[] =
{
	{ TASK_SET_FAIL_SCHEDULE,			(float)SCHED_COWER			},
	{ TASK_STOP_MOVING,					(float)0					},
	{ TASK_FIND_COVER_FROM_BEST_SOUND,	(float)0					},
	{ TASK_RUN_PATH,					(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,			(float)0					},
	{ TASK_REMEMBER,					(float)bits_MEMORY_INCOVER	},
	{ TASK_TURN_LEFT,					(float)179					},
};

Schedule_t	slHugTakeCoverFromBestSound[] =
{
	{ 
		tlHugTakeCoverFromBestSound,
		ARRAYSIZE ( tlHugTakeCoverFromBestSound ), 
		bits_COND_NEW_ENEMY,
		0,
		"HugTakeCoverFromBestSound"
	},
};

// Essaye de travailler en paix!

Task_t tlHugWork[] = 
{
	{ TASK_HUG_FIND_HINTNODE,		(float)0	},
	{ TASK_GET_PATH_TO_HINTNODE,	(float)0	},
	{ TASK_WALK_PATH,				(float)0	},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0	},
	{ TASK_FACE_HINTNODE,			(float)0	},
	{ TASK_HUG_PLAY_ACTIVITY,		(float)0	},
	{ TASK_WAIT,					(float)4    },
	{ TASK_HUG_PLAY_ACTIVITY,		(float)0	},
	{ TASK_WAIT,					(float)2    },
	{ TASK_HUG_PLAY_ACTIVITY,		(float)0	},
	{ TASK_WAIT,					(float)3    },
	{ TASK_HUG_PLAY_ACTIVITY,		(float)0	},	
}; 

Schedule_t slHugWork[] =
{
	{ 
		tlHugWork,
		ARRAYSIZE ( tlHugWork ),
		bits_COND_NEW_ENEMY			|
		bits_COND_PROVOKED			|  //en cas d'activation
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"HugWork"
	},
};

// Ce branleur fait une petite promenade en rendant visite  ses collaborateurs!

Task_t tlHugWalkaround[] = 
{
	{ TASK_HUG_FIND_FRIEND,			(float)0	},
	{ TASK_GET_PATH_TO_HINTNODE,	(float)0	},
	{ TASK_WALK_PATH,				(float)0	},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0	},
	{ TASK_HUG_PLAY_DIALOG,			(float)0	},
	{ TASK_WAIT,					(float)3    },
	{ TASK_HUG_PLAY_DIALOG,			(float)0	},
};

Schedule_t slHugWalkaround[] =
{
	{ 
		tlHugWalkaround,
		ARRAYSIZE ( tlHugWalkaround ),
		bits_COND_NEW_ENEMY			|
		bits_COND_PROVOKED			|  //en cas d'activation
		bits_COND_HEAR_SOUND,

		
		bits_SOUND_DANGER,
		"HugWalkaround"
	},
};

Task_t tlHugTalk[] = 
{
	{ TASK_HUG_FACE_FRIEND,			(float)0	},
	{ TASK_WAIT,					(float)2    },
	{ TASK_HUG_PLAY_DIALOG,			(float)0	},
	{ TASK_WAIT,					(float)3    },
	{ TASK_HUG_PLAY_DIALOG,			(float)0	},
};

Schedule_t slHugTalk[] =
{
	{ 
		tlHugTalk,
		ARRAYSIZE ( tlHugTalk ),
		bits_COND_NEW_ENEMY			|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"HugTalk"
	},
};

DEFINE_CUSTOM_SCHEDULES( CHug )
{
	slHugFail,
	slHugStandoff,
	slHugTakeCoverFromEnemy,
	slHugTakeCoverFromBestSound,
	slHugWork,
	slHugWalkaround,
	slHugTalk,
};

IMPLEMENT_CUSTOM_SCHEDULES( CHug, CBaseMonster );


//=========================================================
// StartTask, pour les tches de contrle
//=========================================================
void CHug :: StartTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_HUG_FIND_HINTNODE:

		m_iHintNode = FindWorkNode();

		if ( m_iHintNode != NO_NODE )
			{
				TaskComplete();
			}
		else
			{
				TaskFail();
			}
		break;

	case TASK_HUG_FIND_FRIEND:

		m_iHintNode = FindFRiend();

		
		if ( m_iHintNode != NO_NODE )
			{
				TaskComplete();
			}
		else
			{
				TaskFail();
			}

		break;

	case TASK_HUG_PLAY_ACTIVITY:
		{
			// pour une activit de travail on peut utiliser : ACT_GUARD qui n'est gnralement pas utilise dans les modles
			// il suffira de nommer l'animation de travail comme ACT_GUARD dans le fichier qc du modle.
			m_IdealActivity = ( Activity )WorldGraph.m_pNodes[ m_iHintNode ].m_sHintActivity;
			break;
		}

	case TASK_HUG_PLAY_DIALOG:


		if ( Friend )//on active le stakanoviste qui travaille pour qu'il arrte de travailler et rponde
		{
			Friend->Use(this, this, USE_ON, 0 );
		}
		
		m_IdealActivity = ( Activity )WorldGraph.m_pNodes[ m_iHintNode ].m_sHintActivity;


		break;

	case TASK_HUG_FACE_FRIEND: // regarde moi quand je te parle ducon!!
		{
			if (Activator)
			{
				MakeIdealYaw ( Activator->pev->origin );
				SetTurnActivity(); 
			}
			break;
		}

	case TASK_WALK_PATH:
	case TASK_RUN_PATH:
		
		Forget( bits_MEMORY_INCOVER );
		CBaseMonster ::StartTask( pTask );
		break;
	
	case TASK_FACE_IDEAL:
	case TASK_FACE_ENEMY:
		CBaseMonster :: StartTask( pTask );
		if (pev->movetype == MOVETYPE_FLY)
		{
			m_IdealActivity = ACT_GLIDE;
		}
		break;

	default: 
		CBaseMonster :: StartTask( pTask );
		break;
	}
}

void CHug :: RunTask( Task_t *pTask )//surveille le droulement de la tche
{
		

	switch ( pTask->iTask )
	{
	case TASK_HUG_PLAY_ACTIVITY:
		{
			if ( m_fSequenceFinished )
			{
				TaskComplete();
			}
			break;
		}
	case TASK_HUG_PLAY_DIALOG:
		{
			if ( m_fSequenceFinished )
			{
				TaskComplete();
			}
			break;
		}

	case TASK_HUG_FACE_FRIEND:
		{

			if (Activator)
			{
				MakeIdealYaw( Activator->pev->origin );

				ChangeYaw( pev->yaw_speed );
			}

			if ( FacingIdeal() )
			{
				TaskComplete();
			}
			break;
		}

	default:
		CBaseMonster::RunTask( pTask );
		break;
	}

}

//recherche d'un node pour y travailler
int CHug ::FindWorkNode(void)
{
	int i;

	if ( !WorldGraph.m_fGraphPresent )//pas de node graph pour la map
	{
		ALERT ( at_aiconsole, "find_hintnode: graph not ready!\n" );
		return NO_NODE;
	}
	
	if ( WorldGraph.m_iLastActiveIdleSearch >= WorldGraph.m_cNodes )//vrifie quel est le dernier hintnode recherch
	{
		WorldGraph.m_iLastActiveIdleSearch = 0;
	}

	
	//boucle sur les nodes pour rechercher les hintnodes

	for ( i = 0; i < WorldGraph.m_cNodes ; i++ )
	{
		int nodeNumber = (i + WorldGraph.m_iLastActiveIdleSearch) % WorldGraph.m_cNodes;
		CNode &node = WorldGraph.Node( nodeNumber );

		if ( node.m_sHintType )//si c'est un hintnode
		{
			//contrle du type, (si on peut y travailler)
			if ( FValidateHintType ( node.m_sHintType ) == 1 )
			{
				//si une activit a t dfinie pour ce hintnode et si elle existe dans le fichier mdl du hugnauth
				if ( !node.m_sHintActivity || LookupActivity ( node.m_sHintActivity ) != ACTIVITY_NOT_AVAILABLE )
				{	
					// le prochain ouvrier cherchera le prochain hintnode,
					// pour qu'ils ne se rendent pas tous au mme endroit.
					WorldGraph.m_iLastActiveIdleSearch = nodeNumber + 1; 
																		
					return nodeNumber;
				}
			}
		}
	}


	return NO_NODE;
}


//===================================================================================================
// Recherche d'un collgue qui travaille vers un node ou qui se trouve  un rendez-vous de discussion
// La fonction va voir si aux alentours du hintnode de conversation, il y a un collgue au travail 
// sur un autre hintnode, il faut que les deux hintnodes soient proches, moins de 128 units.
// On mettra donc toujours un couple de hintnodes , un de travail(hinttype = 4) et un de discussion (12)
//===================================================================================================
int CHug ::FindFRiend()
{

	int i;

	if ( !WorldGraph.m_fGraphPresent )//pas de node graph pour la map
	{
		ALERT ( at_aiconsole, "find_hintnode: graph not ready!\n" );
		return NO_NODE;
	}

	if ( WorldGraph.m_iLastActiveIdleSearch >= WorldGraph.m_cNodes )//vrifie quel est le dernier hintnode recherch
	{
		WorldGraph.m_iLastActiveIdleSearch = 0;
	}

	//boucle sur les nodes pour rechercher les hintnodes
	for ( i = 0; i < WorldGraph.m_cNodes ; i++ )
	{
		int nodeNumber = (i + WorldGraph.m_iLastActiveIdleSearch) % WorldGraph.m_cNodes;
		CNode &node = WorldGraph.Node( nodeNumber );

		if ( node.m_sHintType )//si c'est un hintnode
		{
			//contrle du type, (si on peut y discuter)
			if ( FValidateHintType ( node.m_sHintType ) == 2 )
			{
				Vector vecNodePos = node.m_vecOrigin;//position du hintnode

				CBaseEntity *pEntity = NULL;

				while ((pEntity = UTIL_FindEntityInSphere( pEntity, vecNodePos, 128)) != NULL)
				{
					//si c'est bien un collgue
					if ( strcmp( "monster_hug", STRING( pEntity->pev->classname )) == 0  && (pEntity->pev != pev))
					{
						WorldGraph.m_iLastActiveIdleSearch = nodeNumber + 1; 

						Friend = pEntity;
																		
						return nodeNumber;
					}

				}
			}
		}
	}

	return NO_NODE;
}

//================================================================
//  FValidateHintType //vrifie de quel type de hintnode il s'agit
//	HINT_WORLD_MACHINERY signifie qu'il faut accomplir un travail
//  HINT_WORLD_TALK signifie qu'on peut y aller se promener pour 
//	discuter avec un collgue ventuellement.
//================================================================
BOOL CHug :: FValidateHintType ( short sHint )
{
	
	if ( HINT_WORLD_MACHINERY == sHint ) //valeur 4
	{
		return 1;
	}
	else if ( HINT_WORLD_TALK == sHint ) //valeur 12
	{
		return 2;
	}
	else
	{
		ALERT ( at_aiconsole, "Couldn't validate hint type" );
	
		return 0;
	}
	
}


//=================================================================
// Utilis pour interrompre le travail et permettre la discussion
//=================================================================
void CHug ::Use(CBaseEntity *pActivator, CBaseEntity *pCaller, USE_TYPE useType, float value)
{
  SetConditions(bits_COND_PROVOKED);

  Activator = pActivator;
}


//===================================================
//Activits dpendant de l'tat actuel
//===================================================

void CHug :: SetActivity ( Activity NewActivity )
{
	int	iSequence = ACTIVITY_NOT_AVAILABLE;
	void *pmodel = GET_MODEL_PTR( ENT(pev) );

	switch ( NewActivity)
	{
	case ACT_RUN:
		if ( pev->health <= 20 )
		{
			
			iSequence = LookupActivity ( ACT_RUN_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_WALK:
		if ( pev->health <= 20 )
		{
			
			iSequence = LookupActivity ( ACT_WALK_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	default:
		iSequence = LookupActivity ( NewActivity );
		break;
	}
	
	m_Activity = NewActivity; 

	
	if ( iSequence > ACTIVITY_NOT_AVAILABLE )
	{
		if ( pev->sequence != iSequence || !m_fSequenceLoops )
		{
			pev->frame = 0;
		}

		pev->sequence		= iSequence;	
		ResetSequenceInfo( );
		SetYawSpeed();
	}
	else
	{
		
		ALERT ( at_console, "%s has no sequence for act:%d\n", STRING(pev->classname), NewActivity );
		pev->sequence		= 0;	
	}
}


//=========================================================
// GetSchedule - dcide du type de schedule qui convient le mieux
// Appelle ensuite la fonction pour obtenir un pointeur vers la schedule 
// qui convient
//=========================================================

Schedule_t *CHug :: GetSchedule ( void )
{
	
	
	switch	( m_MonsterState )
	{


	case MONSTERSTATE_IDLE:
		{

			if ( HasConditions( bits_COND_PROVOKED ))//il a t activ par quelqu'un, il va s'arrter et parler
			{
				return GetScheduleOfType( SCHED_HUG_TALK );
			}
			
			//ALERT ( at_console, "IDLE\n");
			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					//ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );//casse-toi de l vite fait
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_COWER );//baisse la tte avant qu'on te la coupe!!
				}
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );//va voir maman si t'a bobo!!
			}

			switch ( RANDOM_LONG(0,1) )
			{
				case 0: return GetScheduleOfType( SCHED_HUG_WORK );
					break;

				case 1: return GetScheduleOfType( SCHED_HUG_WALKAROUND );
					break;
			}

		}
		break;
	
	
	case MONSTERSTATE_ALERT:
		{

			if ( HasConditions( bits_COND_PROVOKED ))//il a t activ par quelqu'un, il va s'arrter et parler
			{
				return GetScheduleOfType( SCHED_HUG_TALK );
			}

			//ALERT ( at_console, "ALERT\n");
			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_COWER );
				}
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}

			switch ( RANDOM_LONG(0,1) )
			{
				case 0: return GetScheduleOfType( SCHED_HUG_WORK );
					break;

				case 1: return GetScheduleOfType( SCHED_HUG_WALKAROUND );
					break;
			}
		}
		break;

	
	case MONSTERSTATE_COMBAT:
		{
			//ALERT ( at_console, "COMBAT\n");
			if ( HasConditions( bits_COND_ENEMY_DEAD ) )
			{
				
				return CBaseMonster :: GetSchedule();
			}

			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					ALERT( at_console, "MONSTERSTATE %i\n: ", m_MonsterState);
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
			}

			if ( pev->iuser4 == 2 )
			{
				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}
			
			return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ENEMY );
						
		}

		return GetScheduleOfType ( SCHED_STANDOFF );
	}

	return CBaseMonster :: GetSchedule();
}

//=========================================================
//=========================================================
Schedule_t* CHug :: GetScheduleOfType ( int Type ) 
{
	switch	( Type )
	{

	case SCHED_TAKE_COVER_FROM_ENEMY:
		return &slHugTakeCoverFromEnemy[ 0 ];

	case SCHED_TAKE_COVER_FROM_BEST_SOUND:
		return &slHugTakeCoverFromBestSound[ 0 ];
		break;

	case SCHED_STANDOFF:
		return &slHugStandoff[ 0 ];
		break;

	case SCHED_FAIL:
			
		{
			return &slHugFail[ 0 ];
		}
		break;
	
	case SCHED_HUG_WORK:
		return &slHugWork[ 0 ];
		break;

	case SCHED_HUG_WALKAROUND:
		return &slHugWalkaround[ 0 ];
		break;

	case SCHED_HUG_TALK:
		return &slHugTalk[ 0 ];
		break;
	}

	return CBaseMonster :: GetScheduleOfType( Type );
}
