/***
*
*	Code pour crer un sabre laser
*	  
*	Jean-Franois Vuagniaux : vuagniaux.jf@com.mcnet.ch
*
****/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "gamerules.h"
#include "effects.h"
#include "customentity.h"
//#include "mathlib.h"



#define	LSABER_BODYHIT_VOLUME	128
#define	LSABER_WALLHIT_VOLUME	512
#define BLADE_SPRITE			"sprites/laserbeam.spr"



class CLSaber : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 1; }
	int GetItemInfo(ItemInfo *p);
	void WeaponIdle( void );
	void PrimaryAttack( void );
	void SecondaryAttack( void );
	void EXPORT Smack( int SoundType );
	void Boum( int AType );
	void EXPORT SecBoum( void );
	void EXPORT PriBoum( void );
	BOOL Deploy( void );
	void Holster(int skiplocal = 0 );
	void Etincelles( int chocmonde );
	
	void EXPORT DrawBlade( void );
	void EXPORT Lumiere( void );
	void DestroyBlade( void );
	void UpdateBlade( void );

	void ReflectBlaster( void );

	CBeam *m_pBlade;
	CBeam *m_pBladeW;
	//CBaseEntity *pEntity;
	
	BOOL m_BladeStarted;
	float m_DrawTime;
	float fvolbar;
	int m_iSwing;
	int m_sabGlow; 
	int m_sabBalls;
	Vector vecSparks;
	Vector vecSmokePos;
	TraceResult m_trHit;
	float m_flRadius;
	float m_flLightTime; 
	int m_sabSmoke;
	float m_flTempsSyncho;
	//BOOL m_idleWeapon;
	BOOL done;
	TraceResult tr;
};
LINK_ENTITY_TO_CLASS( weapon_lsaber, CLSaber );


enum gauss_e {
	SABER_IDLE = 0,
	SABER_DRAW,
	SABER_HOLSTER,
	SABER_ATTACK1HIT,
	SABER_ATTACK1MISS,
	SABER_ATTACK2MISS,
	SABER_ATTACK2HIT,
	SABER_ATTACK3MISS,
	SABER_ATTACK3HIT,
	SABER_SECATTACK1HIT,// les deux actions secondaires  ont t inverse 
	SABER_SECATTACK1, //par accident lors de l'animation
	SABER_IDLE2,
	SABER_IDLE3,
	SABER_RICOCHET
};



void CLSaber::Spawn( )
{
	pev->classname = MAKE_STRING("weapon_lsaber");
	Precache( );
	m_iId = WEAPON_LSABER;
	SET_MODEL(ENT(pev), "models/w_saber.mdl"); // modle du sabre  placer dans la map
	m_iClip = -1;// pas de munition utilise

	pev->iuser3 = 1;

	FallInit();
	
}


void CLSaber::Precache( void )
{
	PRECACHE_MODEL("models/v_saber.mdl");
	PRECACHE_MODEL("models/w_saber.mdl");
	PRECACHE_MODEL("models/p_saber.mdl");
	PRECACHE_SOUND("weapons/saber_hit1.wav");
	PRECACHE_SOUND("weapons/saber_hit2.wav");
	PRECACHE_SOUND("weapons/saber_hitbod1.wav");
	PRECACHE_SOUND("weapons/saber_hitbod2.wav");
	PRECACHE_SOUND("weapons/saber_hitbod3.wav");
	PRECACHE_SOUND("weapons/saber_miss1.wav");
	PRECACHE_SOUND("weapons/saber_miss2.wav");
	PRECACHE_SOUND("weapons/lsaber_hum.wav");
	PRECACHE_SOUND("weapons/lsaber_ric.wav");
	PRECACHE_SOUND("weapons/lsaber_draw.wav");
	PRECACHE_SOUND("weapons/lsaber_holster.wav");
	PRECACHE_SOUND("weapons/lsaber_ric.wav");
	m_sabGlow = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_sabBalls = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_sabSmoke = PRECACHE_MODEL( "sprites/blasthit.spr" );
	PRECACHE_MODEL( BLADE_SPRITE );
}

int CLSaber::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = NULL;
	p->iMaxAmmo1 = -1;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = WEAPON_NOCLIP;
	p->iSlot = 0;
	p->iPosition = 2; // position de l'arme dans le slot 1 
	p->iId = WEAPON_LSABER;
	p->iWeight = SABER_WEIGHT;// priorit de l'arme
	return 1;
}


void CLSaber::Etincelles(int chocmonde ) // ajout pour crer des tincelles au point de contact
{
	
	UTIL_Sparks( vecSparks );
	Vector vecSmokePos;


			if (chocmonde == 1)
			{
				// tache incandescente
				MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, vecSparks );
					WRITE_BYTE( TE_GLOWSPRITE );
					WRITE_COORD( vecSparks.x);		// position
					WRITE_COORD( vecSparks.y);
					WRITE_COORD( vecSparks.z);
					WRITE_SHORT( m_sabGlow );		// modle
					WRITE_BYTE( 40 );				// dure * 10
					WRITE_BYTE( 3 );				// taille * 10
					WRITE_BYTE( 3000 );				// luminosit
				MESSAGE_END();

			

				// billes incandescentes
				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSparks );
					WRITE_BYTE( TE_SPRITETRAIL );
					WRITE_COORD( vecSparks.x );
					WRITE_COORD( vecSparks.y );
					WRITE_COORD( vecSparks.z );
					WRITE_COORD( vecSparks.x );
					WRITE_COORD( vecSparks.y );
					WRITE_COORD( vecSparks.z );
					WRITE_SHORT( m_sabBalls );		// modle
					WRITE_BYTE( 10 );				// nombre
					WRITE_BYTE( 10 );				// dure * 10
					WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille * 10
					WRITE_BYTE( 10 );				// amplitude * 0.1
					WRITE_BYTE( 20 );				// vitesse * 100
				MESSAGE_END();

				vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 8 );//loigne la sprite lgrement du mur
				
				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( vecSmokePos.x );	// position
					WRITE_COORD( vecSmokePos.y );	
					WRITE_COORD( vecSmokePos.z + 16);	
					WRITE_SHORT( m_sabSmoke );		// modle
					WRITE_BYTE( 10 );				//taille * 10
					WRITE_BYTE( 255 );			//luminosit
				MESSAGE_END();
			}

			else
			{
				

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSparks );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( vecSparks.x );	// pos
					WRITE_COORD( vecSparks.y );	
					WRITE_COORD( vecSparks.z + 3 );	
					WRITE_SHORT( m_sabSmoke );		// model
					WRITE_BYTE( 6 );				// size * 10
					WRITE_BYTE( 255 );			// brightness
				MESSAGE_END();


			}
			
}


BOOL CLSaber::Deploy( )
{
	
	m_idleWeapon = 1;
	
	float m_flLightTime = gpGlobals->time;

	
	SetThink( DrawBlade );
	pev->nextthink = gpGlobals->time + 1.0;

	m_DrawTime = gpGlobals->time + 1.0;

	return DefaultDeploy( "models/v_saber.mdl", "models/p_saber.mdl", SABER_DRAW, "lsaber" );

}


void CLSaber::DrawBlade( void )
{

	DestroyBlade();

	m_pBlade = CBeam::BeamCreate(BLADE_SPRITE, 15 );
	m_pBladeW = CBeam::BeamCreate(BLADE_SPRITE, 5 );

	m_pBlade->EntsInit( m_pPlayer->entindex(), m_pPlayer->entindex() );
	m_pBladeW->EntsInit( m_pPlayer->entindex(), m_pPlayer->entindex() );
	
	m_pBlade->SetEndAttachment( 1 );
	m_pBlade->SetStartAttachment( 2 );
	m_pBladeW->SetEndAttachment( 1 );
	m_pBladeW->SetStartAttachment( 2 );

	m_pBlade->pev->spawnflags |= SF_BEAM_TEMPORARY;
	m_pBladeW->pev->spawnflags |= SF_BEAM_TEMPORARY;
	m_pBlade->SetScrollRate( 50 );
	m_pBlade->SetNoise( 2 );
	m_pBlade->SetColor( 0, 255, 0 );
	m_pBlade->SetBrightness( 255 );
	m_pBlade->SetWidth( 15 );
	m_pBladeW->SetScrollRate( 70 );
	m_pBladeW->SetNoise( 2 );
	m_pBladeW->SetColor( 255, 255, 255 );
	m_pBladeW->SetBrightness( 255 );
	m_pBladeW->SetWidth( 5 );
	
	Lumiere();
	
	if ( !m_BladeStarted )
	{

		EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_STATIC, "weapons/lsaber_hum.wav", 0.6, ATTN_NORM);
		EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/lsaber_draw.wav", 1.0, ATTN_NORM);

		m_BladeStarted = 1;
	}

}

void CLSaber::Lumiere(void)
{
	//lumire colore plus faible
		Vector vecMid = m_pPlayer->GetGunPosition() + gpGlobals->v_right * 5 + gpGlobals->v_up * -13;
			
		MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(vecMid.x);	// X
			WRITE_COORD(vecMid.y);	// Y
			WRITE_COORD(vecMid.z);	// Z
			WRITE_BYTE( 40 );		// radius * 0.1
			WRITE_BYTE( 12 );		// r
			WRITE_BYTE( 18 );		// g
			WRITE_BYTE( 12 );		// b
			WRITE_BYTE( 1 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 10 );		// decay * 0.1
		MESSAGE_END( );
	//fin lumire

		

}

void CLSaber::UpdateBlade( void )
{
	
	if ( m_DrawTime > gpGlobals->time ) // temps de l'animation de prise en main
	{
		return;
	}
	
		DrawBlade();
	
}

void CLSaber::DestroyBlade( void )
{

	if ( m_pBlade )
	{
		UTIL_Remove( m_pBlade );
		m_pBlade = NULL;

	}

	if ( m_pBladeW )
	{
		UTIL_Remove( m_pBladeW );
		m_pBladeW = NULL;

	}

}


void CLSaber::WeaponIdle( void )
{


	if ( m_idleWeapon )
	{
		UpdateBlade();
	}

	ReflectBlaster();

	ResetEmptySound( );

	if (m_flTimeWeaponIdle > gpGlobals->time)
		return;

	
	int iAnim;
	float flRand = RANDOM_FLOAT(0, 1);
	if (flRand <= 0.4 )
	{
		iAnim = SABER_IDLE;

		m_flTimeWeaponIdle = gpGlobals->time + 5.0;
	}
	else if ( flRand > 0.4 && flRand <= 0.7 ) 
	{
			
		iAnim = SABER_IDLE2;

		m_flTimeWeaponIdle = gpGlobals->time + 5.0;
	}
	else
	{
		iAnim = SABER_IDLE3;

		m_flTimeWeaponIdle = gpGlobals->time + 5.0;
	}

	SendWeaponAnim( iAnim );
	
	
}

void CLSaber::Holster(int skiplocal  )
{
	
	STOP_SOUND(ENT(m_pPlayer->pev), CHAN_STATIC, "weapons/lsaber_hum.wav");// arrte le son

	EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/lsaber_holster.wav", 1.0, ATTN_NORM);

	//ClearBits(m_pPlayer->pev->effects, EF_BRIGHTLIGHT);// teint la lumire
	

	DestroyBlade();
	
	m_BladeStarted = 0;

	m_pPlayer->m_flNextAttack = gpGlobals->time + 0.5;
	SendWeaponAnim( SABER_HOLSTER );
}


//la fonction suivante dtermine le point de contact du sabre avec le monde ou un objet.

void LSabFindHullIntersection( const Vector &vecSrc, TraceResult &tr, float *mins, float *maxs, edict_t *pEntity )
{
	int			i, j, k;
	float		distance;
	float		*minmaxs[2] = {mins, maxs};
	TraceResult tmpTrace;
	Vector		vecHullEnd = tr.vecEndPos;
	Vector		vecEnd;

	distance = 1e6f;

	vecHullEnd = vecSrc + ((vecHullEnd - vecSrc)*2);
	UTIL_TraceLine( vecSrc, vecHullEnd, dont_ignore_monsters, pEntity, &tmpTrace );
	if ( tmpTrace.flFraction < 1.0 )
	{
		tr = tmpTrace;
		return;
	}

	for ( i = 0; i < 2; i++ )
	{
		for ( j = 0; j < 2; j++ )
		{
			for ( k = 0; k < 2; k++ )
			{
				vecEnd.x = vecHullEnd.x + minmaxs[i][0];
				vecEnd.y = vecHullEnd.y + minmaxs[j][1];
				vecEnd.z = vecHullEnd.z + minmaxs[k][2];

				UTIL_TraceLine( vecSrc, vecEnd, dont_ignore_monsters, pEntity, &tmpTrace );
				if ( tmpTrace.flFraction < 1.0 )
				{
					float thisDistance = (tmpTrace.vecEndPos - vecSrc).Length();
					if ( thisDistance < distance )
					{
						tr = tmpTrace;
						distance = thisDistance;
					}
				}
			}
		}
	}
}


void CLSaber::PrimaryAttack()
{
	if ( m_flNextPrimaryAttack < gpGlobals->time )
	{

		m_flTimeWeaponIdle = gpGlobals->time + 5.0;

		switch( (m_iSwing++) % 3 )//lance l'animation primaire
		{
		case 0:
			SendWeaponAnim( SABER_ATTACK1MISS ); break;
		case 1:
			SendWeaponAnim( SABER_ATTACK2MISS ); break;
		case 2:
			SendWeaponAnim( SABER_ATTACK3MISS ); break;
		}
	
		m_flNextPrimaryAttack = gpGlobals->time + 0.6;
		// joue un son de manqu avec pitch variable
		EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_miss1.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		// joue l'animation d'attaque pour le joueur en question
		m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

		m_flTempsSyncho = gpGlobals->time; // dpart de l'animation d'attaque

		done = 0;

		SetThink( PriBoum );//necessaire pour synchroniser l'impacte avec l'animation
		pev->nextthink = gpGlobals->time + 0.01;
	}
	
	
}

void CLSaber::SecondaryAttack()
{
	
	m_flTimeWeaponIdle = gpGlobals->time + 5.0;

	switch( (m_iSwing++) % 3 )//lance l'animation secondaire
	{
	case 0:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;// pour le moment il n'y a qu'une seule animation disponible
	case 1:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;
	case 2:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;
	}
	
	m_flNextSecondaryAttack = gpGlobals->time + 0.9;
	// joue un son de manqu avec pitch variable
	EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_miss2.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

	// joue l'animation d'attaque pour le joueur en question
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	m_flTempsSyncho = gpGlobals->time;

	done = 0;

	SetThink( SecBoum );
	pev->nextthink = gpGlobals->time + 0.01;
	
		
}

void CLSaber::SecBoum()
{
	
	m_idleWeapon = 1;

	if ( m_flTempsSyncho + 1.5 >= gpGlobals->time )
	{
		SetThink( SecBoum );
		pev->nextthink = gpGlobals->time +0.01;

		m_idleWeapon = 0;
	}
	
	DrawBlade();

	if ( m_flTempsSyncho + 0.8 <= gpGlobals->time && !done )
	{
		Boum( 2 );

		done = 1;
	}
}

void CLSaber::PriBoum()
{
	m_idleWeapon = 1;

	if ( m_flTempsSyncho + 1 >= gpGlobals->time )
	{
		SetThink( PriBoum );
		pev->nextthink = gpGlobals->time +0.01;

		m_idleWeapon = 0;
	}

	DrawBlade();

	if ( m_flTempsSyncho + 0.5 <= gpGlobals->time && !done )
	{
		Boum( 1 );

		done = 1;
	}
}

void CLSaber::Boum(int AType)
{
	
	float m_flReach;
	
	if ( AType == 1 )
	{
		m_flReach = 80;// 80 est la porte du sabre  partir de la main
	}
	else
	{
		m_flReach = 120;
	}
	
	

	UTIL_MakeVectors (m_pPlayer->pev->v_angle);
	Vector vecSrc	= m_pPlayer->GetGunPosition();
	Vector vecEnd	= vecSrc + gpGlobals->v_forward * m_flReach; 

	UTIL_TraceLine( vecSrc, vecEnd, dont_ignore_monsters, ENT( m_pPlayer->pev ), &tr );

	if ( tr.flFraction >= 1.0 )
	{
		UTIL_TraceHull( vecSrc, vecEnd, dont_ignore_monsters, head_hull, ENT( m_pPlayer->pev ), &tr );
		if ( tr.flFraction < 1.0 )
		{
			// Calcule le point d'intersection de la ligne (ou boite) avec l'objet qui est frapp
			// Ceci est une approximation de la meilleure intersection
			
			CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
			if ( !pHit || pHit->IsBSPModel() )
				LSabFindHullIntersection( vecSrc, tr, VEC_DUCK_HULL_MIN, VEC_DUCK_HULL_MAX, m_pPlayer->edict() );
			vecEnd = tr.vecEndPos;	// Ceci est le point sur la surface actuelle (la boite peut n'avoir touch que le vide)
			
		}
	}

	if ( tr.flFraction >= 1.0 )
	{
	}
	
	else
	{
		// touch
		

		CBaseEntity *pEntity = CBaseEntity::Instance(tr.pHit);

		if ( AType == 1 )// primary attack
		{
	
			ClearMultiDamage( );
			
			pEntity->TraceAttack(m_pPlayer->pev, gSkillData.plrDmgSaber, gpGlobals->v_forward, &tr, DMG_SABER ); 
			
			m_flNextPrimaryAttack = gpGlobals->time + 0.5;

			ApplyMultiDamage(m_pPlayer->pev, m_pPlayer->pev);

		}


		if ( AType == 2 )// secondary attack (1.5 fois la puissance du coup simple)
		{
		
		
			ClearMultiDamage( );
			
			pEntity->TraceAttack(m_pPlayer->pev, gSkillData.plrDmgSaber * 1.5, gpGlobals->v_forward, &tr, DMG_SABER ); 
				
			m_flNextSecondaryAttack = gpGlobals->time + 0.9;

			ApplyMultiDamage(m_pPlayer->pev, m_pPlayer->pev);

		}

		
		// joue diffrents son de chocs selon la nature de l'objet
			float flVol = 1.0;
			int fHitWorld = TRUE;
			
			int m_typeson;

			if (pEntity)
			{
				if (pEntity->Classify() != CLASS_NONE && pEntity->Classify() != CLASS_MACHINE)
				{
					
					m_typeson = 0;
					
					m_pPlayer->m_iWeaponVolume = LSABER_BODYHIT_VOLUME;
					if (!pEntity->IsAlive() )
					{
					}
			
					else
						flVol = 0.1;

					fHitWorld = FALSE;
					
				}
			}

			// joue un son avec le facteur texture
			

			if (fHitWorld) // choc avec le monde
			{
				fvolbar = TEXTURETYPE_PlaySound(&tr, vecSrc, vecSrc + (vecEnd-vecSrc)*2, BULLET_PLAYER_SABER);

				
				m_typeson = 1;
				
				if ( g_pGameRules->IsMultiplayer() )
				{
					// volume au maximum car il n'y a pas de facteur texture en multijoueurs 
					// et le son serait 0  cause de la fonction au-dessus

					fvolbar = 1;
				}

				
			}

				
				m_trHit = tr;
				vecSparks = tr.vecEndPos;
				
				Smack(m_typeson);
				
				m_pPlayer->m_iWeaponVolume = flVol * LSABER_WALLHIT_VOLUME;
		
		
	}
	
}


void CLSaber::Smack(int SoundType )
{
	DecalGunshot( &m_trHit, BULLET_PLAYER_SABER );	
	
	ApplyMultiDamage( m_pPlayer->pev, m_pPlayer->pev );

	if (SoundType == 0)
	{
		Etincelles( 0 ); // apelle la fonction qui cre des tincelles au point de contact.

		// joue un son de coup dans un corps
		switch( RANDOM_LONG(0,2) )
		{
		case 0:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod1.wav", 1, ATTN_NORM); break;
		case 1:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod2.wav", 1, ATTN_NORM); break;
		case 2:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod3.wav", 1, ATTN_NORM); break;
		}
	}

	if (SoundType == 1)
	{
		Etincelles( 1 ); // apelle la fonction qui cre des tincelles au point de contact.

		// joue un son de choc sur un mur selon la texture
		switch( RANDOM_LONG(0,1) )
		{
		case 0:
			//UTIL_EmitAmbientSound(ENT(0), ptr->vecEndPos, "weapons/saber_hit1.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3));
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_ITEM, "weapons/saber_hit1.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3)); 
			break;
		case 1:
			//UTIL_EmitAmbientSound(ENT(0), ptr->vecEndPos, "weapons/saber_hit2.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3));
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_ITEM, "weapons/saber_hit2.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3)); 
			break;
		}
	}

		


}


void CLSaber::ReflectBlaster( void )
{

	CBaseEntity *pEntity = NULL;
	
	m_flRadius = 64; //rayon de recherche
	
	Vector vecVelocity; //vitesse projectile
	Vector vecNewVelocity; // nouvelle vitesse
	Vector vecAiming; //regard du joueur
	Vector vecResult;
	float AddResult;
	
	//float rx;
	//float ry;
	//float rz;

	vecAiming = gpGlobals->v_forward;
	
	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_10DEGREES ;

	while ((pEntity = UTIL_FindEntityInSphere( pEntity, m_pPlayer->pev->origin, m_flRadius )) != NULL )
	{

		vecVelocity = pEntity->pev->velocity;

		//ALERT(at_console, "Vitesse %f\n", vecVelocity.Length());
		
		if ( vecVelocity.Length() > 1000 ) // si la vitesse est trop basse on limine (le Blaster se dplace  2000)
		{
			
			vecVelocity = vecVelocity.Normalize();

			vecNewVelocity.x = (vecVelocity.x * -1);// nouvelle direction pour la vitesse du blaster
			vecNewVelocity.y = (vecVelocity.y * -1);
			vecNewVelocity.z = (vecVelocity.z * -1);

			vecNewVelocity = vecNewVelocity + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;

			vecNewVelocity = vecNewVelocity * 1800;
		
			/*
			rx = vecVelocity.x ;
			ry = vecVelocity.y ;
			rz = vecVelocity.z ;

			rx = vecAiming.x ;
			ry = vecAiming.y ;
			rz = vecAiming.z ;

			rx = vecNewVelocity.x ;
			ry = vecNewVelocity.y ;
			rz = vecNewVelocity.z ;
			
			  */
			vecResult.x = (vecAiming.x + vecVelocity.x) ;
			vecResult.y = (vecAiming.y + vecVelocity.y) ;
			vecResult.z = (vecAiming.z + vecVelocity.z) ;

			AddResult = vecResult.Length();

			//ALERT( at_console, "ADDRESULT, %f, %f, %f, %f \n", AddResult, rx, ry, rz);

			if ( AddResult < 0.2 )
			{

				pEntity->pev->velocity = vecNewVelocity; // le projectile est renvoy

				// joue un son de ricochet avec pitch variable
				EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

				SendWeaponAnim( SABER_RICOCHET );
			}
		}
	}

}







