/***
*
*	Code pour le pistolet blaster des officiers de l'Empire
*
*	Par Jean-Franois Vuagniaux 
*
*	vuagniaux.jf@com.mcnet.ch
*
****/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "soundent.h"
#include "gamerules.h"
#include "effects.h"
#include "decals.h"
#include "..\apifmod\fmod.h"


int m_psprite;
int m_psmoke;
float m_pistDamage;
int m_PInzoom;
int m_iPTrail;
int m_pWallSmoke;

enum pist_e
{
	PIST_LONGIDLE = 0,
	PIST_IDLE1,
	PIST_RELOAD,
	PIST_DEPLOY,
	PIST_FIRE,
	
};

//======================================================================================
// Mask pour la lunette de vise, sprite avec un trou rond restreignant le champs visuel
//======================================================================================

/*
class CMask : public CBaseEntity
{
	void Spawn( void );
public:
	
	static CMask *CreateMask( void );

};

LINK_ENTITY_TO_CLASS( scopemask, CMask );



void CMask::Spawn( void )
{
	pev->movetype = MOVETYPE_NONE;
	
	pev->solid = SOLID_NOT;
	pev->rendermode = kRenderTransAlpha;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/scopemask.spr");
	
	pev->scale = 0.1;

	UTIL_SetOrigin( pev, pev->origin );
}

CMask *CMask::CreateMask( void )  // cre le masque  partir de la dfinition de classe
{
	CMask *pMask = GetClassPtr( (CMask *)NULL );
	pMask->Spawn();

	pMask->pev->classname = MAKE_STRING("scopemask");

	return pMask;
}

  */

//================================================================================
// Projectile de blaster pour les armes lgres de la companie BlasTech industries
//================================================================================

class CPBlaster : public CBaseEntity
{
public:
	void Spawn( void );
	//void Think( void );

	static void Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_blastballs;
	int  m_blastglow;
	float nextAnim;

	Vector vecNewVelocity;
	BOOL m_refelct;
	
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol


};

LINK_ENTITY_TO_CLASS( pblaster, CPBlaster );

TYPEDESCRIPTION	CPBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CPBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CPBlaster, CBaseEntity );


void CPBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "pblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blastvert.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iPTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;

}




void CPBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 100 );		// r
			WRITE_BYTE( 255 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;


		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		

		int iPitch = RANDOM_FLOAT( 90, 110 );

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}

		vecVelocity = pev->velocity;

		//ALERT(at_console, "VecVelocity %f %f %f\n", vecVelocity.x, vecVelocity.y, vecVelocity.z);

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_psmoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}
}

void CPBlaster::Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity )
{
	CPBlaster *pBlast = GetClassPtr( (CPBlaster *)NULL );
	pBlast->Spawn();
	
	UTIL_SetOrigin( pBlast->pev, vecStart );
	pBlast->pev->velocity = vecVelocity;
	pBlast->pev->owner = ENT(pevOwner);

	pBlast->SetThink ( Animate );
	pBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CPBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iPitch;
	m_blastglow = m_psprite;
	m_blastballs = m_psprite;

	Vector vecDirImpact;
	
	Vector vecTrOrigin;
	//float	m_flVitesse;
	
	iPitch = RANDOM_FLOAT( 90, 110 );

	entvars_t *pevAttacker = NULL;
	if ( pev->owner )
	{
		pevAttacker = VARS(pev->owner);
	}

	if ( pev->owner == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		pev->owner = NULL;//on dfini le propritaire comme NULL pour que le joueur puisse tre touch aprs un ricochet

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}

	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		if ( !pOther->pev->takedamage )
		{
			
			
		

			// placer un decal sur les murs
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			//sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}


			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_blastglow );				// modle
						WRITE_BYTE( 30 );	// dure
						WRITE_BYTE( 2 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_blastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 16);	
						WRITE_SHORT( m_pWallSmoke );		// modle
						WRITE_BYTE( 10 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else 
		{

			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
			Vector centre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( centre.x );	// position
					WRITE_COORD( centre.y );	
					WRITE_COORD( centre.z + 6 );	
					WRITE_SHORT( m_psmoke );		// modle
					WRITE_BYTE( 3 );				//taille * 10
					WRITE_BYTE( 255 );			//luminosit
				MESSAGE_END();
			
				
					
				m_pistDamage = 1;
			// plus de dommages avec la lunette de vise

				if ( m_PInzoom )
				{
					m_pistDamage = 2;
				}

				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg * m_pistDamage, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, (gSkillData.blasterDmg * m_pistDamage) * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
					
			
				ApplyMultiDamage( pev, pevAttacker );
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

//======================================================================
// Pistolet blaster des Stormtroopers de la companie BlasTech industries
//======================================================================

class CPIST : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 2; }
	int GetItemInfo(ItemInfo *p);
	int AddToPlayer( CBasePlayer *pPlayer );
	void PrimaryAttack( void );
	void SecondaryAttack ( void );
	BOOL Deploy( void );
	void Holster( int skiplocal = 0 );
	void Reload( void );
	void WeaponIdle( void );
	Vector GetGunPosition( void );
	float m_flNextAnimTime;
	void UpdateMask( void );
	//CMask *m_pMask;
	BOOL JoueMp3;
	
	
};
LINK_ENTITY_TO_CLASS( weapon_pistol, CPIST );



//=========================================================
//=========================================================

void CPIST::Spawn( )
{
	pev->classname = MAKE_STRING("weapon_pistol"); 
	Precache( );
	SET_MODEL(ENT(pev), "models/w_pistol.mdl");
	m_iId = WEAPON_PIST;
	
	/*
	//debut glowshell
	pev->rendermode = kRenderNormal;

	pev->renderamt = 255;

	pev->rendercolor.x = 0;

	pev->rendercolor.y = 0;

	pev->rendercolor.z = 255;

	pev->renderamt = 10;

	pev->renderfx = kRenderFxGlowShell;

	//fin glowshell

  */
	m_iDefaultAmmo = PIST_DEFAULT_GIVE;

	pev->iuser3 = 1;

	FallInit();// prt  tomber au sol.
}


void CPIST::Precache( void )
{
	PRECACHE_MODEL("models/v_pistol.mdl");
	PRECACHE_MODEL("models/w_pistol.mdl");
	PRECACHE_MODEL("models/p_pistol.mdl");

	PRECACHE_MODEL("sprites/blastvert.spr");

	PRECACHE_MODEL("models/w_strifleclip.mdl");
	PRECACHE_SOUND("items/strfclip1.wav");              

	PRECACHE_SOUND("items/clipinsert.wav");	// les sons de recharges sont dfinis dans le ficier strifle.qc
	PRECACHE_SOUND("items/cliprelease.wav");	// ils sont lancs lors de l'animation de recharge.
	PRECACHE_SOUND ("weapons/chute1.wav");

	PRECACHE_SOUND ("weapons/pist1.wav");
	PRECACHE_SOUND ("weapons/pist2.wav");
	
	PRECACHE_SOUND ("weapons/choc1.wav");
	PRECACHE_SOUND ("weapons/choc2.wav");
	PRECACHE_SOUND ("weapons/choc3.wav");
	PRECACHE_SOUND ("weapons/choc4.wav");
	PRECACHE_SOUND ("weapons/grill.wav");

	m_psprite = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_psmoke = PRECACHE_MODEL( "sprites/blasthit.spr" );
	m_iPTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_pWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
	PRECACHE_MODEL( "sprites/blastvert.spr" );
	//PRECACHE_MODEL( "sprites/scopemask.spr" );
	
	//UTIL_PrecacheOther( "scopemask" );

}

int CPIST::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "enercel";
	p->iMaxAmmo1 = _ENERCEL_MAX_CARRY;
	p->iMaxClip = STRF_MAX_CLIP;
	p->iSlot = 1;
	p->iPosition = 0;
	p->iFlags = 0;
	p->iId = m_iId = WEAPON_PIST;
	p->iWeight = PIST_WEIGHT;

	return 1;
}

int CPIST::AddToPlayer( CBasePlayer *pPlayer )
{
	if ( CBasePlayerWeapon::AddToPlayer( pPlayer ) )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
			WRITE_BYTE( m_iId );
		MESSAGE_END();
		return TRUE;
	}
	return FALSE;
}

BOOL CPIST::Deploy( )
{
	return DefaultDeploy( "models/v_pistol.mdl", "models/p_pistol.mdl", PIST_DEPLOY, "pistol" );
}

Vector CPIST :: GetGunPosition( )
{
	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); 
	return vecArmPos;
}
void CPIST::PrimaryAttack()
{

	
	// ne pas tirer sous l'eau
	if (m_pPlayer->pev->waterlevel == 3)
	{
		PlayEmptySound( );
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;
		return;
	}

	if (m_iClip <= 0)
	{
		PlayEmptySound();
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;
		return;
	}

	m_pPlayer->m_iWeaponVolume = NORMAL_GUN_VOLUME;
	m_pPlayer->m_iWeaponFlash = NORMAL_GUN_FLASH;

	m_iClip--;

	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;


	if (1 || m_flNextAnimTime < gpGlobals->time)
	{
		SendWeaponAnim( PIST_FIRE );
		m_flNextAnimTime = gpGlobals->time + 0.5;
	}

	// animation de tir du joueur
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	switch( RANDOM_LONG(0,1) )
	{
	case 0: EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/pist1.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); break;
	case 1: EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/pist2.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); break;
	}

	UTIL_MakeVectors( m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle );

	//modifier pour prendre en compte le dsalignement de la man par rapport  la ligne de vise 
	//car le coup porte trop bas  droite:
	//
	//tracer une ligne avec le vecteur: vector aiming et trouver le point d'impacte
	//corriger le vecteur de tir en consquence.
	
	Vector vecSrc	 = m_pPlayer->GetGunPosition( ) ; //point de vise du HUD
	Vector vecAiming = m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );
	
	TraceResult tr;
	UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

	vecSrc = vecSrc + gpGlobals->v_forward * 3 + gpGlobals->v_right * 5 + gpGlobals->v_up * -13;//position du canon
	
	vecAiming = tr.vecEndPos - vecSrc;
	
	vecAiming = vecAiming.Normalize();

	// fin de correction

	if ( ! m_PInzoom )
	{
	
	
	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_1DEGREES ;
	vecAiming = vecAiming + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;

	}
	
// code pour tirer un projectile de blaster
	
	CPBlaster::Shoot(m_pPlayer->pev, vecSrc, vecAiming * 2000);
	
	UTIL_MakeVectors( m_pPlayer->pev->v_angle );
	
	if (!m_iClip && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)
		// la combinaison HEV indique : plus de munitions
		m_pPlayer->SetSuitUpdate("!HEV_AMO0", FALSE, 0);

	m_flNextPrimaryAttack = m_flNextPrimaryAttack + 0.5;
	if (m_flNextPrimaryAttack < gpGlobals->time)
		m_flNextPrimaryAttack = gpGlobals->time + 0.5;

	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );

	m_pPlayer->pev->punchangle.x = RANDOM_FLOAT( -2, 2 );

	//UpdateMask();

 /* 
//essai de son MP3

	int PasDeMP3 = 0;

	if ( !JoueMp3 )
	{
		 PasDeMP3 = UTIL_PlayMP3("tmpQuArK/mp3/testmp3.mp3", 255, 1);

		 if ( !PasDeMP3 )
		 {
			ALERT(at_console, "Pas de Fichier MP3\n");
		 }
	
		JoueMp3 = 1;
	}

	//pour couper le son:
	else
	{
		UTIL_StopMP3(0);

		JoueMp3 = 0;
	}


	m_flNextPrimaryAttack = m_flNextPrimaryAttack + 3;

*/
}

void CPIST::SecondaryAttack()
{
	if (m_PInzoom)
	{
		
		m_pPlayer->m_iFOV = 0; // 0 remet l'angle de vue normal
		m_PInzoom = 0;
	}
	else
	{
		m_pPlayer->m_iFOV = 20;
		
		m_PInzoom = 1;

		//UpdateMask();
	}
	
	pev->nextthink = gpGlobals->time + 0.1;
	m_flNextSecondaryAttack = gpGlobals->time + 0.5;

	
}


void CPIST::Reload( void )
{
	DefaultReload( STRF_MAX_CLIP, PIST_RELOAD, 3.0 );
}

void CPIST::Holster( int skiplocal )
{
	
	if ( m_PInzoom )
	{
		SecondaryAttack( ); // pour viter de rester avec le champs de vision de 20 
	}

	/*
	if (m_pMask)
	{
		m_pMask->Killed( NULL, GIB_NEVER );		//supprime le masque
		m_pMask = NULL;
	}
	*/
}
void CPIST::WeaponIdle( void )
{
	//UpdateMask();
	
	ResetEmptySound( );

	m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );

	if ( m_PInzoom ) 
		return;

	if (m_flTimeWeaponIdle > gpGlobals->time)
		return;

	int iAnim;
	switch ( RANDOM_LONG( 0, 1 ) )
	{
	case 0:	
		iAnim = PIST_LONGIDLE;	
		break;
	
	default:
	case 1:
		iAnim = PIST_IDLE1;
		break;
	}

	SendWeaponAnim( iAnim );

	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 5, 15 );// temps d'attente avant la prochaine animation.
}

/*
void CPIST::UpdateMask( void )
{

	if ( m_PInzoom )
	{

		if ( !m_pMask )
		{
			m_pMask = CMask::CreateMask();
		}
		
		UTIL_MakeVectors( m_pPlayer->pev->v_angle );

		Vector vecSrc = m_pPlayer->GetGunPosition( );;
		Vector vecAiming = gpGlobals->v_forward;
		
		vecSrc = vecSrc + vecAiming * 40;
		
		UTIL_SetOrigin( m_pMask->pev, vecSrc );

	}


}

*/
// la munitions est la mme que celle du fusil blaster strifle



















