/***
*
*	Code pour le Gran Ree-Yees
*	Par Jean-Franois Vuagniaux
*	vuagniaux.jf@com.mcnet.ch
*
****/
//=========================================================
// Homme de main de Ka'Pa le Hutt
//=========================================================

#include	"extdll.h"
#include	"util.h"
#include	"cbase.h"
#include	"monsters.h"
#include	"schedule.h"
#include	"squadmonster.h"
#include	"weapons.h"
#include	"soundent.h"
#include	"animation.h"
#include	"player.h"


int m_Yoisprite;
int m_Yoismoke;
int m_iYoTrail;
int m_ReWallSmoke;
int m_NombrePunch;

//==========================================================
//Dfinitions spcifiques
//==========================================================

#define	REEYEES_CLIP_SIZE			25
#define REEYEES_THERMAL_NBR			3

#define REEYEES_HANDS				( 1 << 0) // numro 1
#define REEYEES_STRIFLE				( 1 << 1) // numro 2
#define REEYEES_THERMAL				( 1 << 2) // numro 4

#define GUN_GROUP					1
#define GUN_STRIFLE					0
#define GUN_NONE					2

#define REEYEES_LIMP_HEALTH			20

#define	REEYEES_MELEE_DIST			100

//=========================================================
// types de schedule spcifiques
//=========================================================
enum
{
	SCHED_REEYEES_SUPPRESS = LAST_COMMON_SCHEDULE + 1,
	SCHED_REEYEES_ESTABLISH_LINE_OF_FIRE,
	SCHED_REEYEES_COVER_AND_RELOAD,
	SCHED_REEYEES_ELOF_FAIL,
	SCHED_REEYEES_RECHERCHE,
	SCHED_REEYEES_DRAW_WEAPON,
	SCHED_REEYEES_HOLSTER,
};


//=========================================================
// taches spcifique
//=========================================================
enum 
{

	TASK_REEYEES_GET_PATH_TO_ENEMY_CORPSE = LAST_COMMON_TASK + 1,
	TASK_REEYEES_CHECK_FIRE,
};


//=========================================================
// conditions spcifiques
//=========================================================
#define bits_COND_REEYEES_NOFIRE	( bits_COND_SPECIAL1 )


int iReeyeesMuzzleFlash;

//=========================================================
// evnements d'animation
//=========================================================
#define		REEYEES_AE_TIR1	( 1 )
#define		REEYEES_AE_LEFT_PUNCH ( 2 )
#define		REEYEES_AE_RIGHT_PUNCH ( 3 )
#define		REEYEES_AE_RELOAD		( 4 )
#define		REEYEES_AE_DROP_GUN		( 5 ) 
#define		REEYEES_AE_TOSS1		( 6 )
#define		REEYEES_AE_PUNCH		( 7 )
#define		REEYEES_AE_DRAW_WEAPON	( 8 )
#define		REEYEES_AE_HOLSTER		( 9 )

//=========================================================
// Classe du projectile Blaster du strifle du Reeyees
//=========================================================

class CYoBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_Mblastballs;
	int  m_Mblastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;

	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol

};

LINK_ENTITY_TO_CLASS( Yoblaster, CYoBlaster );

TYPEDESCRIPTION	CYoBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CYoBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CYoBlaster, CBaseEntity );


void CYoBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "Yoblaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blaster.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iYoTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}

void CYoBlaster::Animate( void )
{
	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 255 );		// r
			WRITE_BYTE( 100 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde
		
	pev->nextthink = gpGlobals->time;

	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		
		Vector vecVelocity;
		int iPitch = RANDOM_FLOAT( 90, 110 );
	

		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_Yoismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}

}

void CYoBlaster::Shoot( entvars_t *pevOwner, Vector MvecStart, Vector MvecVelocity )
{
	CYoBlaster *pYoBlast = GetClassPtr( (CYoBlaster *)NULL );
	pYoBlast->Spawn();
	
	UTIL_SetOrigin( pYoBlast->pev, MvecStart );
	pYoBlast->pev->velocity = MvecVelocity;
	pYoBlast->pev->euser1 = ENT(pevOwner);
	pYoBlast->pev->owner = NULL;// modifi pour que le ricochet du sabre l'atteigne
	pYoBlast->SetThink ( Animate );
	pYoBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CYoBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iMPitch;
	m_Mblastglow = m_Yoisprite;
	m_Mblastballs = m_Yoisprite;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	// son de choc
	iMPitch = RANDOM_FLOAT( 90, 110 );

	entvars_t *pevAttacker = NULL;
	if ( pev->euser1 )
	{
		pevAttacker = VARS(pev->euser1);
	}

	if ( pev->euser1 == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}


	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;

		//m_flVitesse = vecNewVelocity.Length() ;
		
		//ALERT( at_console, "VELOCITY %f\n", m_flVitesse);


	}
	else//sinon c'est normal
	{

		if ( !pOther->pev->takedamage )
		{
			
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			
			// sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_Mblastglow );		// modle
						WRITE_BYTE( 30 );	// dure
						WRITE_BYTE( 2 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );// TE_RAILTRAIL);
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_Mblastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 16 );	
						WRITE_SHORT( m_ReWallSmoke );		// modle
						WRITE_BYTE( 10 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else
		{
			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iMPitch );	

				switch ( RANDOM_LONG( 0, 1 ) )
				{
				case 0:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				case 1:
					EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iMPitch );	
					break;
				}

				Vector Mcentre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, Mcentre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( Mcentre.x );	// pos
					WRITE_COORD( Mcentre.y );	
					WRITE_COORD( Mcentre.z + 6 );	
					WRITE_SHORT( m_Yoismoke );		// model
					WRITE_BYTE( 3 );				// size * 10
					WRITE_BYTE( 255 );			// brightness
				MESSAGE_END();
			
				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg, DMG_ENERGYBEAM );

				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, gSkillData.blasterDmg * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );
					

				ApplyMultiDamage( pev, pevAttacker );

				m_NombrePunch++;

		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

class CReeyees : public CSquadMonster
{
public:
	void Spawn( void );
	void Precache( void );
	void SetYawSpeed ( void );
	int  Classify ( void );
	int  ISoundMask ( void );
	void HandleAnimEvent( MonsterEvent_t *pEvent );
	void SetObjectCollisionBox( void )
	{
		pev->absmin = pev->origin + Vector( -16, -16, 0 );
		pev->absmax = pev->origin + Vector( 16, 16, 80 );
	}

	Schedule_t* GetSchedule ( void );
	Schedule_t* GetScheduleOfType ( int Type );
	BOOL FCanCheckAttacks ( void );
	BOOL CheckMeleeAttack1 ( float flDot, float flDist );
	BOOL CheckRangeAttack1 ( float flDot, float flDist );
	BOOL CheckRangeAttack2 ( float flDot, float flDist );	// lancer de grenade
	void CheckAmmo ( void );
	void StartTask ( Task_t *pTask );
	
	void AlertSound( void );
	void DeathSound ( void );
	void PainSound ( void );
	void AttackSound ( void );
	
	void PrescheduleThink ( void );
	void TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType);
	int TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType );
	void GibMonster ( void );
	int IRelationship( CBaseEntity *pTarget );
	
	
	void StopTalking ( void );
	BOOL ShouldSpeak( void );
	
	void Shoot ( void );
	Vector GetGunPosition( void );
	BOOL	m_fStanding;
	BOOL    m_jesuismort;
	void SetActivity( Activity NewActivity );

	CUSTOM_SCHEDULES;

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	static const char *pAttackHitSounds[];
	static const char *pAttackMissSounds[];
	static const char *pAttackSounds[];
	static const char *pDieSounds[];
	static const char *pPainSounds[];
	static const char *pIdleSounds[];
	static const char *pAlertSounds[];

	int		m_cClipSize;

	float	m_flNextPainTime;
	float	m_flNextSpeakTime;
	float	m_flNextWordTime;
	int		m_iLastWord;
	float   m_flNextAttackSound;
	float   m_flNextGrenadeCheck;
	BOOL	m_fThrowGrenade;
	Vector	m_vecTossVelocity;
	BOOL    m_enalerte;
	BOOL	m_fGunDrawn;
	BOOL	m_noreload;
	int		m_armedepart;
	float	m_healthPaix;

};
LINK_ENTITY_TO_CLASS( monster_reeyees, CReeyees );

TYPEDESCRIPTION	CReeyees::m_SaveData[] = 
{

	DEFINE_FIELD( CReeyees, m_flNextPainTime, FIELD_TIME ),
	DEFINE_FIELD( CReeyees, m_flNextSpeakTime, FIELD_TIME ),
	DEFINE_FIELD( CReeyees, m_flNextWordTime, FIELD_TIME ),
	DEFINE_FIELD( CReeyees, m_iLastWord, FIELD_INTEGER ),
	DEFINE_FIELD( CReeyees, m_cClipSize, FIELD_INTEGER ),
	DEFINE_FIELD( CReeyees, m_enalerte, FIELD_BOOLEAN ),
	DEFINE_FIELD( CReeyees, m_noreload, FIELD_BOOLEAN ),
	DEFINE_FIELD( CReeyees, m_armedepart, FIELD_INTEGER ),
	DEFINE_FIELD( CReeyees, m_fGunDrawn, FIELD_BOOLEAN ),
};

IMPLEMENT_SAVERESTORE( CReeyees, CSquadMonster );

const char *CReeyees::pAttackHitSounds[] = 
{
	"reeyees/punch1.wav",
	"reeyees/punch2.wav",
	"reeyees/punch3.wav",
};

const char *CReeyees::pAttackMissSounds[] = 
{
	"zombie/claw_miss1.wav",
	"zombie/claw_miss2.wav",
};

const char *CReeyees::pAttackSounds[] =
{
	"reeyees/attack1.wav",
	"reeyees/attack2.wav",
	"reeyees/attack3.wav",
};

const char *CReeyees::pDieSounds[] =
{
	"reeyees/die1.wav",
	"reeyees/die2.wav",
	"reeyees/die3.wav",
};

const char *CReeyees::pPainSounds[] =
{
	"reeyees/pain1.wav",
	"reeyees/pain2.wav",
	"reeyees/pain3.wav",
	"reeyees/pain4.wav",
};

const char *CReeyees::pIdleSounds[] =
{
	"reeyees/idle1.wav",
	"reeyees/idle2.wav",
	"reeyees/idle3.wav",
	"reeyees/idle4.wav",
	"reeyees/idle5.wav",
	"reeyees/idle6.wav",
	"reeyees/idle7.wav",
	"reeyees/idle8.wav",
};

const char *CReeyees::pAlertSounds[] =
{
	"reeyees/alert1.wav",
	"reeyees/alert2.wav",
	"reeyees/alert3.wav",
	"reeyees/alert4.wav",
};

//=========================================================
// IRelationship .
//=========================================================
int CReeyees::IRelationship ( CBaseEntity *pTarget )
{
	if ( FClassnameIs( pTarget->pev, "monster_alien_grunt" ) )
	{
		return R_NM;
	}

	return CSquadMonster :: IRelationship( pTarget );
}



//=========================================================
// ISoundMask 
//=========================================================
int CReeyees :: ISoundMask ( void )
{
	return	bits_SOUND_WORLD	|
			bits_SOUND_COMBAT	|
			bits_SOUND_DANGER	|
			bits_SOUND_PLAYER;
}

//=========================================================
// TraceAttack
//=========================================================
void CReeyees :: TraceAttack( entvars_t *pevAttacker, float flDamage, Vector vecDir, TraceResult *ptr, int bitsDamageType)
{
	
		m_LastHitGroup = ptr->iHitgroup;

		switch ( ptr->iHitgroup )
		{
		case HITGROUP_GENERIC:
			break;
		case HITGROUP_HEAD:
			flDamage *= gSkillData.monHead;
			break;
		case HITGROUP_CHEST:
			flDamage *= gSkillData.monChest;
			break;
		case HITGROUP_STOMACH:
			flDamage *= gSkillData.monStomach;
			break;
		case HITGROUP_LEFTARM:
		case HITGROUP_RIGHTARM:
			flDamage *= gSkillData.monArm;
			break;
		case HITGROUP_LEFTLEG:
		case HITGROUP_RIGHTLEG:
			flDamage *= gSkillData.monLeg;
			break;
		default:
			break;
		}

		if ( bitsDamageType == DMG_SABER ) // pour comprendre, il faut couper la tte!
		{
			if ( ptr->iHitgroup == HITGROUP_HEAD )
			{
				if ( pev->health <= flDamage )
				{
					// code pour changer le modle (sans tte), 
					// crer une tte qui va rouler et jouer l'animation de mort correspondante.	
				}
			}
		}



		SpawnBlood(ptr->vecEndPos, BloodColor(), flDamage);
		TraceBleed( flDamage, vecDir, ptr, bitsDamageType );
		
		AddMultiDamage( pevAttacker, this, flDamage, bitsDamageType );

	
}
/////////////
//Take damage
/////////////

int CReeyees :: TakeDamage( entvars_t *pevInflictor, entvars_t *pevAttacker, float flDamage, int bitsDamageType )
{
	Forget( bits_MEMORY_INCOVER );


	
	
	return CSquadMonster :: TakeDamage ( pevInflictor, pevAttacker, flDamage, bitsDamageType );
}


//=========================================================
// projette une arme
//=========================================================
 
void CReeyees :: GibMonster ( void )
{
	Vector	vecGunPos;
	Vector	vecGunAngles;

	if ( m_jesuismort )
	{
		return;
	}

	if ( GetBodygroup( 1 ) != 1 )
	{
		GetAttachment( 0, vecGunPos, vecGunAngles );
		
		CBaseEntity *pGun;
		
			pGun = DropItem( "weapon_strifle", vecGunPos, vecGunAngles );
	
		if ( pGun )
		{
			pGun->pev->velocity = Vector (RANDOM_FLOAT(-100,100), RANDOM_FLOAT(-100,100), RANDOM_FLOAT(200,300));
			pGun->pev->avelocity = Vector ( 0, RANDOM_FLOAT( 200, 400 ), 0 );
		}
	
		
	}

	CBaseMonster :: GibMonster();
}

//=========================================================
// StopTalking - ne parle plus pendant 10-20 secondes
//=========================================================
void CReeyees::StopTalking( void )
{
	m_flNextWordTime = m_flNextSpeakTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);
}

//=========================================================
// ShouldSpeak - est-ce qu'il doit parler?
//=========================================================
BOOL CReeyees::ShouldSpeak( void )
{
	if ( m_flNextSpeakTime > gpGlobals->time )
	{
		
		return FALSE;
	}

	if ( pev->spawnflags & SF_MONSTER_GAG )
	{
		if ( m_MonsterState != MONSTERSTATE_COMBAT )
		{
			// si 'gag' est mis il ne parle pas hors du combat
			// on repousse un peu plus loim
			m_flNextSpeakTime = gpGlobals->time + 3;
			return FALSE;
		}
	}

	return TRUE;
}

//=========================================================
// PrescheduleThink 
//=========================================================
void CReeyees :: PrescheduleThink ( void )
{
	if ( ShouldSpeak() )
	{
		if ( m_flNextWordTime < gpGlobals->time )
		{
			int num = -1;

				switch	( m_MonsterState )
				{
				case MONSTERSTATE_IDLE:
					{
			
						do
						{
							num = RANDOM_LONG(0,ARRAYSIZE(pIdleSounds)-1);
						} while( num == m_iLastWord );

						m_iLastWord = num;

						
						EMIT_SOUND ( ENT(pev), CHAN_VOICE, pIdleSounds[ num ], 1.0, ATTN_NORM );
					}
					break;
				
				case MONSTERSTATE_COMBAT:// faut tre logique 
					{
			
						do
						{
							num = RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1);
						} while( num == m_iLastWord );

						m_iLastWord = num;

						
						EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[ num ], 1.0, ATTN_NORM );
					}
					break;

				}

			
			if ( RANDOM_LONG( 1, 10 ) <= 7 )
			{
				
				StopTalking();
			}
			else
			{
				m_flNextWordTime = gpGlobals->time + RANDOM_FLOAT( 3.5, 8 );
			}
		}
	}
}

//=========================================================
// DieSound
//=========================================================
void CReeyees :: DeathSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pDieSounds[RANDOM_LONG(0,ARRAYSIZE(pDieSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AlertSound
//=========================================================
void CReeyees :: AlertSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAlertSounds[RANDOM_LONG(0,ARRAYSIZE(pAlertSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// AttackSound
//=========================================================
void CReeyees :: AttackSound ( void )
{
	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pAttackSounds[RANDOM_LONG(0,ARRAYSIZE(pAttackSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// PainSound
//=========================================================
void CReeyees :: PainSound ( void )
{
	if ( m_flNextPainTime > gpGlobals->time )
	{
		return;
	}

	m_flNextPainTime = gpGlobals->time + 1.6;

	StopTalking();

	EMIT_SOUND ( ENT(pev), CHAN_VOICE, pPainSounds[RANDOM_LONG(0,ARRAYSIZE(pPainSounds)-1)], 1.0, ATTN_NORM );
}

//=========================================================
// Classify - position dans la table des relations
//=========================================================
int	CReeyees :: Classify ( void )
{
	float m_sante = gSkillData.reeyeesHealth;

	float m_health = pev-> health;

	float m_PlayerDamage = m_NombrePunch * gSkillData.blasterDmg;

	int m_arme = ArmeEnmain( );

	BOOL m_passif;

	if ( m_arme == WEAPON_NONE )
	{
		m_passif = 1;
	}

	if ( m_arme == WEAPON_HANDS )
	{
		m_passif = 1;
	}
	else
	{
		m_passif = 0;
	}

	if ( m_passif == 1 )
	{
		m_enalerte = FALSE;
	}

	if ( (m_sante - 5) > pev-> health )
	{ 
		if ( m_healthPaix == 0 || (m_health + 3)  < m_healthPaix )
		{		
			m_enalerte = TRUE;
			
		}
		else 
		{
			m_enalerte = FALSE;
		}
	}

	if ( m_passif == 0 )
		{
			m_enalerte = TRUE;
		}

	if ( pev->health < m_sante * 0.5 )
		{
			m_enalerte = TRUE;
		}



	if ( m_MonsterState == MONSTERSTATE_COMBAT )
	{
		// ajout du contrle sur le fait que si le joueur n'a bless personne 
		// plus qu'il n'a t bless, l'ennemi redevient pacifique si le joueur range son arme
		if ( m_passif == 1 )
		{
		
			if ( (m_sante - m_health) <= m_PlayerDamage && pev->health > m_sante * 0.5 )
			{
				m_enalerte = FALSE; //a suffit, t'en a pris plein la gueule, on fait la paix.

				m_healthPaix = m_health;

				m_hEnemy = NULL;

				m_IdealMonsterState = MONSTERSTATE_IDLE;

				m_NombrePunch = 0;

			}
			else
			{
				m_enalerte = TRUE;
			}

		}
		
		else
		{
			m_enalerte = TRUE;
		}
		
		
	}
	

	if ( m_enalerte )
	{
		if ( m_armedepart == 1 )
		{
			//SetBodygroup( GUN_GROUP, GUN_STRIFLE );
		}
		else
		{
			//SetBodygroup( GUN_GROUP, GUN_NONE );
		}
		return  CLASS_ALIEN_MILITARY;
	}

	else
	{
		//SetBodygroup( GUN_GROUP, GUN_NONE );
		return	CLASS_ALIEN_PASSIVE;
	}
	
}

//=========================================================
// SetYawSpeed - permet d'avoir un taux de rotation pour chaque squence
//=========================================================
void CReeyees :: SetYawSpeed ( void )
{
	int ys;

	switch ( m_Activity )
	{
	case ACT_IDLE:	
		ys = 150;		
		break;
	case ACT_RUN:	
		ys = 150;	
		break;
	case ACT_WALK:	
		ys = 180;		
		break;
	case ACT_RANGE_ATTACK1:	
		ys = 120;	
		break;
	case ACT_MELEE_ATTACK1:	
		ys = 120;	
		break;	
	case ACT_TURN_LEFT:
	case ACT_TURN_RIGHT:	
		ys = 180;
		break;
	case ACT_GLIDE:
	case ACT_FLY:
		ys = 30;
		break;
	default:
		ys = 90;
		break;
	}

	pev->yaw_speed = ys;
}

//=========================================================
// GetGunPosition	donne l'extrmit du canon
//=========================================================

Vector CReeyees :: GetGunPosition( )
{
	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); //point d'attache numro 1 du canon
	return vecArmPos;
/*	
	if (m_fStanding )
	{
		return pev->origin + Vector( 0, 0, 60 );
	}
	else
	{
		return pev->origin + Vector( 0, 0, 48 );
	}
*/
}


//=========================================================
//Tir d'un projectile Blaster
//=========================================================

void CReeyees :: Shoot ( void )
{
	if (m_hEnemy == NULL)
	{
		return;
	}

	Vector vecShootOrigin = GetGunPosition();
	Vector vecShootDir = ShootAtEnemy( vecShootOrigin );

	UTIL_MakeVectors ( pev->angles );
	
	// code pour tirer un projectile de blaster
	// ajout de la dispersion du tir automatique rapide

	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_1DEGREES ;
	vecShootDir = vecShootDir + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;


	CYoBlaster::Shoot(pev,vecShootOrigin,vecShootDir * 2000);

	pev->effects |= EF_MUZZLEFLASH;

	/*
	//debut glowshell
	pev->rendermode = kRenderNormal;

	pev->renderamt = 255;

	pev->rendercolor.x = 0;

	pev->rendercolor.y = 0;

	pev->rendercolor.z = 255;

	pev->renderamt = 10;

	pev->renderfx = kRenderFxGlowShell;

	//fin glowshell
	*/
	
	m_cAmmoLoaded--;// retire un coup du chargeur!

	Vector angDir = UTIL_VecToAngles( vecShootDir );
	SetBlending( 0, angDir.x ); // donne l'inclinaison de tir du reeyees pour l'animation
}

//=========================================================
// HandleAnimEvent - prend en compte les message spcifiques contenus dans les animations
// Retourne le nombre d'venements traits.
//=========================================================
void CReeyees :: HandleAnimEvent( MonsterEvent_t *pEvent )
{
	switch( pEvent->event )
	{

	case REEYEES_AE_DRAW_WEAPON:
		{

			if ( m_armedepart == 1 )
			{
				SetBodygroup( GUN_GROUP, GUN_STRIFLE );
			}
			else
			{
				SetBodygroup( GUN_GROUP, GUN_NONE );
			}
			
			m_fGunDrawn = TRUE;
		}

		break;

	case REEYEES_AE_HOLSTER:
		{
			SetBodygroup( GUN_GROUP, GUN_NONE );
			
			m_fGunDrawn = FALSE;

		}

		break;

	case REEYEES_AE_TOSS1:
		{
			UTIL_MakeVectors( pev->angles );
			CThermal::ShootTimed( pev, pev->origin + gpGlobals->v_forward * 34 + Vector (0, 0, 32), m_vecTossVelocity, 3.5 );

			m_flNextGrenadeCheck = gpGlobals->time + 2;// wait six seconds before even looking again to see if a grenade can be thrown.
			m_fThrowGrenade = FALSE;
			m_cAmmoLoaded--;

			m_NombrePunch++;
		}
		break;
	
	case REEYEES_AE_DROP_GUN:
		
		{		
		Vector	vecGunPos;
		Vector	vecGunAngles;

		GetAttachment( 1, vecGunPos, vecGunAngles );

		m_armedepart = 0;

		// passe au corps sans arme
		SetBodygroup( GUN_GROUP, GUN_NONE );

		// cre un pistol
		
			

			
			if (FBitSet( pev->weapons, REEYEES_THERMAL ))
			{
				DropItem( "weapon_handthermal", vecGunPos, vecGunAngles );
			}
			else if (FBitSet( pev->weapons, REEYEES_STRIFLE ))
			{
				DropItem( "weapon_strifle", vecGunPos, vecGunAngles );
			}
			 
			m_jesuismort = 1;
		}

		break;

	case REEYEES_AE_RELOAD:
		
		
			EMIT_SOUND( ENT(pev), CHAN_WEAPON, "stormt/st_reload1.wav", 1, ATTN_NORM );
			m_cAmmoLoaded = m_cClipSize;
	

		ClearConditions(bits_COND_NO_AMMO_LOADED);
		break;

	case REEYEES_AE_TIR1: 
		{
			// m_vecEnemyLKP doit tre le centre de l'ennemi
			Vector vecArmPos, vecArmDir;
			Vector vecDirToEnemy;
			Vector angDir;

				vecDirToEnemy = ( ( m_vecEnemyLKP ) - pev->origin );
				angDir = UTIL_VecToAngles( vecDirToEnemy );
				vecDirToEnemy = vecDirToEnemy.Normalize();
			
			

			pev->effects = EF_MUZZLEFLASH;// clair de dpart du coup

			// make angles +-180
			if (angDir.x > 180)
			{
				angDir.x = angDir.x - 360;
			}

			SetBlending( 0, angDir.x );
			GetAttachment( 0, vecArmPos, vecArmDir );

			vecArmPos = vecArmPos + vecDirToEnemy * 32;
			MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecArmPos );
				WRITE_BYTE( TE_SPRITE );
				WRITE_COORD( vecArmPos.x );	// position
				WRITE_COORD( vecArmPos.y );	
				WRITE_COORD( vecArmPos.z );	
				WRITE_SHORT( iReeyeesMuzzleFlash );		// model
				WRITE_BYTE( 6 );				// taille * 10
				WRITE_BYTE( 128 );			// luminosit
			MESSAGE_END();

			// code pour le tir d'un projectile blaster pistolet (vert)

			Shoot();

			if ( RANDOM_LONG(0,1) )
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf1.wav", 1, ATTN_NORM );
				}
				else
				{
					EMIT_SOUND( ENT(pev), CHAN_WEAPON, "weapons/strf2.wav", 1, ATTN_NORM );
				}

		}
		break;

	
	case REEYEES_AE_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( REEYEES_MELEE_DIST, ( gSkillData.reeyeesDmgPunch ) , DMG_CLUB );
			
			if ( pHurt )//touch
			{
				pHurt->pev->punchangle.y = 20;
				pHurt->pev->punchangle.x = 28;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * -150;

					m_NombrePunch++;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				
			}
			else
			{
				// c'est rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}
		}
		break;

	case REEYEES_AE_LEFT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( REEYEES_MELEE_DIST, ( gSkillData.reeyeesDmgPunch ) , DMG_CLUB );
			
			if ( pHurt )//touch
			{
				pHurt->pev->punchangle.y = -30;
				pHurt->pev->punchangle.x = 28;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * 180;

					m_NombrePunch++;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				//Vector vecArmPos, vecArmAng;
				//GetAttachment( 0, vecArmPos, vecArmAng );
				//SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				// c'est rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}
		}
		break;

	case REEYEES_AE_RIGHT_PUNCH:
		{
			CBaseEntity *pHurt = CheckTraceHullAttack( REEYEES_MELEE_DIST, gSkillData.reeyeesDmgPunch, DMG_CLUB );

			if ( pHurt )
			{
				pHurt->pev->punchangle.y = 30;
				pHurt->pev->punchangle.x = 28;

				if ( pHurt->IsPlayer() )
				{
					pHurt->pev->velocity = pHurt->pev->velocity + gpGlobals->v_right * -180;

					m_NombrePunch++;
				}

				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackHitSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackHitSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );

				Vector vecArmPos, vecArmAng;
				GetAttachment( 0, vecArmPos, vecArmAng );
				SpawnBlood(vecArmPos, pHurt->BloodColor(), 25);// une gicle de sang
			}
			else
			{
				//caramba! encore rat
				EMIT_SOUND_DYN ( ENT(pev), CHAN_WEAPON, pAttackMissSounds[ RANDOM_LONG(0,ARRAYSIZE(pAttackMissSounds)-1) ], 1.0, ATTN_NORM, 0, 100 + RANDOM_LONG(-5,5) );
			}
		}
		break;

	default:
		CSquadMonster::HandleAnimEvent( pEvent );
		break;
	}
}


//========================================================
//vrifie la munitions
//========================================================

void CReeyees :: CheckAmmo ( void )
{
	if ( m_cAmmoLoaded <= 0 )
	{
		SetConditions(bits_COND_NO_AMMO_LOADED);
	}
}


//=========================================================
// Spawn
//=========================================================
void  CReeyees:: Spawn()
{
	Precache( );

	SET_MODEL(ENT(pev), "models/reeyees.mdl");
	UTIL_SetSize(pev, Vector(-16, -16, 0), Vector(16, 16, 80));

	pev->solid			= SOLID_SLIDEBOX;
	pev->movetype		= MOVETYPE_STEP;
	m_bloodColor		= BLOOD_COLOR_RED;
	pev->effects		= 0;
	pev->health			= gSkillData.reeyeesHealth;
	m_flFieldOfView		= 0.2;
	m_MonsterState		= MONSTERSTATE_NONE;
	m_afCapability		= bits_CAP_SQUAD | bits_CAP_RANGE_ATTACK2 | bits_CAP_DOORS_GROUP;

	m_flNextSpeakTime	= m_flNextWordTime = gpGlobals->time + 10 + RANDOM_LONG(0, 10);

	m_HackedGunPos = Vector ( 0, 0, 65 );

	pev->iuser3 = 2;//masse
	pev->iuser4	= 1;//incendie

	
	if (pev->weapons == 0)
	{
		//ALERT ( at_console, "Hands\n");
		pev->weapons = REEYEES_HANDS ;
				
	}

	if (FBitSet( pev->weapons, REEYEES_STRIFLE ))
	{
		//ALERT ( at_console, "Strifle\n");
		SetBodygroup( GUN_GROUP, GUN_NONE ); // classify changera selon les besoin de l'AI
		m_cClipSize		= REEYEES_CLIP_SIZE;
		m_noreload		= FALSE;
		m_armedepart	= 1;

	}

	if (FBitSet( pev->weapons, REEYEES_THERMAL ))
	{
		//ALERT ( at_console, "Thermal\n");
		SetBodygroup( GUN_GROUP, GUN_NONE );
		m_cClipSize		= REEYEES_THERMAL_NBR;
		m_noreload		= TRUE;
		m_armedepart	= 2;

	}

	if (FBitSet( pev->weapons, REEYEES_HANDS ))
	{
		SetBodygroup( GUN_GROUP, GUN_NONE );
		m_noreload		= TRUE;
		m_armedepart	= 0;

	}
	
	m_cAmmoLoaded		= m_cClipSize;

	m_fGunDrawn			= FALSE;

	MonsterInit();
}

//=========================================================
// Precache - met en prcache les ressources
//=========================================================
void CReeyees :: Precache()
{
	int i;

	PRECACHE_MODEL("models/reeyees.mdl");

	for ( i = 0; i < ARRAYSIZE( pAttackHitSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackHitSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackMissSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackMissSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pIdleSounds ); i++ )
		PRECACHE_SOUND((char *)pIdleSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pDieSounds ); i++ )
		PRECACHE_SOUND((char *)pDieSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pPainSounds ); i++ )
		PRECACHE_SOUND((char *)pPainSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAttackSounds ); i++ )
		PRECACHE_SOUND((char *)pAttackSounds[i]);

	for ( i = 0; i < ARRAYSIZE( pAlertSounds ); i++ )
		PRECACHE_SOUND((char *)pAlertSounds[i]);


	PRECACHE_SOUND( "weapons/strf1.wav" );
	PRECACHE_SOUND( "weapons/strf2.wav" );
	PRECACHE_SOUND( "stormt/st_reload1.wav" );
	
  
	iReeyeesMuzzleFlash = PRECACHE_MODEL( "sprites/muz4.spr" );
	PRECACHE_MODEL("sprites/blaster.spr");

	m_Yoisprite = PRECACHE_MODEL( "sprites/hotglow.spr" ); //pour le tir du blaster
	m_Yoismoke = PRECACHE_MODEL( "sprites/blasthit.spr" ); //pour l'impacte du blaster
	m_iYoTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	m_ReWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );
	
}	
	
//=========================================================
// AI Schedules spcifiques
//=========================================================

//=========================================================
// Fail Schedule
//=========================================================
Task_t	tlReeyeesFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE },
	{ TASK_WAIT,				(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slReeyeesFail[] =
{
	{
		tlReeyeesFail,
		ARRAYSIZE ( tlReeyeesFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Reeyees Fail"
	},
};

//=========================================================
// Combat Fail Schedule
//=========================================================
Task_t	tlReeyeesCombatFail[] =
{
	{ TASK_STOP_MOVING,			0				},
	{ TASK_SET_ACTIVITY,		(float)ACT_IDLE_ANGRY },
	{ TASK_WAIT_FACE_ENEMY,		(float)2		},
	{ TASK_WAIT_PVS,			(float)0		},
};

Schedule_t	slReeyeesCombatFail[] =
{
	{
		tlReeyeesCombatFail,
		ARRAYSIZE ( tlReeyeesCombatFail ),
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_CAN_MELEE_ATTACK1,
		0,
		"Reeyees Combat Fail"
	},
};

//=========================================================
// Standoff schedule. Utilis en combat lorsque le monstre a perdu de vue l'ennemi
// Doit-on aller voir dans le coin?
//=========================================================
Task_t	tlReeyeesStandoff[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_ACTIVITY,			(float)ACT_IDLE				},
	{ TASK_WAIT_FACE_ENEMY,			(float)2					},
};

Schedule_t slReeyeesStandoff[] = 
{
	{
		tlReeyeesStandoff,
		ARRAYSIZE ( tlReeyeesStandoff ),
		bits_COND_CAN_RANGE_ATTACK1		|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_SEE_ENEMY				|
		bits_COND_NEW_ENEMY				|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Reeyees Standoff"
	}
};


//=========================================================
// primary range attacks
//=========================================================
Task_t	tlReeyeesRangeAttack1[] =
{
	{ TASK_STOP_MOVING,			(float)0		},
	{ TASK_FACE_ENEMY,			(float)0		},
	{ TASK_RANGE_ATTACK1,		(float)0		},
};

Schedule_t	slReeyeesRangeAttack1[] =
{
	{ 
		tlReeyeesRangeAttack1,
		ARRAYSIZE ( tlReeyeesRangeAttack1 ), 
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"Reeyees Range Attack1"
	},
};

//=========================================================
// Attaque secondaire , il faut attendre avant de courrir vers l'ennemi sinon boum!!
//=========================================================
Task_t	tlReeyeesRangeAttack2[] =
{
	
	{ TASK_PLAY_SEQUENCE,			(float)ACT_RANGE_ATTACK2	},
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_SCHEDULE,			(float)SCHED_COWER	},
};

Schedule_t	slReeyeesRangeAttack2[] =
{
	{ 
		tlReeyeesRangeAttack2,
		ARRAYSIZE ( tlReeyeesRangeAttack2 ), 
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_HEAR_SOUND,

		bits_SOUND_DANGER,
		"RangeAttack2"
	}
};

//=========================================================
// Se mettre  couvert, d'abord de ct puis vers un noeud
//=========================================================
Task_t	tlReeyeesTakeCoverFromEnemy[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SMALL_FLINCH,			(float)0					},
	{ TASK_WAIT,					(float)0.2					},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
};

Schedule_t	slReeyeesTakeCoverFromEnemy[] =
{
	{ 
		tlReeyeesTakeCoverFromEnemy,
		ARRAYSIZE ( tlReeyeesTakeCoverFromEnemy ), 
		bits_COND_NEW_ENEMY |
		bits_COND_CAN_MELEE_ATTACK1		|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"ReeyeesTakeCoverFromEnemy"
	},
};

//Attention au grenades

Task_t	tlReeyeesTakeCoverFromBestSound[] =
{
	{ TASK_SET_FAIL_SCHEDULE,			(float)SCHED_COWER	},
	{ TASK_STOP_MOVING,					(float)0					},
	{ TASK_FIND_COVER_FROM_BEST_SOUND,	(float)0					},
	{ TASK_RUN_PATH,					(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,			(float)0					},
	{ TASK_REMEMBER,					(float)bits_MEMORY_INCOVER	},
	{ TASK_TURN_LEFT,					(float)179					},
};

Schedule_t	slReeyeesTakeCoverFromBestSound[] =
{
	{ 
		tlReeyeesTakeCoverFromBestSound,
		ARRAYSIZE ( tlReeyeesTakeCoverFromBestSound ), 
		bits_COND_NEW_ENEMY,
		0,
		"ReeyeesTakeCoverFromBestSound"
	},
};


//=========================================================
// J'ai gagn !!!
//=========================================================
Task_t	tlReeyeesVictoryDance[] =
{
	{ TASK_STOP_MOVING,						(float)0					},
	{ TASK_WAIT,							(float)0.2					},
	{ TASK_REEYEES_GET_PATH_TO_ENEMY_CORPSE,	(float)0					},
	{ TASK_WALK_PATH,						(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,				(float)0					},
	{ TASK_FACE_ENEMY,						(float)0					},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_CROUCH			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_STAND			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_CROUCH			},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_VICTORY_DANCE	},
	{ TASK_PLAY_SEQUENCE,					(float)ACT_STAND			},
};

Schedule_t	slReeyeesVictoryDance[] =
{
	{ 
		tlReeyeesVictoryDance,
		ARRAYSIZE ( tlReeyeesVictoryDance ), 
		bits_COND_NEW_ENEMY		|
		bits_COND_LIGHT_DAMAGE	|
		bits_COND_HEAVY_DAMAGE,
		0,
		"ReeyeesVictoryDance"
	},
};

Task_t	tlReeyeesSuppress[] =
{
	{ TASK_STOP_MOVING,			0							},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_REEYEES_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_REEYEES_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_REEYEES_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_REEYEES_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
	{ TASK_FACE_ENEMY,			(float)0					},
	{ TASK_REEYEES_CHECK_FIRE,	(float)0					},
	{ TASK_RANGE_ATTACK1,		(float)0					},
};

Schedule_t	slReeyeesSuppress[] =
{
	{ 
		tlReeyeesSuppress,
		ARRAYSIZE ( tlReeyeesSuppress ), 
		bits_COND_ENEMY_DEAD		|
		bits_COND_LIGHT_DAMAGE		|
		bits_COND_HEAVY_DAMAGE		|
		bits_COND_HEAR_SOUND		|
		bits_COND_REEYEES_NOFIRE		|
		bits_COND_NO_AMMO_LOADED,

		bits_SOUND_DANGER,
		"Suppress"
	},
};

//=========================================================
// Officer reload schedule
//=========================================================
Task_t	tlReeyeesHideReload[] =
{
	{ TASK_STOP_MOVING,				(float)0					},
	{ TASK_SET_FAIL_SCHEDULE,		(float)SCHED_RELOAD			},
	{ TASK_FIND_COVER_FROM_ENEMY,	(float)0					},
	{ TASK_RUN_PATH,				(float)0					},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0					},
	{ TASK_REMEMBER,				(float)bits_MEMORY_INCOVER	},
	{ TASK_FACE_ENEMY,				(float)0					},
	{ TASK_PLAY_SEQUENCE,			(float)ACT_RELOAD			},
};

Schedule_t slReeyeesHideReload[] = 
{
	{
		tlReeyeesHideReload,
		ARRAYSIZE ( tlReeyeesHideReload ),
		bits_COND_HEAVY_DAMAGE	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"ReeyeesHideReload"
	}
};

// Recherche l'ennemi

Task_t tlReeyeesHunt[] = 
{
	{ TASK_GET_PATH_TO_ENEMY,	(float)0		},
	{ TASK_RUN_PATH,			(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0		},
};

Schedule_t slReeyeesHunt[] =
{
	{ 
		tlReeyeesHunt,
		ARRAYSIZE ( tlReeyeesHunt ),
		bits_COND_NEW_ENEMY			|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"ReeyeesHunt"
	},
};

//=========================================================
// Establish line of fire - dplace vers une position de tir
//=========================================================
Task_t tlReeyeesEstablishLineOfFire[] = 
{
	{ TASK_SET_FAIL_SCHEDULE,	(float)SCHED_REEYEES_ELOF_FAIL	},
	{ TASK_GET_PATH_TO_ENEMY,	(float)0						},					
	{ TASK_RUN_PATH,			(float)0						},
	{ TASK_WAIT_FOR_MOVEMENT,	(float)0						},
};

Schedule_t slReeyeesEstablishLineOfFire[] =
{
	{ 
		tlReeyeesEstablishLineOfFire,
		ARRAYSIZE ( tlReeyeesEstablishLineOfFire ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_CAN_RANGE_ATTACK2	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"ReeyeesEstablishLineOfFire"
	},
};


Task_t tlReeyeesRecherche[] =
{
	{ TASK_GET_PATH_TO_SPOT,		(float)0		},
	{ TASK_RUN_PATH,				(float)0		},
	{ TASK_WAIT_FOR_MOVEMENT,		(float)0		},
};

Schedule_t slReeyeesRecherche[] =
{
	{
		tlReeyeesRecherche,
		ARRAYSIZE ( tlReeyeesRecherche ),
		bits_COND_NEW_ENEMY			|
		bits_COND_ENEMY_DEAD		|
		bits_COND_CAN_RANGE_ATTACK1	|
		bits_COND_CAN_MELEE_ATTACK1	|
		bits_COND_HEAR_SOUND,
		
		bits_SOUND_DANGER,
		"ReeyeesRecherche"
	},
};

Task_t   tlReeyeesDrawWeapon[] =
{
	{ TASK_STOP_MOVING,				0			},		
	{ TASK_FACE_ENEMY,				0			},
	{ TASK_PLAY_SEQUENCE_FACE_ENEMY, 	(float)  ACT_ARM 	},
};

Schedule_t   slReeyeesDrawWeapon[] =
{
	{ 
		tlReeyeesDrawWeapon,
		ARRAYSIZE ( tlReeyeesDrawWeapon ),
		0,
		0,
		"Reeyees Draw Weapon"
	}
};

Task_t   tlReeyeesHolster[] =
{
	{ TASK_STOP_MOVING,				0					},		
	{ TASK_WAIT,					(float)0.2			},
	{ TASK_PLAY_SEQUENCE, 			(float)  ACT_DISARM 	},
};

Schedule_t   slReeyeesHolster[] =
{
	{ 
		tlReeyeesHolster,
		ARRAYSIZE ( tlReeyeesHolster ),
		0,
		0,
		"Reeyees Holster Weapon"
	}
};
//=========================================================
//=========================================================

DEFINE_CUSTOM_SCHEDULES( CReeyees )
{
	slReeyeesFail,
	slReeyeesCombatFail,
	slReeyeesStandoff,
	slReeyeesRangeAttack1,
	slReeyeesRangeAttack2,
	slReeyeesTakeCoverFromEnemy,
	slReeyeesTakeCoverFromBestSound,
	slReeyeesVictoryDance,
	slReeyeesHideReload,
	slReeyeesSuppress,
	slReeyeesEstablishLineOfFire,
	slReeyeesHunt,
	slReeyeesRecherche,
	slReeyeesDrawWeapon,
	slReeyeesHolster,
};


IMPLEMENT_CUSTOM_SCHEDULES( CReeyees, CSquadMonster );

//=========================================================
// FCanCheckAttacks 
//=========================================================
BOOL CReeyees :: FCanCheckAttacks ( void )
{
	if ( !HasConditions( bits_COND_ENEMY_TOOFAR ) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//=========================================================
// CheckMeleeAttack1 
//=========================================================
BOOL CReeyees :: CheckMeleeAttack1 ( float flDot, float flDist )
{
	
	CBaseMonster *pEnemy;

	if ( m_hEnemy != NULL )
	{
		pEnemy = m_hEnemy->MyMonsterPointer();

		if ( !pEnemy )
		{
			//ALERT ( at_console, "PAS D'ENNEMI\n");
			return FALSE;
		}
	}

	if ( flDist <= 64 && flDot >= 0.7	&& 
		 pEnemy->Classify() != CLASS_ALIEN_BIOWEAPON &&
		 pEnemy->Classify() != CLASS_PLAYER_BIOWEAPON )
	{
		return TRUE;
	}
	return FALSE;
	
}

//=========================================================
// CheckRangeAttack1 
//=========================================================
BOOL CReeyees :: CheckRangeAttack1 ( float flDot, float flDist )
{
	
	if ( FBitSet(pev->weapons, (REEYEES_HANDS )))
		{
			return FALSE;
		}

	if ( FBitSet(pev->weapons, (REEYEES_THERMAL )))
		{
			
			return FALSE;
		}

	if ( m_cAmmoLoaded <= 0 && m_noreload == TRUE)
	{
		return FALSE;
	}

	if ( !HasConditions( bits_COND_ENEMY_OCCLUDED ) && flDist <= 2048 && flDot >= 0.5 && NoFriendlyFire() )
	{
		TraceResult	tr;
		
		
		if ( !m_hEnemy->IsPlayer() && flDist <= 64 )
		{
			
			return FALSE;
		}

		Vector vecSrc = GetGunPosition();

		
		UTIL_TraceLine( vecSrc, m_hEnemy->BodyTarget(vecSrc), ignore_monsters, ignore_glass, ENT(pev), &tr);

		if ( tr.flFraction == 1.0 ) //si gal  1 cel veut dire que la voie est libre
		{
			return TRUE;
		}
	}

	return FALSE;
}


//=========================================================
// CheckRangeAttack2 - toss grenade if enemy gets in the way and is too close. 
//=========================================================
BOOL CReeyees :: CheckRangeAttack2 ( float flDot, float flDist )
{
	
	//ALERT ( at_console, "RANGE ATTACK 2\n");
	if ( FBitSet(pev->weapons, (REEYEES_HANDS )))
		{
			return FALSE;
		}

	if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
			return FALSE;
		}

	if ( m_cAmmoLoaded <= 0 ) // le nombre de grenades est limit
	{
		return FALSE;
	}

	if ( m_flNextGrenadeCheck > gpGlobals->time )
	{
		//ALERT ( at_console, "PLUS TARD\n");
		return FALSE;
	}

	if ( !FBitSet ( m_hEnemy->pev->flags, FL_ONGROUND ) && m_hEnemy->pev->waterlevel == 0 && m_vecEnemyLKP.z > pev->absmax.z  )
	{
		
		m_fThrowGrenade = FALSE;
		return m_fThrowGrenade;
	}


	Vector vecTarget;

	// find feet
	if (RANDOM_LONG(0,1))
	{
		// magically know where they are
		vecTarget = Vector( m_hEnemy->pev->origin.x, m_hEnemy->pev->origin.y, m_hEnemy->pev->absmin.z );
	}
	else
	{
		// toss it to where you last saw them
		vecTarget = m_vecEnemyLKP;
	}
		

	if ( InSquad() )
	{
		if (SquadMemberInRange( vecTarget, 384 ))
		{
			// crap, I might blow my own guy up. Don't throw a grenade and don't check again for a while.
			m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
			m_fThrowGrenade = FALSE;
		}
	}
	
	if ( ( vecTarget - pev->origin ).Length2D() <= 384 )
	{
		// crap, I don't want to blow myself up
		//ALERT ( at_console, "TROP PRES\n");
		m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
		m_fThrowGrenade = FALSE;
		return m_fThrowGrenade;
	}
	
	
	Vector vecToss = VecCheckToss( pev, GetGunPosition(), vecTarget, 0.5 );

	if ( vecToss != g_vecZero )
	{
		//ALERT ( at_console, "JESSAIE\n");
		m_vecTossVelocity = vecToss;

		// throw a hand grenade
		m_fThrowGrenade = TRUE;
		// don't check again for a while.
		m_flNextGrenadeCheck = gpGlobals->time; // 1/3 second.
	}
	else
	{
		//ALERT ( at_console, "PEUT PAS\n");
		// don't throw
		m_fThrowGrenade = FALSE;
		// don't check again for a while.
		m_flNextGrenadeCheck = gpGlobals->time + 1; // one full second.
	}
	
	
	return m_fThrowGrenade;
}


//=========================================================
// StartTask
//=========================================================
void CReeyees :: StartTask ( Task_t *pTask )
{
	switch ( pTask->iTask )
	{
	case TASK_REEYEES_GET_PATH_TO_ENEMY_CORPSE:
		{
			UTIL_MakeVectors( pev->angles );
			if ( BuildRoute ( m_vecEnemyLKP - gpGlobals->v_forward * 50, bits_MF_TO_LOCATION, NULL ) )
			{
				TaskComplete();
			}
			else
			{
				ALERT ( at_aiconsole, "ReeyeesGetPathToEnemyCorpse failed!!\n" );
				TaskFail();
			}
		}
		break;
	
	case TASK_RANGE_ATTACK2:
		if (!m_fThrowGrenade)
		{
			ALERT ( at_console, "FINI\n");
			TaskComplete( );
		}
		else
		{
			CSquadMonster :: StartTask ( pTask );
		}
		break;

	case TASK_REEYEES_CHECK_FIRE:
		if ( !NoFriendlyFire() )
		{
			SetConditions( bits_COND_REEYEES_NOFIRE );
		}
		TaskComplete();
		break;

	case TASK_WALK_PATH:
	case TASK_RUN_PATH:
		
		Forget( bits_MEMORY_INCOVER );
		CSquadMonster ::StartTask( pTask );
		break;
		
	case TASK_RELOAD:
		m_IdealActivity = ACT_RELOAD;
		break;

	case TASK_FACE_IDEAL:
	case TASK_FACE_ENEMY:
		CSquadMonster :: StartTask( pTask );
		if (pev->movetype == MOVETYPE_FLY)
		{
			m_IdealActivity = ACT_GLIDE;
		}
		break;

	default: 
		CSquadMonster :: StartTask( pTask );
		break;
	}
}

//===================================================
//Activits dpendant de l'tat actuel
//===================================================

void CReeyees :: SetActivity ( Activity NewActivity )
{
	int	iSequence = ACTIVITY_NOT_AVAILABLE;
	void *pmodel = GET_MODEL_PTR( ENT(pev) );

	switch ( NewActivity)
	{
	case ACT_RANGE_ATTACK1:
		
		
		if ( m_fStanding )
		{
				
			iSequence = LookupSequence( "shoot_strf" );
		}
		else
		{
			
			iSequence = LookupSequence( "shoot_strf" );
		}
				
		break;
	
	case ACT_RUN:

		//ALERT ( at_console, "RUN\n");
		
		if ( pev->health <= REEYEES_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_RUN_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	case ACT_WALK:
		if ( pev->health <= REEYEES_LIMP_HEALTH )
		{
			
			iSequence = LookupActivity ( ACT_WALK_HURT );
		}
		else
		{
			iSequence = LookupActivity ( NewActivity );
		}
		break;
	
	case ACT_TURN_LEFT:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_turnl" );
		}
		else
		{
			
			iSequence = LookupSequence( "turnl" );
		}
				
		break;

	case ACT_TURN_RIGHT:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_turnr" );
		}
		else
		{
			
			iSequence = LookupSequence( "turnr" );
		}
				
		break;

	case ACT_COWER:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_couvert" );
		}
		else
		{
			
			iSequence = LookupSequence( "couvert" );
		}
				
		break;

	case ACT_CROUCH:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_baisse" );
		}
		else
		{
			
			iSequence = LookupSequence( "baisse" );
		}
				
		break;

	case ACT_VICTORY_DANCE:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_victory" );
		}
		else
		{
			
			iSequence = LookupSequence( "victory" );
		}
				
		break;

	case ACT_STAND:
		
		//ALERT ( at_console, "STAND\n");

		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_observe" );
		}
		else
		{
			
			iSequence = LookupSequence( "observe" );
		}
				
		break;

	case ACT_SMALL_FLINCH:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_smallflinch" );
		}
		else
		{
			
			iSequence = LookupSequence( "smallflinch" );
		}
				
		break;

	case ACT_BIG_FLINCH:
		
		
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "strf_bigflinch" );
		}
		else
		{
			
			iSequence = LookupSequence( "bigflinch" );
		}
				
		break;

	case ACT_MELEE_ATTACK1:
		
		//ALERT ( at_console, "ACT MELEE\n");
		if (! FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
				
			iSequence = LookupSequence( "mattack3" );
		}
		else
		{
			if ( RANDOM_LONG(0,1) )
				{
					iSequence = LookupSequence( "mattack1" );
				}
				else
				{
					iSequence = LookupSequence( "mattack2" );
				}
		
		}
				
		break;

	case ACT_ARM:

		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
		
			iSequence = LookupSequence( "drawweapon" );
		}
		else
		{
			iSequence = LookupSequence( "drawhands" );
		}
	
		
		break;

	case ACT_DISARM:

		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
		
			iSequence = LookupSequence( "holster" );
		}
		else
		{
			iSequence = LookupSequence( "downhands" );
		}
	
		
		break;

	case ACT_IDLE_ANGRY:

			
		if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
		{
		
			iSequence = LookupSequence( "strf_idle" );
		}
		else
		{
			iSequence = LookupSequence( "combat_idle" );
		}
	
		
		break;

	
	default:
		iSequence = LookupActivity ( NewActivity );
		break;
	}
	
	m_Activity = NewActivity; 

	
	if ( iSequence > ACTIVITY_NOT_AVAILABLE )
	{
		if ( pev->sequence != iSequence || !m_fSequenceLoops )
		{
			pev->frame = 0;
		}

		pev->sequence		= iSequence;	
		ResetSequenceInfo( );
		SetYawSpeed();
	}
	else
	{
		
		ALERT ( at_console, "%s has no sequence for act:%d\n", STRING(pev->classname), NewActivity );
		pev->sequence		= 0;	
	}
}
//=========================================================
// GetSchedule - dcide du type de schedule qui convient le mieux
// Appelle ensuite la fonction pour obtenir un pointeur vers la schedule 
// qui convient
//=========================================================

Schedule_t *CReeyees :: GetSchedule ( void )
{
	
	switch	( m_MonsterState )
	{
	case MONSTERSTATE_IDLE:
	case MONSTERSTATE_ALERT:
		{
			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
				if ( pSound && (pSound->m_iType & bits_SOUND_COMBAT) )
				{
					return GetScheduleOfType( SCHED_INVESTIGATE_SOUND );
				}
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) || HasConditions ( bits_COND_LIGHT_DAMAGE ) )
			{

				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
			}

			if ( m_fGunDrawn )
			{
				return GetScheduleOfType( SCHED_REEYEES_HOLSTER );
			}

		}
		break;

	
	case MONSTERSTATE_COMBAT:
		{
			if ( pev->iuser4 == 2 )//on fuit si on brle
				{
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ORIGIN );
				}
			if ( HasConditions( bits_COND_ENEMY_DEAD ) )
			{
				// call base class, all code to handle dead enemies is centralized there.
				return CBaseMonster :: GetSchedule();
			}

			if ( HasConditions( bits_COND_HEAR_SOUND ))
			{
				
				CSound *pSound;
				pSound = PBestSound();

				ASSERT( pSound != NULL );
				if ( pSound && (pSound->m_iType & bits_SOUND_DANGER) )
				{
					
					return GetScheduleOfType( SCHED_TAKE_COVER_FROM_BEST_SOUND );
				}
			}

			if ( HasConditions(bits_COND_NEW_ENEMY) )
			{
				return GetScheduleOfType( SCHED_WAKE_ANGRY );

			}

			if ( !m_fGunDrawn )
			{
				return GetScheduleOfType( SCHED_REEYEES_DRAW_WEAPON );
			}

			else if ( HasConditions ( bits_COND_NO_AMMO_LOADED ) && m_noreload == FALSE )
			{
				//ALERT ( at_console, "RELOAD\n");

				return GetScheduleOfType ( SCHED_REEYEES_COVER_AND_RELOAD );
			}

	// zap player!
			if ( HasConditions ( bits_COND_CAN_MELEE_ATTACK1 ) )
			{
				
				if ( m_flNextAttackSound < gpGlobals->time )// pas  chaque fois
				{
					AttackSound();
			
					m_flNextAttackSound = gpGlobals->time + 10;// on verra tout  l'heure
				}

				//ALERT ( at_console, "MELEE1\n");

				
				return GetScheduleOfType ( SCHED_MELEE_ATTACK1 );
			}

			if ( HasConditions ( bits_COND_HEAVY_DAMAGE ) )
			{
				return GetScheduleOfType( SCHED_TAKE_COVER_FROM_ENEMY );
			}

			
			// throw grenade
			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK2 ) )
			{
				// ALERT( at_console, "range attack 2\n");
				return GetScheduleOfType ( SCHED_RANGE_ATTACK2 );
			}

			
			if ( HasConditions( bits_COND_SEE_ENEMY ) && !HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) )
			{
					

				if ( HasConditions( bits_COND_CAN_RANGE_ATTACK2 )  )
					{
						return GetScheduleOfType( SCHED_RANGE_ATTACK2 );
					}
					else 
					{
						if ( FBitSet(pev->weapons, (REEYEES_STRIFLE )))
						{
		
							return GetScheduleOfType( SCHED_REEYEES_ESTABLISH_LINE_OF_FIRE );
						}
						else
						{
							if ( HasConditions( bits_COND_CAN_MELEE_ATTACK1 ))
							{
								//ALERT ( at_console, "MELEE2\n");
								return GetScheduleOfType ( SCHED_MELEE_ATTACK1 );
							}
							else
							{
								//ALERT ( at_console, "CHASE\n");

								return GetScheduleOfType( SCHED_CHASE_ENEMY );
							}
						}

					}
			}

			

			if ( HasConditions ( bits_COND_CAN_RANGE_ATTACK1 ) && OccupySlot ( bits_SLOTS_REEYEES_TIR ) )
			{
				return GetScheduleOfType ( SCHED_RANGE_ATTACK1 );
			}

			if ( OccupySlot ( bits_SLOT_REEYEES_CHASE ) )
			{
				return GetScheduleOfType ( SCHED_CHASE_ENEMY );
			}
			
		}

		return GetScheduleOfType ( SCHED_STANDOFF );
	}

	return CSquadMonster :: GetSchedule();
}

//=========================================================
//=========================================================
Schedule_t* CReeyees :: GetScheduleOfType ( int Type ) 
{
	switch	( Type )
	{

	case SCHED_REEYEES_HOLSTER:

		return	&slReeyeesHolster[ 0 ];

		break;

	case SCHED_REEYEES_DRAW_WEAPON:
		if ( m_hEnemy != NULL )
		{
			return &slReeyeesDrawWeapon[ 0 ];
		}
		break;

	case SCHED_TAKE_COVER_FROM_ENEMY:
		return &slReeyeesTakeCoverFromEnemy[ 0 ];

	case SCHED_TAKE_COVER_FROM_BEST_SOUND:
		return &slReeyeesTakeCoverFromBestSound[ 0 ];
		break;
	
	case SCHED_CHASE_ENEMY:
		return &slReeyeesHunt[ 0 ];	
	
	case SCHED_RANGE_ATTACK1:
		
		return &slReeyeesRangeAttack1[ 0 ];
				
		break;
	
	case SCHED_RANGE_ATTACK2:

		return &slReeyeesRangeAttack2[ 0 ];

		break;

	case SCHED_REEYEES_RECHERCHE:
		return &slReeyeesRecherche[ 0 ];
		break;

	case SCHED_STANDOFF:
		return &slReeyeesStandoff[ 0 ];
		break;

	case SCHED_VICTORY_DANCE:
		return &slReeyeesVictoryDance[ 0 ];
		break;

	case SCHED_REEYEES_ELOF_FAIL:
		{			
			//ALERT ( at_console, "FAIL\n");

			return GetScheduleOfType ( SCHED_TAKE_COVER_FROM_ENEMY );
		}
		break;

	case SCHED_REEYEES_ESTABLISH_LINE_OF_FIRE:
		{
			return &slReeyeesEstablishLineOfFire[ 0 ];
		}
		break;

	case SCHED_REEYEES_COVER_AND_RELOAD:
		{
			return &slReeyeesHideReload[ 0 ];
		}

	case SCHED_FAIL:
			
		{
			if ( m_hEnemy != NULL )
			{
				
				return &slReeyeesCombatFail[ 0 ];
			}

			return &slReeyeesFail[ 0 ];
		}
		break;

	}

	return CSquadMonster :: GetScheduleOfType( Type );
}

//=========================================================
// Classe  pour un cadavre de reeyees
//=========================================================
class CDeadReeyees : public CBaseMonster
{
public:
	void Spawn( void );
	int	Classify ( void ) { return	CLASS_ALIEN_MILITARY; }

	void KeyValue( KeyValueData *pkvd );

	int	m_iPose;
	static char *m_szPoses[3];
};

char *CDeadReeyees::m_szPoses[] = { "deadstomach", "deadside", "deadsitting" };

void CDeadReeyees::KeyValue( KeyValueData *pkvd )
{
	if (FStrEq(pkvd->szKeyName, "pose"))
	{
		m_iPose = atoi(pkvd->szValue);
		pkvd->fHandled = TRUE;
	}
	else 
		CBaseMonster::KeyValue( pkvd );
}

LINK_ENTITY_TO_CLASS( monster_reeyees_dead, CDeadReeyees );

//=========================================================
// ********** Cadavre d'officier **********
//=========================================================
void CDeadReeyees :: Spawn( void )
{
	PRECACHE_MODEL("models/reeyees.mdl");
	SET_MODEL(ENT(pev), "models/reeyees.mdl");

	pev->effects		= 0;
	pev->yaw_speed		= 8;
	pev->sequence		= 0;
	m_bloodColor		= BLOOD_COLOR_RED;

	pev->sequence = LookupSequence( m_szPoses[m_iPose] );

	if (pev->sequence == -1)
	{
		ALERT ( at_console, "Dead reeyees with bad pose\n" );
	}

	
	pev->health			= 8;

	
	switch( pev->body )
	{
	case 0: // reeyees avec strifle
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_STRIFLE );
		break;
	case 1: // reeyees sans arme
		pev->body = 0;
		SetBodygroup( GUN_GROUP, GUN_NONE );
		break;
	}

	MonsterInitDead();
}
