/***
*
*	Code pour crer un sabre laser
*	  
*	Jean-Franois Vuagniaux : vuagniaux.jf@com.mcnet.ch
*
****/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "gamerules.h"



#define	SABER_BODYHIT_VOLUME 128
#define	SABER_WALLHIT_VOLUME 512




class CSaber : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 1; }
	int GetItemInfo(ItemInfo *p);
	
	void PrimaryAttack( void );
	void SecondaryAttack( void );
	void EXPORT Smack( int SoundType );
	void Boum( int AType );
	void EXPORT SecBoum( void );
	void EXPORT PriBoum( void );
	BOOL Deploy( void );
	void Holster(int skiplocal = 0 );
	
	void Etincelles( int chocmonde );
	void EXPORT Humsound(void);// vilain code pour son en boucle (peut mieux faire !!!)
	
	float fvolbar;
	float m_topdepart;// pour son en boucle
	int m_iSwing;
	int m_sabGlow; 
	int m_sabBalls;
	BOOL m_boucle; // pour son ambient du sabre
	Vector vecSparks;
	TraceResult m_trHit;
};
LINK_ENTITY_TO_CLASS( weapon_saber, CSaber );


enum gauss_e {
	SABER_IDLE = 0,
	SABER_DRAW,
	SABER_HOLSTER,
	SABER_ATTACK1HIT,
	SABER_ATTACK1MISS,
	SABER_ATTACK2MISS,
	SABER_ATTACK2HIT,
	SABER_ATTACK3MISS,
	SABER_ATTACK3HIT,
	SABER_SECATTACK1HIT,// les deux actions secondaires  ont t inverse 
	SABER_SECATTACK1 //par accident lors de l'animation
};



void CSaber::Spawn( )
{
	pev->classname = MAKE_STRING("weapon_saber");
	Precache( );
	m_iId = WEAPON_SABER;
	SET_MODEL(ENT(pev), "models/w_saber.mdl"); // modle du sabre  placer dans la map
	m_iClip = -1;// pas de munition utilise

	FallInit();
	//m_boucle = TRUE; // dmarrage de la boucle
}


void CSaber::Precache( void )
{
	PRECACHE_MODEL("models/v_saber.mdl");
	PRECACHE_MODEL("models/w_saber.mdl");
	PRECACHE_MODEL("models/p_saber.mdl");
	PRECACHE_SOUND("weapons/saber_hit1.wav");
	PRECACHE_SOUND("weapons/saber_hit2.wav");
	PRECACHE_SOUND("weapons/saber_hitbod1.wav");
	PRECACHE_SOUND("weapons/saber_hitbod2.wav");
	PRECACHE_SOUND("weapons/saber_hitbod3.wav");
	PRECACHE_SOUND("weapons/saber_miss1.wav");
	PRECACHE_SOUND("weapons/saber_miss2.wav");
	PRECACHE_SOUND("weapons/saber_hum.wav");
	m_sabGlow = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_sabBalls = PRECACHE_MODEL( "sprites/hotglow.spr" );
}

int CSaber::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = NULL;
	p->iMaxAmmo1 = -1;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = WEAPON_NOCLIP;
	p->iSlot = 0;
	p->iPosition = 4; // position de l'arme dans le slot 1 (pied de biche :0)
	p->iId = WEAPON_SABER;
	p->iWeight = SABER_WEIGHT;// priorit de l'arme
	return 1;
}

void CSaber::Humsound( ) //Ajout pour le son de fond du sabre
{
	
	if (m_boucle == TRUE) // TRUE au dploiement, FALSE lors de la remise  l'tui.
	{
		if (gpGlobals->time >= m_topdepart+5) // pour viter la superposition du son lors d'appels multiples
		{

			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_STATIC, "weapons/saber_hum.wav", 0.6, ATTN_NORM);
			
			m_topdepart = gpGlobals->time;// dfini le moment o le son commence, il dure 5 sec.
											//attention  modifier si on change la longueur du son
			
		}
		
		SetThink( Humsound );  // cre la boucle
			pev->nextthink = gpGlobals->time + 0.1;//relancer tous les 0.1 sec
	}
	
	else
	{
		STOP_SOUND(ENT(m_pPlayer->pev), CHAN_STATIC, "weapons/saber_hum.wav");// arrte le son
	}
	
// Le son est jou en boucle grce  Think qui va rapeler Humsound toutes les 5 sec.		
// Attention car d'autres fonctions vont utiliser Think et ensuite la boucle s'arrtera, il
// il faudra alors rappeler Humsound dans la fonction que Think a appel pour redmarrer la boucle.
// Le code n'est pas optimal il faudra l'amliorer car le son se superpose parfois ou reste muet un court instant.
}

void CSaber::Etincelles(int chocmonde ) // ajout pour crer des tincelles au point de contact
{
	
	UTIL_Sparks( vecSparks );


			if (chocmonde == 1)
			{
				// tache incandescente
				MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, vecSparks );
					WRITE_BYTE( TE_GLOWSPRITE );
					WRITE_COORD( vecSparks.x);		// position
					WRITE_COORD( vecSparks.y);
					WRITE_COORD( vecSparks.z);
					WRITE_SHORT( m_sabGlow );				// modle
					WRITE_BYTE( 40 );	// dure * 10
					WRITE_BYTE( 3 );					// taille * 10
					WRITE_BYTE( 3000 );			// luminosit
				MESSAGE_END();

			}

				// billes incandescentes
				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSparks );
					WRITE_BYTE( TE_SPRITETRAIL );
					WRITE_COORD( vecSparks.x );
					WRITE_COORD( vecSparks.y );
					WRITE_COORD( vecSparks.z );
					WRITE_COORD( vecSparks.x );
					WRITE_COORD( vecSparks.y );
					WRITE_COORD( vecSparks.z );
					WRITE_SHORT( m_sabBalls );		// modle
					WRITE_BYTE( 10 );				// nombre
					WRITE_BYTE( 10 );				// dure * 10
					WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille * 10
					WRITE_BYTE( 10 );				// amplitude * 0.1
					WRITE_BYTE( 20 );				// vitesse * 100
				MESSAGE_END();
			
}


BOOL CSaber::Deploy( )
{
	m_boucle = TRUE;
		
	SetBits(m_pPlayer->pev->effects, EF_BRIGHTLIGHT);// allume la lueur du sabre
	
	Humsound(); // dmarre le processus du son en boucle

	//pev->effects = kRenderFxGlowShell;
	
	return DefaultDeploy( "models/v_saber.mdl", "models/p_saber.mdl", SABER_DRAW, "saber" );

}

void CSaber::Holster(int skiplocal  )
{
	
	m_boucle = FALSE;

	ClearBits(m_pPlayer->pev->effects, EF_BRIGHTLIGHT);// teint la lumire
	

	Humsound();// ncessaire de rapeler pour que le son stoppe immdiatement
	
	m_pPlayer->m_flNextAttack = gpGlobals->time + 0.5;
	SendWeaponAnim( SABER_HOLSTER );
}


//la fonction suivante dtermine le point de contact du sabre avec le monde ou un objet.

void SabFindHullIntersection( const Vector &vecSrc, TraceResult &tr, float *mins, float *maxs, edict_t *pEntity )
{
	int			i, j, k;
	float		distance;
	float		*minmaxs[2] = {mins, maxs};
	TraceResult tmpTrace;
	Vector		vecHullEnd = tr.vecEndPos;
	Vector		vecEnd;

	distance = 1e6f;

	vecHullEnd = vecSrc + ((vecHullEnd - vecSrc)*2);
	UTIL_TraceLine( vecSrc, vecHullEnd, dont_ignore_monsters, pEntity, &tmpTrace );
	if ( tmpTrace.flFraction < 1.0 )
	{
		tr = tmpTrace;
		return;
	}

	for ( i = 0; i < 2; i++ )
	{
		for ( j = 0; j < 2; j++ )
		{
			for ( k = 0; k < 2; k++ )
			{
				vecEnd.x = vecHullEnd.x + minmaxs[i][0];
				vecEnd.y = vecHullEnd.y + minmaxs[j][1];
				vecEnd.z = vecHullEnd.z + minmaxs[k][2];

				UTIL_TraceLine( vecSrc, vecEnd, dont_ignore_monsters, pEntity, &tmpTrace );
				if ( tmpTrace.flFraction < 1.0 )
				{
					float thisDistance = (tmpTrace.vecEndPos - vecSrc).Length();
					if ( thisDistance < distance )
					{
						tr = tmpTrace;
						distance = thisDistance;
					}
				}
			}
		}
	}
}


void CSaber::PrimaryAttack()
{
	
	

	switch( (m_iSwing++) % 3 )//lance l'animation primaire
	{
	case 0:
		SendWeaponAnim( SABER_ATTACK1MISS ); break;
	case 1:
		SendWeaponAnim( SABER_ATTACK2MISS ); break;
	case 2:
		SendWeaponAnim( SABER_ATTACK3MISS ); break;
	}
	
	m_flNextPrimaryAttack = gpGlobals->time + 0.5;
	// joue un son de manqu avec pitch variable
	EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_miss1.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

	// joue l'animation d'attaque pour le joueur en question
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );


	SetThink( PriBoum );
	pev->nextthink = gpGlobals->time + 0.5;

	
}

void CSaber::SecondaryAttack()
{

	

	switch( (m_iSwing++) % 3 )//lance l'animation secondaire
	{
	case 0:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;// pour le moment il n'y a qu'une seule animation disponible
	case 1:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;
	case 2:
		SendWeaponAnim( SABER_SECATTACK1HIT ); break;
	}
	
	m_flNextSecondaryAttack = gpGlobals->time + 0.9;
	// joue un son de manqu avec pitch variable
	EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_miss2.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

	// joue l'animation d'attaque pour le joueur en question
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	

	SetThink( SecBoum );
	pev->nextthink = gpGlobals->time + 0.8;
	
		
}

void CSaber::SecBoum()
{

	Boum( 2 );
}

void CSaber::PriBoum()
{

	Boum( 1 );
}

void CSaber::Boum(int AType)
{
	
	
	Humsound();// ncessaire de rapeler pour redmarrer le son car Think a t utilis pour Swing
	
	TraceResult tr;

	UTIL_MakeVectors (m_pPlayer->pev->v_angle);
	Vector vecSrc	= m_pPlayer->GetGunPosition();
	Vector vecEnd	= vecSrc + gpGlobals->v_forward * 80; // 80 est la porte du sabre  partir de la main

	UTIL_TraceLine( vecSrc, vecEnd, dont_ignore_monsters, ENT( m_pPlayer->pev ), &tr );

	if ( tr.flFraction >= 1.0 )
	{
		UTIL_TraceHull( vecSrc, vecEnd, dont_ignore_monsters, head_hull, ENT( m_pPlayer->pev ), &tr );
		if ( tr.flFraction < 1.0 )
		{
			// Calcule le point d'intersection de la ligne (ou boite) avec l'objet qui est frapp
			// Ceci est une approximation de la meilleure intersection
			
			CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
			if ( !pHit || pHit->IsBSPModel() )
				SabFindHullIntersection( vecSrc, tr, VEC_DUCK_HULL_MIN, VEC_DUCK_HULL_MAX, m_pPlayer->edict() );
			vecEnd = tr.vecEndPos;	// Ceci est le point sur la surface actuelle (la boite peut n'avoir touch que le vide)
			
		}
	}

	if ( tr.flFraction >= 1.0 )
	{
	}
	
	else
	{
		// touch
		

		CBaseEntity *pEntity = CBaseEntity::Instance(tr.pHit);

		if ( AType == 1 )// primary attack
		{
	
			ClearMultiDamage( );
			
			pEntity->TraceAttack(m_pPlayer->pev, gSkillData.plrDmgSaber, gpGlobals->v_forward, &tr, DMG_ENERGYBEAM ); 
			
			m_flNextPrimaryAttack = gpGlobals->time + 0.5;

		}


		if ( AType == 2 )// secondary attack (1.5 fois la puissance du coup simple)
		{
		
		
			ClearMultiDamage( );
			
			pEntity->TraceAttack(m_pPlayer->pev, gSkillData.plrDmgSaber * 1.5, gpGlobals->v_forward, &tr, DMG_ENERGYBEAM ); 
				
			m_flNextSecondaryAttack = gpGlobals->time + 0.9;

		}

		
		// joue diffrents son de chocs selon la nature de l'objet
			float flVol = 1.0;
			int fHitWorld = TRUE;
			
			int m_typeson;

			if (pEntity)
			{
				if (pEntity->Classify() != CLASS_NONE && pEntity->Classify() != CLASS_MACHINE)
				{
					
					m_typeson = 0;
					
					m_pPlayer->m_iWeaponVolume = SABER_BODYHIT_VOLUME;
					if (!pEntity->IsAlive() )
					{
					}
			
					else
						flVol = 0.1;

					fHitWorld = FALSE;
					
				}
			}

			// joue un son avec le facteur texture
			

			if (fHitWorld) // choc avec le monde
			{
				fvolbar = TEXTURETYPE_PlaySound(&tr, vecSrc, vecSrc + (vecEnd-vecSrc)*2, BULLET_PLAYER_SABER);

				
				m_typeson = 1;
				
				if ( g_pGameRules->IsMultiplayer() )
				{
					// volume au maximum car il n'y a pas de facteur texture en multijoueurs 
					// et le son serait 0  cause de la fonction au-dessus

					fvolbar = 1;
				}

				
			}

				
				m_trHit = tr;
				vecSparks = tr.vecEndPos;
				
				Smack(m_typeson);
				
				m_pPlayer->m_iWeaponVolume = flVol * SABER_WALLHIT_VOLUME;
		
		
	}
	
}


void CSaber::Smack(int SoundType )
{
	DecalGunshot( &m_trHit, BULLET_PLAYER_SABER );	
	
	ApplyMultiDamage( m_pPlayer->pev, m_pPlayer->pev );

	if (SoundType == 0)
	{
		Etincelles( 0 ); // apelle la fonction qui cre des tincelles au point de contact.

		// joue un son de coup dans un corps
		switch( RANDOM_LONG(0,2) )
		{
		case 0:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod1.wav", 1, ATTN_NORM); break;
		case 1:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod2.wav", 1, ATTN_NORM); break;
		case 2:
			EMIT_SOUND(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/saber_hitbod3.wav", 1, ATTN_NORM); break;
		}
	}

	if (SoundType == 1)
	{
		Etincelles( 1 ); // apelle la fonction qui cre des tincelles au point de contact.

		// joue un son de choc sur un mur selon la texture
		switch( RANDOM_LONG(0,1) )
		{
		case 0:
			//UTIL_EmitAmbientSound(ENT(0), ptr->vecEndPos, "weapons/saber_hit1.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3));
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_ITEM, "weapons/saber_hit1.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3)); 
			break;
		case 1:
			//UTIL_EmitAmbientSound(ENT(0), ptr->vecEndPos, "weapons/saber_hit2.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3));
			EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_ITEM, "weapons/saber_hit2.wav", fvolbar, ATTN_NORM, 0, 98 + RANDOM_LONG(0,3)); 
			break;
		}
	}

		


}










