/***
*
*	Code pour le fusil blaster des stormtroopers
*	Par Jean-Franois Vuagniaux
*	vuagniaux.jf@com.mcnet.ch
*
****/

#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "monsters.h"
#include "weapons.h"
#include "nodes.h"
#include "player.h"
#include "soundent.h"
#include "gamerules.h"
#include "effects.h"
#include "decals.h"


int m_isprite;
int m_ismoke;
float m_strfDamage;
int   m_Inzoom;
int  m_iRTrail;
int m_STRWallSmoke;

enum strf_e
{
	STRF_LONGIDLE = 0,
	STRF_IDLE1,
	STRF_RELOAD,
	STRF_DEPLOY,
	STRF_FIRE1,
	STRF_FIRE2,
	STRF_FIRE3,
};

//========================================================================
// Projectile de blaster pour les armes de la companie BlasTech industries
//========================================================================

class CBlaster : public CBaseEntity
{
public:
	void Spawn( void );

	static void Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity );
	void Touch( CBaseEntity *pOther );
	void EXPORT Animate( void );

	virtual int		Save( CSave &save );
	virtual int		Restore( CRestore &restore );
	static	TYPEDESCRIPTION m_SaveData[];

	int  m_maxFrame;
	int  m_blastballs;
	int  m_blastglow;
	float nextAnim;
	Vector vecNewVelocity;
	BOOL m_refelct;	
	float m_flAttenuation;//facteur de perte d'efficacit avec le temps de vol

};

LINK_ENTITY_TO_CLASS( blaster, CBlaster );

TYPEDESCRIPTION	CBlaster::m_SaveData[] = 
{
	DEFINE_FIELD( CBlaster, m_maxFrame, FIELD_INTEGER ),
};

IMPLEMENT_SAVERESTORE( CBlaster, CBaseEntity );


void CBlaster:: Spawn( void )
{
	pev->movetype = MOVETYPE_FLY;
	pev->classname = MAKE_STRING( "blaster" );
	
	pev->solid = SOLID_BBOX;
	pev->rendermode = kRenderTransAdd;
	pev->renderamt = 255;

	SET_MODEL(ENT(pev), "sprites/blaster.spr");
	pev->frame = 0;
	pev->scale = 0.2;

	UTIL_SetSize( pev, Vector( 0, 0, 0), Vector(0, 0, 0) );
	
	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );

		WRITE_BYTE( TE_BEAMFOLLOW ); // le sillage suit le projectile
		WRITE_SHORT(entindex());	// entit
		WRITE_SHORT(m_iRTrail );	// modle
		WRITE_BYTE( 1 ); // dure
		WRITE_BYTE( 1 );  // largeur
		WRITE_BYTE( 255 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 0 );   // r, g, b
		WRITE_BYTE( 255 );	// luminosit

	MESSAGE_END();  

	m_maxFrame = (float) MODEL_FRAMES( pev->modelindex ) - 1;
	nextAnim = 0;

	m_flAttenuation = 1;
}

void CBlaster::Animate( void )
{

	//ajout de lumire mise par le projectile blaster

	MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY );
			WRITE_BYTE(TE_DLIGHT);
			WRITE_COORD(pev->origin.x);	// X
			WRITE_COORD(pev->origin.y);	// Y
			WRITE_COORD(pev->origin.z);	// Z
			WRITE_BYTE( 15 );		// radius * 0.1
			WRITE_BYTE( 255 );		// r
			WRITE_BYTE( 100 );		// g
			WRITE_BYTE( 100 );		// b
			WRITE_BYTE( 0.2 );		// time * 10   1 doit tre 0.1 seconde
			WRITE_BYTE( 0 );		// decay * 0.1
		MESSAGE_END( );

	//le reste on ne le fait que chaque dixime de seconde

	pev->nextthink = gpGlobals->time;
	
	if ( nextAnim < gpGlobals->time )
	{

		m_flAttenuation -= 0.1;//on diminue de 0.1 chaque 1/10me de seconde

		if (m_flAttenuation < 0.5)//on limite  un minimum
			m_flAttenuation = 0.5;

		nextAnim = gpGlobals->time + 0.1;
		

		int iPitch = RANDOM_FLOAT( 90, 110 );


		if ( pev->frame++ )
		{
			if ( pev->frame > m_maxFrame )
			{
				pev->frame = 0;
			}
		}

		if ( m_refelct )
		{
			pev->velocity = vecNewVelocity;

			m_refelct = 0;
		}


		
		Vector vecVelocity;

		vecVelocity = pev->velocity;

		if ( vecVelocity.Length() < 1000 )
		{
			
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
				Vector centre = pev->origin;

					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( centre.x );	// position
						WRITE_COORD( centre.y );	
						WRITE_COORD( centre.z + 6 );	
						WRITE_SHORT( m_ismoke );		// modle
						WRITE_BYTE( 3 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();

			SetThink ( SUB_Remove );
			pev->nextthink = gpGlobals->time;
		}
	}

}

void CBlaster::Shoot( entvars_t *pevOwner, Vector vecStart, Vector vecVelocity )
{
	CBlaster *pBlast = GetClassPtr( (CBlaster *)NULL );
	pBlast->Spawn();
	
	UTIL_SetOrigin( pBlast->pev, vecStart );
	pBlast->pev->velocity = vecVelocity;
	pBlast->pev->owner = ENT(pevOwner);

	pBlast->SetThink ( Animate );
	pBlast->pev->nextthink = gpGlobals->time + 0.1;
}

void CBlaster :: Touch ( CBaseEntity *pOther )
{
	TraceResult tr;
	int		iPitch;
	m_blastglow = m_isprite;
	m_blastballs = m_isprite;
	Vector vecDirImpact;
	
	Vector vecTrOrigin;


	
	iPitch = RANDOM_FLOAT( 90, 110 );


	entvars_t *pevAttacker = NULL;
	if ( pev->owner )
	{
		pevAttacker = VARS(pev->owner);
	}

	if ( pev->owner == NULL ) // attention si pevAttacker est null on plante 
												   
	{
		pevAttacker = pev;
	}

	if ( pOther->pev->iuser3 == 1000 )//c'est une surface blinde ou un champs de force
	{
		UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

		float fl_vitesse = pev->velocity.Length();
		
		vecNewVelocity = pev->velocity.Normalize();
		

		float n = -DotProduct(tr.vecPlaneNormal, vecNewVelocity);

		vecNewVelocity = ( 2 * tr.vecPlaneNormal * n ) + vecNewVelocity;
		vecNewVelocity.Normalize();
		vecNewVelocity = vecNewVelocity * fl_vitesse * 0.8;
		
		
		UTIL_SetOrigin( pev, (pev->origin) + (tr.vecPlaneNormal * 3) );//on sort le blaster du mur
		pev->velocity = vecNewVelocity;

		m_refelct = 1;

		pev->owner = NULL;//on dfini le propritaire comme NULL pour que le joueur puisse tre touch aprs un ricochet

		EMIT_SOUND_DYN(ENT(pev), CHAN_WEAPON, "weapons/lsaber_ric.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xF));

		return;
	}


	if ( pOther->pev->takedamage && pOther->pev->iuser3 == 100 )//ATST blind rflchit les blasters
	{
		//on va crer un ricochet

		vecNewVelocity = pev->velocity;

		vecNewVelocity = vecNewVelocity.Normalize();
				
		vecTrOrigin = pOther->pev->origin - pev->origin;
		vecTrOrigin = vecTrOrigin.Normalize();
		
			
		vecNewVelocity = vecNewVelocity - vecTrOrigin;

		if ( vecNewVelocity.Length() == 0 )
		{
			ALERT( at_console, "VELOCITY NULLE\n");
			
			vecNewVelocity = -1 * vecTrOrigin;
		}

		vecNewVelocity = vecNewVelocity.Normalize();

		pev->velocity = vecNewVelocity * 1500;

		vecNewVelocity = pev->velocity;


	}

	else//sinon c'est normal
	{
		if ( !pOther->pev->takedamage )
		{
			UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );
			
			//pas d'effet si on touche le ciel

			if ( UTIL_IsTextureSky( &tr, pev->origin, pev->origin + pev->velocity * 10 ) )
			{
				SetThink ( SUB_Remove );
				pev->nextthink = gpGlobals->time;

				return;

			}

			
			//sons d'impacte sur les murs
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc1.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc2.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
		

			// placer un decal sur les murs
			
			UTIL_DecalTrace(&tr, 31);
			
			// incandescence sur les murs
					MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_GLOWSPRITE );
						WRITE_COORD( tr.vecEndPos.x);		// pos
						WRITE_COORD( tr.vecEndPos.y);
						WRITE_COORD( tr.vecEndPos.z);
						WRITE_SHORT( m_blastglow );				// modle
						WRITE_BYTE( 30 );	// dure
						WRITE_BYTE( 2 );					// taille
						WRITE_BYTE( 3000 );			// luminosit
					MESSAGE_END();

				

					// billes incandescentes projetes
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, tr.vecEndPos );
						WRITE_BYTE( TE_SPRITETRAIL );
						WRITE_COORD( tr.vecEndPos.x );
						WRITE_COORD( tr.vecEndPos.y );
						WRITE_COORD( tr.vecEndPos.z );
						WRITE_COORD( tr.vecEndPos.x + tr.vecPlaneNormal.x );
						WRITE_COORD( tr.vecEndPos.y + tr.vecPlaneNormal.y );
						WRITE_COORD( tr.vecEndPos.z + tr.vecPlaneNormal.z );
						WRITE_SHORT( m_blastballs );		// modle
						WRITE_BYTE( 5 );				// nombre
						WRITE_BYTE( 5 );				// dure
						WRITE_BYTE( RANDOM_LONG( 1, 2 ) );				// taille
						WRITE_BYTE( 10 );				// amplitude * 0.1
						WRITE_BYTE( 5 );				// vitesse * 100
					MESSAGE_END();

					Vector vecSmokePos = tr.vecEndPos + ( tr.vecPlaneNormal * 10 );//loigne la sprite lgrement du mur
					
					MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, vecSmokePos );//nuage de fume
						WRITE_BYTE( TE_SPRITE );
						WRITE_COORD( vecSmokePos.x );	// position
						WRITE_COORD( vecSmokePos.y );	
						WRITE_COORD( vecSmokePos.z + 16 );	
						WRITE_SHORT( m_STRWallSmoke );		// modle
						WRITE_BYTE( 10 );				//taille * 10
						WRITE_BYTE( 255 );			//luminosit
					MESSAGE_END();
		
		}
		else
		{

			//sons d'impacte sur les corps
			EMIT_SOUND_DYN( ENT(pev), CHAN_VOICE, "weapons/grill.wav", 1, ATTN_NORM, 0, iPitch );	

			switch ( RANDOM_LONG( 0, 1 ) )
			{
			case 0:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc3.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			case 1:
				EMIT_SOUND_DYN( ENT(pev), CHAN_WEAPON, "weapons/choc4.wav", 1, ATTN_NORM, 0, iPitch );	
				break;
			}
			
			// cration n'un nuage d'impacte pour les entits

				Vector centre = pev->origin;//pOther->Center();

				MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, centre );
					WRITE_BYTE( TE_SPRITE );
					WRITE_COORD( centre.x );	// position
					WRITE_COORD( centre.y );	
					WRITE_COORD( centre.z + 6 );	
					WRITE_SHORT( m_ismoke );		// modle de sprite
					WRITE_BYTE( 3 );				// taille * 10
					WRITE_BYTE( 255 );			// luminosit
				MESSAGE_END();
			
				if ( m_Inzoom )
				{
					m_strfDamage = 3;
				}
				else
				{
					m_strfDamage = 1;
				}

				//pOther->TakeDamage ( pev, pev, gSkillData.blasterDmg * m_strfDamage, DMG_ENERGYBEAM );
				UTIL_TraceLine( pev->origin, pev->origin + pev->velocity * 10, dont_ignore_monsters, ENT( pev ), &tr );

				vecDirImpact = pev->velocity;
				vecDirImpact.Normalize();

				ClearMultiDamage( );

				pOther->TraceAttack( pevAttacker, (gSkillData.blasterDmg * m_strfDamage) * m_flAttenuation, vecDirImpact, &tr, DMG_ENERGYBEAM );

				ApplyMultiDamage( pev, pevAttacker );
		}

		SetThink ( SUB_Remove );
		pev->nextthink = gpGlobals->time;
	}
}

//===================================================================
// Fusil blaster des Stormtroopers de la companie BlasTech industries
//===================================================================

class CSTRF : public CBasePlayerWeapon
{
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( void ) { return 2; }
	int GetItemInfo(ItemInfo *p);
	int AddToPlayer( CBasePlayer *pPlayer );
	void PrimaryAttack( void );
	void SecondaryAttack( void );
	BOOL Deploy( void );
	void Holster( int skiplocal = 0 );
	void Reload( void );
	void WeaponIdle( void );
	Vector GetGunPosition( void );
	float m_flNextAnimTime;
	
};
LINK_ENTITY_TO_CLASS( weapon_strifle, CSTRF );



//=========================================================
//=========================================================

void CSTRF::Spawn( )
{
	pev->classname = MAKE_STRING("weapon_strifle"); 
	Precache( );
	SET_MODEL(ENT(pev), "models/w_strifle.mdl");
	m_iId = WEAPON_STRF;

	m_iDefaultAmmo = STRF_DEFAULT_GIVE;

	pev->iuser3 = 1;

	FallInit();// prt  tomber au sol.
}


void CSTRF::Precache( void )
{
	PRECACHE_MODEL("models/v_strifle.mdl");
	PRECACHE_MODEL("models/w_strifle.mdl");
	PRECACHE_MODEL("models/p_strifle.mdl");

	PRECACHE_MODEL("sprites/blaster.spr");

	PRECACHE_MODEL("models/w_strifleclip.mdl");
	PRECACHE_SOUND("items/strfclip1.wav");              

	PRECACHE_SOUND("items/clipinsert.wav");	// les sons de recharges sont dfinis dans le ficier strifle.qc
	PRECACHE_SOUND("items/cliprelease.wav");	// ils sont lancs lors de l'animation de recharge.

	PRECACHE_SOUND ("weapons/strf1.wav");
	PRECACHE_SOUND ("weapons/strf2.wav");
	
	PRECACHE_SOUND ("weapons/choc1.wav");
	PRECACHE_SOUND ("weapons/choc2.wav");
	PRECACHE_SOUND ("weapons/choc3.wav");
	PRECACHE_SOUND ("weapons/choc4.wav");
	PRECACHE_SOUND ("weapons/grill.wav");

	m_isprite = PRECACHE_MODEL( "sprites/hotglow.spr" );
	m_ismoke = PRECACHE_MODEL( "sprites/blasthit.spr" );
	m_iRTrail = PRECACHE_MODEL( "sprites/zbeam4.spr" );
	PRECACHE_MODEL( "sprites/blaster.spr" );
	m_STRWallSmoke = PRECACHE_MODEL( "sprites/bexplo.spr" );

}

int CSTRF::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "enercel";
	p->iMaxAmmo1 = _ENERCEL_MAX_CARRY;
	p->iMaxClip = STRF_MAX_CLIP;
	p->iSlot = 1;
	p->iPosition = 1;
	p->iFlags = 0;
	p->iId = m_iId = WEAPON_STRF;
	p->iWeight = STRF_WEIGHT;

	return 1;
}

int CSTRF::AddToPlayer( CBasePlayer *pPlayer )
{
	if ( CBasePlayerWeapon::AddToPlayer( pPlayer ) )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
			WRITE_BYTE( m_iId );
		MESSAGE_END();
		return TRUE;
	}
	return FALSE;
}

BOOL CSTRF::Deploy( )
{
	return DefaultDeploy( "models/v_strifle.mdl", "models/p_strifle.mdl", STRF_DEPLOY, "strifle" );
}


Vector CSTRF :: GetGunPosition( )
{
	Vector vecArmPos, vecArmDir;
	GetAttachment( 0, vecArmPos, vecArmDir ); 
	return vecArmPos;
}

void CSTRF::PrimaryAttack()
{
	// ne pas tirer sous l'eau
	if (m_pPlayer->pev->waterlevel == 3)
	{
		PlayEmptySound( );
		m_flNextPrimaryAttack = gpGlobals->time + 0.15;
		return;
	}
	
	// plus de munitions
	if (m_iClip <= 0)
	{
		PlayEmptySound();
		m_flNextPrimaryAttack = gpGlobals->time + 0.15;
		return;
	}

	m_pPlayer->m_iWeaponVolume = NORMAL_GUN_VOLUME;
	m_pPlayer->m_iWeaponFlash = NORMAL_GUN_FLASH;

	m_iClip--;

	m_pPlayer->pev->effects = (int)(m_pPlayer->pev->effects) | EF_MUZZLEFLASH;


	if (1 || m_flNextAnimTime < gpGlobals->time)
	{
		SendWeaponAnim( STRF_FIRE1 + RANDOM_LONG(0,2));
		m_flNextAnimTime = gpGlobals->time + 0.2;
	}

	// animation de tir du joueur
	m_pPlayer->SetAnimation( PLAYER_ATTACK1 );

	switch( RANDOM_LONG(0,1) )
	{
	case 0: EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/strf1.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); break;
	case 1: EMIT_SOUND_DYN(ENT(m_pPlayer->pev), CHAN_WEAPON, "weapons/strf2.wav", 1, ATTN_NORM, 0, 94 + RANDOM_LONG(0,0xf)); break;
	}

	UTIL_MakeVectors( m_pPlayer->pev->v_angle + m_pPlayer->pev->punchangle );

	//modifier pour prendre en compte le dsalignement de la man par rapport  la ligne de vise 
	//car le coup porte trop bas  droite:
	//
	//tracer une ligne avec le vecteur: vector aiming et trouver le point d'impacte
	//corriger le vecteur de tir en consquence.
	
	Vector vecSrc	 = m_pPlayer->GetGunPosition( ) ; //point de vise du HUD
	Vector vecAiming = m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );
	
	TraceResult tr;
	UTIL_TraceLine ( vecSrc, vecSrc + vecAiming * 8192, dont_ignore_monsters, ENT(m_pPlayer->pev), &tr ); //ligne de vise

	vecSrc = vecSrc + gpGlobals->v_forward * 1 + gpGlobals->v_right * 4 + gpGlobals->v_up * -10;//position du canon
	
	vecAiming = tr.vecEndPos - vecSrc;
	
	vecAiming = vecAiming.Normalize();

	// fin de correction
	
	//Vector vecSrc	 = m_pPlayer->GetGunPosition( ) + gpGlobals->v_forward * 1 + gpGlobals->v_right * 4 + gpGlobals->v_up * -10;
	//Vector vecAiming = m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );
	//Vector vecAiming = gpGlobals->v_forward;

	// ajout de la dispersion du tir automatique rapide, si pas de lunette de vise active
	
	if ( ! m_Inzoom )
	{
	
	
	Vector vecRight = gpGlobals->v_right;
	Vector vecUp = gpGlobals->v_up;

	float x, y, z;
	
			x = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			y = RANDOM_FLOAT(-0.5,0.5) + RANDOM_FLOAT(-0.5,0.5);
			z = x*x+y*y;
	
	Vector vecSpread = VECTOR_CONE_3DEGREES ;
	vecAiming = vecAiming + x * vecSpread.x * vecRight + y * vecSpread.y * vecUp ;

	}

	
// code pour tirer un projectile de blaster
	
	CBlaster::Shoot(m_pPlayer->pev,vecSrc,vecAiming * 2000);
	
	UTIL_MakeVectors( m_pPlayer->pev->v_angle );
	
	if (!m_iClip && m_pPlayer->m_rgAmmo[m_iPrimaryAmmoType] <= 0)
		//la combinaison HEV  indique : plus de munitions
		m_pPlayer->SetSuitUpdate("!HEV_AMO0", FALSE, 0);

	m_flNextPrimaryAttack = m_flNextPrimaryAttack + 0.2;
	if (m_flNextPrimaryAttack < gpGlobals->time)
		m_flNextPrimaryAttack = gpGlobals->time + 0.2;

	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 10, 15 );

	m_pPlayer->pev->punchangle.x = RANDOM_FLOAT( -2, 2 );
}

void CSTRF::SecondaryAttack()// activation de la lunette
{
	if (m_Inzoom)
	{
		m_pPlayer->m_iFOV = 0; // 0 signifie que le champs de vision redevient normal
		m_Inzoom = 0;
	}
	else
	{
		m_pPlayer->m_iFOV = 20; // champs de vision rduit  20
		m_Inzoom = 1;
	}
	
	pev->nextthink = gpGlobals->time + 0.1;
	m_flNextSecondaryAttack = gpGlobals->time + 0.5;
}

void CSTRF::Reload( void )
{
	DefaultReload( STRF_MAX_CLIP, STRF_RELOAD, 3.0 );
}

void CSTRF::Holster( int skiplocal )
{
	
	if ( m_Inzoom )
	{
		SecondaryAttack( ); // pour viter de rester avec le champs de vision de 20 
	}

}
void CSTRF::WeaponIdle( void )//animations de repos
{
	ResetEmptySound( );

	m_pPlayer->GetAutoaimVector( AUTOAIM_5DEGREES );

	if ( m_Inzoom )
		return;

	if (m_flTimeWeaponIdle > gpGlobals->time)
		return;

	int iAnim;
	switch ( RANDOM_LONG( 0, 1 ) )
	{
	case 0:	
		iAnim = STRF_LONGIDLE;	
		break;
	
	default:
	case 1:
		iAnim = STRF_IDLE1;
		break;
	}

	SendWeaponAnim( iAnim );

	m_flTimeWeaponIdle = gpGlobals->time + RANDOM_FLOAT ( 5, 15 );// temps d'attente avant la prochaine animation.
}



class CSTRFAmmoClip : public CBasePlayerAmmo // classe de la munitions du blaster
{
	void Spawn( void )
	{ 
		Precache( );
		SET_MODEL(ENT(pev), "models/w_strifleclip.mdl");
		CBasePlayerAmmo::Spawn( );
	}
	void Precache( void )
	{
		PRECACHE_MODEL ("models/w_strifleclip.mdl");
		PRECACHE_SOUND("items/strfclip1.wav");
	}
	BOOL AddAmmo( CBaseEntity *pOther ) 
	{ 
		int bResult = (pOther->GiveAmmo( AMMO_STRFCLIP_GIVE, "enercel", _ENERCEL_MAX_CARRY) != -1);
		if (bResult)
		{
			EMIT_SOUND(ENT(pev), CHAN_ITEM, "items/strfclip1.wav", 1, ATTN_NORM);
		}
		return bResult;
	}
};
LINK_ENTITY_TO_CLASS( ammo_strifleclip, CSTRFAmmoClip );




















